'************************* AX3D.BAS *************************
'  U. S. Geological Survey Computer Program Module AX3D.BAS
'       device-independent routines for graphics system
' $INCLUDE: 'disclaim.inc'
'*************************************************************************
'  $INCLUDE: 'jk2dplt.inc'
'  $INCLUDE: 'jk2dint.inc'
'  $INCLUDE: 'ax2d.inc'
'  $INCLUDE: 'ax2dint.inc'
'  $INCLUDE: 'jk3dplt.inc'
'  $INCLUDE: 'jk3dint.inc'
'  $INCLUDE: 'ax3d.inc'
'  $INCLUDE: 'ax3dint.inc'

'module 3dax ****
'input values made static
'workbox dims, labels, and axis prms
        DIM SHARED x3prm AS AxprmT, y3prm AS AxprmT, z3prm AS AxprmT
END

SUB ax3dprm (which$, oc%, prm AS AxprmT, x(), y(), z())
'subroutine to calculate 3d grafiti parms for drawing axes on the 3d workbox
'initialize axis prm variable
        prm.xpos = 0
        prm.ypos = 0
        prm.side = 1
        prm.nofrst = 0
        prm.nolast = 0
        CALL retvuang(hang, vang, zper)
        hang0 = hang
        vang0 = vang
        IF UCASE$(which$) <> "Z" THEN
          IF vang0 < 0 THEN
            FOR i% = 1 TO 3
              z(i%) = z3prm.axis
            NEXT i%
            prm.side = -1
          END IF
          z(3) = z(3) + 1
          a% = checkax%(prm.axis, min, max, prm)
          IF which$ = "X" THEN
            x3prm.strt = prm.strt
            x3prm.xend = prm.xend
            x3prm.stp = prm.stp
            x3prm.xstep = prm.xstep
            x3prm.cycle = prm.cycle
            x(2) = x3prm.axis
            IF oc% <= 4 THEN
              FOR i% = 1 TO 3
                y(i%) = y3prm.axis
              NEXT i%
              SWAP x(1), x(2)
              SWAP prm.strt, prm.xend
              prm.stp = -prm.stp
              prm.xstep = -prm.xstep
              prm.cycle = -prm.cycle
            END IF
            IF ABS(vang0) > 40 OR fixang(hang) < 25 THEN
              z(3) = z(3) - 1
              prm.side = 1
              IF oc% <= 4 THEN
                y(3) = y(3) - 1
              ELSE
                y(3) = y(3) + 1
              END IF
            END IF
          ELSE
'must be y axis
            y3prm.strt = prm.strt
            y3prm.xend = prm.xend
            y3prm.stp = prm.stp
            y3prm.xstep = prm.xstep
            y3prm.cycle = prm.cycle
            y(2) = y3prm.axis
            IF NOT (3 <= oc% AND oc% <= 6) THEN
              FOR i% = 1 TO 3
                x(i%) = x3prm.axis
              NEXT i%
            ELSE
              SWAP y(2), y(1)
              SWAP prm.strt, prm.xend
              prm.stp = -prm.stp
              prm.xstep = -prm.xstep
              prm.cycle = -prm.cycle
            END IF
            IF fixang(hang0) >= 65 OR ABS(vang0) >= 40 THEN
              z(3) = z(3) - 1
              prm.side = 1
              IF oc% >= 3 AND oc% <= 6 THEN
                x(3) = x(3) + 1
              ELSE
                x(3) = x(3) - 1
              END IF
            END IF
            IF ((oc% - 1) MOD 4) <= 1 THEN
              prm.nolast = -1
            ELSE
              prm.nofrst = -1
            END IF
          END IF
        ELSE
'z axis
          z3prm.strt = prm.strt
          z3prm.xend = prm.xend
          z3prm.stp = prm.stp
          z3prm.xstep = prm.xstep
          z3prm.cycle = prm.cycle
          sd% = 1
          jx% = 1
          IF vang0 <= 0 THEN
            prm.nolast = -1
          ELSE
            prm.nofrst = -1
          END IF
          IF oc% <= 4 THEN
            FOR i% = 1 TO 3
              y(i%) = y3prm.axis
            NEXT i%
            jx% = -jx%
            sd% = -sd%
          END IF
          IF (3 <= oc% AND oc% <= 6) THEN
            FOR i% = 1 TO 3
              x(i%) = x3prm.axis
            NEXT i%
            sd% = -sd%
          END IF
          x(2) = x(1) + jx%
          prm.which = "Y"
          z(3) = z(1) + 1
          prm.side = sd%
          IF fixang(hang0) <= 35 THEN
            x(2) = x(2) - jx%
            y(2) = y(2) + jx% * sd%
          END IF
        END IF
END SUB

SUB axgrf (prm AS AxprmT, oc%, wch1$, wch2$, ht)
        d3% = 3
DIM x(d3%), y(d3%), z(d3%)
'initialize input vars for grafiti call
        FOR i% = 1 TO 3
          x(i%) = 0
          y(i%) = 0
          z(i%) = 0
        NEXT i%
        prm.which = wch1$
        prm.ht = ht
        CALL ax3dprm(wch2$, oc%, prm, x(), y(), z())
        CALL strgrafiti(x(1), y(1), z(1), x(2), y(2), z(2), x(3), y(3), z(3))
        a% = axis1%(prm, prm.ypos)
        CALL endgrafiti
ERASE x, y, z
END SUB

FUNCTION fixang (ang)
'internal function to calculate angles for rev axes
        m = 3.141593 / 180
        fixang = ABS(ATN(TAN(m * ang))) / m
END FUNCTION

SUB nodraw3d (x$, y$, z$)
        x3prm.nodraw = (UCASE$(x$) = "ON")
        y3prm.nodraw = (UCASE$(y$) = "ON")
        z3prm.nodraw = (UCASE$(z$) = "ON")
END SUB

SUB Retaxprm3d (prmx AS AxprmT, prmy AS AxprmT, prmz AS AxprmT)
        prmx = x3prm
        prmy = y3prm
        prmz = z3prm
END SUB

SUB scal3d (ier%)
'set transformation for 3d rel to 3d abs coords
        tmp% = x3prm.nodraw
        x3prm.nodraw = -1
        ht = x3prm.ht
        ier% = axis1%(x3prm, 0)
        x3prm.ht = ht
        x3prm.nodraw = tmp%
        tmp% = y3prm.nodraw
        y3prm.nodraw = -1
        ht = y3prm.ht
        ier% = ier% OR axis1%(y3prm, 0)
        y3prm.ht = ht
        y3prm.nodraw = tmp%
        tmp% = z3prm.nodraw
        z3prm.nodraw = -1
        ht = z3prm.ht
        ier% = ier% OR axis1%(z3prm, 0)
        z3prm.ht = ht
        z3prm.nodraw = tmp%
END SUB

SUB setaxes3d (xt, xs, xp, xe, yt, ys, yp, ye, zt, zs, zp, ze, nodraw3%)
'to annotate three axes of the 3d workbox using grafiti calls
DIM prm AS AxprmT
'set up 3drel to 3dabs transformation
        CALL SetAx1(xt, xs, xp, xe, x3prm)
        CALL SetAx1(yt, ys, yp, ye, y3prm)
        CALL SetAx1(zt, zs, zp, ze, z3prm)
        IF nodraw3% THEN
          x3prm.nodraw = -1
          y3prm.nodraw = -1
          z3prm.nodraw = -1
        END IF
        CALL scal3d(ier%)
'draw axes if specified
        ht = (x3prm.axis + y3prm.axis + z3prm.axis) / 150
        CALL retvuang(hang, vang, zper)
        tmp = hang
        WHILE tmp < 0
          tmp = tmp + 360
        WEND
        WHILE tmp > 360
          tmp = tmp - 360
        WEND
        oc% = INT(tmp / 45) + 1
'x axis
        prm = x3prm
        pht = -ht * (prm.ht <= 0) - prm.ht * (prm.ht >= 0)
        CALL axgrf(prm, oc%, "X", "X", pht)
        x3prm = prm
'y axis
        prm = y3prm
        pht = -ht * (prm.ht <= 0) - prm.ht * (prm.ht >= 0)
        CALL axgrf(prm, oc%, "X", "Y", pht)
        y3prm = prm
'z axis
        prm = z3prm
        pht = -ht * (prm.ht <= 0) - prm.ht * (prm.ht >= 0)
        CALL axgrf(prm, oc%, "X", "Z", pht)
        z3prm = prm
        CALL scal3d(ier%)
END SUB

SUB SetAxht3 (xht, yht, zht)
        IF xht >= 0 THEN x3prm.ht = xht
        IF yht >= 0 THEN y3prm.ht = yht
        IF zht >= 0 THEN z3prm.ht = zht
END SUB

SUB SetAxpg3d (x3l$, x3ax, y3l$, y3ax, z3l$, z3ax)
        CALL ResetAxis(x3prm)
'changes from 2d to define default unit workbox
        x3prm.xpos = 0
        x3prm.ypos = 0
        x3prm.typ = 2
        x3prm.axis = 1
        x3prm.xstep = 1
        y3prm = x3prm
        z3prm = x3prm
'calculate transformations for defaults
        CALL scal3d(ier%)
        x3prm.lab = x3l$
        x3prm.axis = x3ax
        y3prm.lab = y3l$
        y3prm.axis = y3ax
        z3prm.lab = z3l$
        z3prm.axis = z3ax
        CALL setwkbox(x3prm.axis, y3prm.axis, z3prm.axis)
        CALL scl3d2d
END SUB

SUB SetAxprm3d (prmx AS AxprmT, prmy AS AxprmT, prmz AS AxprmT)
        x3prm = prmx
        y3prm = prmy
        z3prm = prmz
END SUB

SUB splot3d (x, y, z, p%)
        CALL plot3d(sclcoord(x3prm, x), sclcoord(y3prm, y), sclcoord(z3prm, z), p%)
END SUB

SUB spoly3d (xary(), yary(), zary(), npts%, inc%, lintyp%, tkiq%, ht)
        DIM x(npts%), y(npts%), z(npts%)
        FOR i% = 0 TO npts%
          x(i%) = sclcoord(x3prm, xary(i%))
          y(i%) = sclcoord(y3prm, yary(i%))
          z(i%) = sclcoord(z3prm, zary(i%))
        NEXT i%
        CALL PolyLine3D(x(), y(), z(), npts%, inc%, lintyp%, tkiq%, ht)
ERASE x, y, z
END SUB

