'************************* DEVALL.BAS *************************
'  U. S. Geological Survey Computer Program Module DEVALL.BAS
'         traffic director module for graphics system
' $INCLUDE: 'disclaim.inc'
'*************************************************************************
'automatic hardware detection
'See QuickBasic Advanced Techniques by Peter Aiken, pp344-352
' $INCLUDE: 'jk2dplt.inc'
' $INCLUDE: 'regs.inc'

DIM SHARED hercerr%

'
'subroutines and functions
'traffic copy device selecter module
DECLARE SUB DevLst (ndev%, lst%(), lst$(), echr%())
DECLARE FUNCTION DevOpen% (devno%)
DECLARE FUNCTION Devclr% (x, y)
DECLARE SUB DevCmt (row%, col%, llen%, TEXT$)
DECLARE FUNCTION DevEnd% ()
DECLARE FUNCTION DevMov% (xo, yo, xn, yn, p%)
DECLARE SUB DevPen (spen%)
DECLARE SUB DevFill (xo, yo, xn, yn, p%)
DECLARE SUB OpenWs (devno%, tkerr%)
DECLARE SUB CloseWs (devno%)
DECLARE SUB SetFnam (devno%, nam$)
DECLARE FUNCTION VideoHardware% ()

'external subroutines and functions for devices
DECLARE SUB InitPsys ()
'sssss *** OMIT THESE LINES FOR NON-SCREEN OUTPUT -START ***
'PC screen
DECLARE FUNCTION PCWsOpen% (devno%)
DECLARE FUNCTION PCWsClose% ()
DECLARE FUNCTION PCDevOpen% (devno%)
DECLARE FUNCTION PCDevclr% ()
DECLARE SUB PCDevCmt (row%, col%, llen%, TEXT$)
DECLARE FUNCTION PCDevEnd% ()
DECLARE FUNCTION PCDevMov% (xo, yo, xn, yn, p%)
DECLARE SUB PCDevPen (spen%)
'sssss *** OMIT THESE LINES FOR NON-SCREEN OUTPUT -END ***
'hhhhh *** OMIT THESE LINES FOR NON-HP PLOTTER OUTPUT -START ***
'HP plotters
DECLARE FUNCTION HPWsOpen% (devno%)
DECLARE FUNCTION HPWsClose% ()
DECLARE FUNCTION HPDevOpen% (devno%)
DECLARE FUNCTION HPDevclr% ()
DECLARE SUB HPDevCmt (row%, col%, llen%, TEXT$)
DECLARE FUNCTION HPDevEnd% ()
DECLARE FUNCTION HPDevMov% (xo, yo, xn, yn, p%)
DECLARE SUB HPDevPen (spen%)
'hhhhh *** OMIT THESE LINES FOR NON-HP PLOTTER OUTPUT -END ***
'eeeee *** OMIT THESE LINES FOR NON-EPSON OUTPUT -START ***
'Epson printers
DECLARE FUNCTION EPWsOpen% (devno%)
DECLARE FUNCTION EPWsClose% ()
DECLARE FUNCTION EPDevOpen% (devno%)
DECLARE FUNCTION EPDevclr% ()
DECLARE SUB EPDevCmt (row%, col%, llen%, TEXT$)
DECLARE FUNCTION EPDevEnd% ()
DECLARE FUNCTION EPDevMov% (xo, yo, xn, yn, p%)
DECLARE SUB EPDevPen (spen%)
'eeeee *** OMIT THESE LINES FOR NON-EPSON OUTPUT -END ***
'lllll *** OMIT THESE LINES FOR NON-LASER OUTPUT -START ***
'HP laser printer (direct or file output)
DECLARE FUNCTION LSWsOpen% (devno%)
DECLARE FUNCTION LSWsClose% ()
DECLARE FUNCTION LSDevOpen% (devno%)
DECLARE FUNCTION LSDevclr% ()
DECLARE SUB LSDevCmt (row%, col%, llen%, TEXT$)
DECLARE FUNCTION LSDevEnd% ()
DECLARE FUNCTION LSDevMov% (xo, yo, xn, yn, p%)
DECLARE SUB LSDevPen (spen%)
DECLARE SUB SetLSfnam (nam$)
'lllll *** OMIT THESE LINES FOR NON-LASER OUTPUT -END ***
'ppppp *** OMIT THESE LINES FOR NON-HP PLOT FILE OUTPUT -START ***
'HP 7550A file output
DECLARE FUNCTION HPFWsOpen% (devno%)
DECLARE FUNCTION HPFWsClose% ()
DECLARE FUNCTION HPFDevOpen% (devno%)
DECLARE FUNCTION HPFDevclr% ()
DECLARE SUB HPFDevCmt (row%, col%, llen%, TEXT$)
DECLARE FUNCTION HPFDevEnd% ()
DECLARE FUNCTION HPFDevMov% (xo, yo, xn, yn, p%)
DECLARE SUB HPFDevPen (spen%)
DECLARE SUB SetHPFnam (nam$)
'ppppp *** OMIT THESE LINES FOR NON-HP PLOT FILE OUTPUT -END ***
'kkkkk *** OMIT THESE LINES FOR NON-JK PLOT FILE OUTPUT -START ***
'JKPLOT intermediate plot file output
DECLARE FUNCTION JKWsOpen% (devno%)
DECLARE FUNCTION JKWsClose% ()
DECLARE FUNCTION JKDevOpen% (devno%)
DECLARE FUNCTION JKDevclr% (x, y)
DECLARE SUB JKDevCmt (row%, col%, llen%, TEXT$)
DECLARE FUNCTION JKDevEnd% ()
DECLARE FUNCTION JKDevMov% (xo, yo, xn, yn, p%)
DECLARE SUB JKDevPen (spen%)
DECLARE SUB SetJKfnam (nam$)
'kkkkk *** OMIT THESE LINES FOR NON-JK PLOT FILE OUTPUT -END ***
scrnname:
DATA "PCCGA Screen","PCEGA Color","PCVGA Color","PCMCGA Color","PCPROF Color"
DATA "PCEGA Mono","PCVGA Mono","PCMCGA Mono", "PCPROF Mono", "PCHERC Mono"


END

Noherc:
  hercerr% = -1
  RESUME NEXT

SUB CloseWs (devno%)
	SELECT CASE devno%
'sssss *** OMIT THESE LINES FOR NON-SCREEN OUTPUT -START ***
	  CASE PCCGA, PCEGA, PCVGA
	    tkerr% = PCWsClose%
'sssss *** OMIT THESE LINES FOR NON-SCREEN OUTPUT -END ***
'hhhhh *** OMIT THESE LINES FOR NON-HP PLOTTER OUTPUT -START ***
	  CASE HPPEN
	    tkerr% = HPWsClose%
'hhhhh *** OMIT THESE LINES FOR NON-HP PLOTTER OUTPUT -END ***
'eeeee *** OMIT THESE LINES FOR NON-EPSON OUTPUT -START ***
	  CASE EPSHR, EPSHW, EPSLR, EPSLW
	    tkerr% = EPWsClose%
'eeeee *** OMIT THESE LINES FOR NON-EPSON OUTPUT -END ***
'lllll *** OMIT THESE LINES FOR NON-LASER OUTPUT -START ***
	  CASE HPLAS, LSFIL
	    tkerr% = LSWsClose%
'lllll *** OMIT THESE LINES FOR NON-LASER OUTPUT -END ***
'ppppp *** OMIT THESE LINES FOR NON-HP PLOT FILE OUTPUT -START ***
	  CASE HPFIL
	    tkerr% = HPFClose%
'ppppp *** OMIT THESE LINES FOR NON-HP PLOT FILE OUTPUT -END ***
'kkkkk *** OMIT THESE LINES FOR NON-JK PLOT FILE OUTPUT -START ***
	  CASE JKFIL
	    tkerr% = JKClose%
'kkkkk *** OMIT THESE LINES FOR NON-JK PLOT FILE OUTPUT -END ***
	  CASE ELSE
	    tkerr% = BADDEVNO
	END SELECT
END SUB

FUNCTION Devclr% (x, y)
	SELECT CASE st.pws
'sssss *** OMIT THESE LINES FOR NON-SCREEN OUTPUT -START ***
	  CASE PCCGA, PCEGA, PCVGA
	    tmperr% = PCDevclr%
'sssss *** OMIT THESE LINES FOR NON-SCREEN OUTPUT -END ***
'hhhhh *** OMIT THESE LINES FOR NON-HP PLOTTER OUTPUT -START ***
	  CASE HPPEN
	    tmperr% = HPDevclr%
'hhhhh *** OMIT THESE LINES FOR NON-HP PLOTTER OUTPUT -END ***
'eeeee *** OMIT THESE LINES FOR NON-EPSON OUTPUT -START ***
	  CASE EPSHR, EPSHW, EPSLR, EPSLW
	    tmperr% = EPDevclr%
'eeeee *** OMIT THESE LINES FOR NON-EPSON OUTPUT -END ***
'lllll *** OMIT THESE LINES FOR NON-LASERR OUTPUT -START ***
	  CASE HPLAS, LSFIL
	    tmperr% = LSDevclr%
'lllll *** OMIT THESE LINES FOR NON-LASER OUTPUT -END ***
'ppppp *** OMIT THESE LINES FOR NON-HP PLOT FILE OUTPUT -START ***
	  CASE HPFIL
	    tmperr% = HPFDevclr%
'ppppp *** OMIT THESE LINES FOR NON-HP PLOT FILE OUTPUT -END ***
'kkkkk *** OMIT THESE LINES FOR NON-JK PLOT FILE OUTPUT -START ***
	  CASE JKFIL
	    tmperr% = JKDevclr%(x, y)
'kkkkk *** OMIT THESE LINES FOR NON-JK PLOT FILE OUTPUT -END ***
	  CASE ELSE
	    tmperr% = BADDEVNO
	END SELECT
	Devclr% = tmperr%
END FUNCTION

SUB DevCmt (row%, col%, llen%, TEXT$)
	  SELECT CASE st.pws
'sssss *** OMIT THESE LINES FOR NON-SCREEN OUTPUT -START ***
	    CASE PCCGA, PCEGA, PCVGA
	      CALL PCDevCmt(row%, col%, llen%, TEXT$)
'sssss *** OMIT THESE LINES FOR NON-SCREEN OUTPUT -END ***
'hhhhh *** OMIT THESE LINES FOR NON-HP PLOTTER OUTPUT -START ***
	    CASE HPPEN
	      CALL HPDevCmt(row%, col%, llen%, TEXT$)
'hhhhh *** OMIT THESE LINES FOR NON-HP PLOTTER OUTPUT -END ***
'eeeee *** OMIT THESE LINES FOR NON-EPSON OUTPUT -START ***
	    CASE EPSHR, EPSHW, EPSLR, EPSLW
	      CALL EPDevCmt(row%, col%, llen%, TEXT$)
'eeeee *** OMIT THESE LINES FOR NON-EPSON OUTPUT -END ***
'lllll *** OMIT THESE LINES FOR NON-LASER OUTPUT -START ***
	    CASE HPLAS, LSFIL
	      CALL LSDevCmt(row%, col%, llen%, TEXT$)
'lllll *** OMIT THESE LINES FOR NON-LASER OUTPUT -END ***
'ppppp *** OMIT THESE LINES FOR NON-HP PLOT FILE OUTPUT -START ***
	    CASE HPFIL
	      CALL HPFDevCmt(row%, col%, llen%, TEXT$)
'ppppp *** OMIT THESE LINES FOR NON-HP PLOT FILE OUTPUT -END ***
'kkkkk *** OMIT THESE LINES FOR NON-JK PLOT FILE OUTPUT -START ***
	    CASE JKFIL
	      CALL JKDevCmt(row%, col%, llen%, TEXT$)
'kkkkk *** OMIT THESE LINES FOR NON-JK PLOT FILE OUTPUT -END ***
	    CASE ELSE
'shouldn't get this error - HA, HA
	  END SELECT
END SUB

FUNCTION DevEnd%
	SELECT CASE st.pws
'sssss *** OMIT THESE LINES FOR NON-SCREEN OUTPUT -START ***
	  CASE PCCGA, PCEGA, PCVGA
	    DevEnd% = PCDevEnd%
'sssss *** OMIT THESE LINES FOR NON-SCREEN OUTPUT -END ***
'hhhhh *** OMIT THESE LINES FOR NON-HP PLOTTER OUTPUT -START ***
	  CASE HPPEN
	    DevEnd% = HPDevEnd%
'hhhhh *** OMIT THESE LINES FOR NON-HP PLOTTER OUTPUT -END ***
'eeeee *** OMIT THESE LINES FOR NON-EPSON OUTPUT -START ***
	  CASE EPSHR, EPSHW, EPSLR, EPSLW
	    DevEnd% = EPDevEnd%
'eeeee *** OMIT THESE LINES FOR NON-EPSON OUTPUT -END ***
'lllll *** OMIT THESE LINES FOR NON-LASER OUTPUT -START ***
	  CASE HPLAS, LSFIL
	    DevEnd% = LSDevEnd%
'lllll *** OMIT THESE LINES FOR NON-LASER OUTPUT -END ***
'ppppp *** OMIT THESE LINES FOR NON-HP PLOT FILE OUTPUT -START ***
	  CASE HPFIL
	    DevEnd% = HPFDevEnd%
'ppppp *** OMIT THESE LINES FOR NON-HP PLOT FILE OUTPUT -END ***
'kkkkk *** OMIT THESE LINES FOR NON-JK PLOT FILE OUTPUT -START ***
	  CASE JKFIL
	    DevEnd% = JKDevEnd%
'kkkkk *** OMIT THESE LINES FOR NON-JK PLOT FILE OUTPUT -END ***
	  CASE ELSE
'shouldn't get this error - HA, HA
	    DevEnd% = -1
	END SELECT
END FUNCTION

SUB DevLst (ndev%, lst%(), lst$(), echr%())
'a subroutine to allow an applications program find out what device
'drivers are loaded
'lst%() is the device numbers
'lst$() is the device names
'echr%() is the emphasized character in the device name
'devices specified are
'   1 =  PC screen
'  11 =  Epson high resolution 8" width
'  12 =  Epson high resolution 13" width
'  13 =  Epson low resolution 8" width
'  14 =  Epson low resolution 13" width
'  15 =  HP plotter
'  16 =  HPGL file
'  17 =  JKPLOT file
'  18 =  HP laser printer direct output
'  19 =  HP laser printer file output
DIM tmplst$(10), tmpch%(10), pclst$(10)
	RESTORE scrnname
	FOR i% = 1 TO 10
	  READ pclst$(i%)
	NEXT i%
	tmplst$(1) = "PC screen"
	tmpch%(1) = 1
	tmplst$(2) = "Epson hires 8"
	tmpch%(2) = 1
	tmplst$(3) = "Epson hires 13"
	tmpch%(3) = 14
	tmplst$(4) = "Epson lowres 8"
	tmpch%(4) = 14
	tmplst$(5) = "Epson lowres 13"
	tmpch%(5) = 7
	tmplst$(6) = "HP plotter"
	tmpch%(6) = 1
	tmplst$(7) = "HPGL plot file"
	tmpch%(7) = 3
	tmplst$(8) = "JK plot file"
	tmpch%(8) = 1
	tmplst$(9) = "HP laser direct"
	tmpch%(9) = 10
	tmplst$(10) = "HP laser file"
	tmpch%(10) = 10
	ndev% = 0
'sssss *** OMIT THESE LINES FOR NON-SCREEN OUTPUT -START ***
	  lst%(0) = VideoHardware%
	  lst$(0) = pclst$(lst%(0))
	  echr%(0) = tmpch%(1)
	ndev% = 1
'sssss *** OMIT THESE LINES FOR NON-SCREEN OUTPUT -END ***
'eeeee *** OMIT THESE LINES FOR NON-EPSON OUTPUT -START ***
	FOR i% = 2 TO 5
	  lst$(ndev%) = tmplst$(i%)
	  lst%(ndev%) = i% + 9
	  echr%(ndev%) = tmpch%(i%)
	  ndev% = ndev% + 1
	NEXT i%
'eeeee *** OMIT THESE LINES FOR NON-EPSON OUTPUT -END ***
'hhhhh *** OMIT THESE LINES FOR NON-HP PLOTTER OUTPUT -START ***
	lst$(ndev%) = tmplst$(6)
	lst%(ndev%) = HPPEN
	echr%(ndev%) = tmpch%(6)
	ndev% = ndev% + 1
'hhhhh *** OMIT THESE LINES FOR NON-HP PLOTTER OUTPUT -END ***
'ppppp *** OMIT THESE LINES FOR NON-HP PLOT FILE OUTPUT -START ***
	lst$(ndev%) = tmplst$(7)
	lst%(ndev%) = HPFIL
	echr%(ndev%) = tmpch%(7)
	ndev% = ndev% + 1
'ppppp *** OMIT THESE LINES FOR NON-HP PLOT FILE OUTPUT -END ***
'lllll *** OMIT THESE LINES FOR NON-LASER OUTPUT -START ***
	lst$(ndev%) = tmplst$(9)
	lst%(ndev%) = HPLAS
	echr%(ndev%) = tmpch%(9)
	ndev% = ndev% + 1
	lst$(ndev%) = tmplst$(10)
	lst%(ndev%) = LSFIL
	echr%(ndev%) = tmpch%(10)
	ndev% = ndev% + 1
'lllll *** OMIT THESE LINES FOR NON-LASER OUTPUT -END ***
'kkkkk *** OMIT THESE LINES FOR NON-JK PLOT FILE OUTPUT -START ***
	lst$(ndev%) = tmplst$(8)
	lst%(ndev%) = JKFIL
	echr%(ndev%) = tmpch%(8)
	ndev% = ndev% + 1
'kkkkk *** OMIT THESE LINES FOR NON-JK PLOT FILE OUTPUT -END ***
END SUB

FUNCTION DevMov% (xo, yo, xn, yn, p%)
	SELECT CASE st.pws
'sssss *** OMIT THESE LINES FOR NON-SCREEN OUTPUT -START ***
	  CASE PCCGA, PCEGA, PCVGA
	    DevMov% = PCDevMov%(xo, yo, xn, yn, p%)
'sssss *** OMIT THESE LINES FOR NON-SCREEN OUTPUT -END ***
'hhhhh *** OMIT THESE LINES FOR NON-HP PLOTTER OUTPUT -START ***
	  CASE HPPEN
	    DevMov% = HPDevMov%(xo, yo, xn, yn, p%)
'hhhhh *** OMIT THESE LINES FOR NON-HP PLOTTER OUTPUT -END ***
'eeeee *** OMIT THESE LINES FOR NON-EPSON OUTPUT -START ***
	  CASE EPSHR, EPSHW, EPSLR, EPSLW
	    DevMov% = EPDevMov%(xo, yo, xn, yn, p%)
'eeeee *** OMIT THESE LINES FOR NON-EPSON OUTPUT -END ***
'lllll *** OMIT THESE LINES FOR NON-LASER OUTPUT -START ***
	  CASE HPLAS, LSFIL
	    DevMov% = LSDevMov%(xo, yo, xn, yn, p%)
'lllll *** OMIT THESE LINES FOR NON-LASER OUTPUT -END ***
'ppppp *** OMIT THESE LINES FOR NON-HP PLOT FILE OUTPUT -START ***
	  CASE HPFIL
	    DevMov% = HPFDevMov%(xo, yo, xn, yn, p%)
'ppppp *** OMIT THESE LINES FOR NON-HP PLOT FILE OUTPUT -END ***
'kkkkk *** OMIT THESE LINES FOR NON-JK PLOT FILE OUTPUT -START ***
	  CASE JKFIL
	    DevMov% = JKDevMov%(xo, yo, xn, yn, p%)
'kkkkk *** OMIT THESE LINES FOR NON-JK PLOT FILE OUTPUT -END ***
	  CASE ELSE
'shouldn't get this error - HA, HA
	    DevMov% = -1
	END SELECT
END FUNCTION

FUNCTION DevOpen% (devno%)
'one time device initialization and comm port open
	IF st.pws <> devno% THEN
	  IF st.pws <> 0 THEN CALL CloseWs(st.pws)
	  CALL OpenWs(devno%, tmperr%)
	END IF
	SELECT CASE devno%
'sssss *** OMIT THESE LINES FOR NON-SCREEN OUTPUT -START ***
	  CASE PCCGA, PCEGA, PCVGA
	    tmperr% = PCDevOpen%(devno%)
'sssss *** OMIT THESE LINES FOR NON-SCREEN OUTPUT -END ***
'hhhhh *** OMIT THESE LINES FOR NON-HP PLOTTER OUTPUT -START ***
	  CASE HPPEN
	    tmperr% = HPDevOpen%(devno%)
'hhhhh *** OMIT THESE LINES FOR NON-HP PLOTTER OUTPUT -END ***
'eeeee *** OMIT THESE LINES FOR NON-EPSON OUTPUT -START ***
	  CASE EPSHR, EPSHW, EPSLR, EPSLW
	    tmperr% = EPDevOpen%(devno%)
'eeeee *** OMIT THESE LINES FOR NON-EPSON OUTPUT -END ***
'lllll *** OMIT THESE LINES FOR NON-LASER OUTPUT -START ***
	  CASE HPLAS, LSFIL
	    tmperr% = LSDevOpen%(devno%)
'lllll *** OMIT THESE LINES FOR NON-LASER OUTPUT -END ***
'ppppp *** OMIT THESE LINES FOR NON-HP PLOT FILE OUTPUT -START ***
	  CASE HPFIL
	    tmperr% = HPFDevOpen%(devno%)
'ppppp *** OMIT THESE LINES FOR NON-HP PLOT FILE OUTPUT -END ***
'kkkkk *** OMIT THESE LINES FOR NON-JK PLOT FILE OUTPUT -START ***
	  CASE JKFIL
	    tmperr% = JKDevOpen%(devno%)
'kkkkk *** OMIT THESE LINES FOR NON-JK PLOT FILE OUTPUT -END ***
	  CASE ELSE
	    tmperr% = -1
	END SELECT
	  IF (NOT tmperr%) THEN
'st.inch can be set to off for scaling tricks
	    st.inch = dev.inch
	  END IF
	pserr% = tmperr%
	DevOpen% = tmperr%
END FUNCTION

SUB DevPen (spen%)
	  SELECT CASE st.pws
'sssss *** OMIT THESE LINES FOR NON-SCREEN OUTPUT -START ***
	    CASE PCCGA, PCEGA, PCVGA
	      CALL PCDevPen(spen%)
'sssss *** OMIT THESE LINES FOR NON-SCREEN OUTPUT -END ***
'hhhhh *** OMIT THESE LINES FOR NON-HP PLOTTER OUTPUT -START ***
	    CASE HPPEN
	      CALL HPDevPen(spen%)
'hhhhh *** OMIT THESE LINES FOR NON-HP PLOTTER OUTPUT -END ***
'eeeee *** OMIT THESE LINES FOR NON-EPSON OUTPUT -START ***
	    CASE EPSHR, EPSHW, EPSLR, EPSLW
	      CALL EPDevPen(spen%)
'eeeee *** OMIT THESE LINES FOR NON-EPSON OUTPUT -END ***
'lllll *** OMIT THESE LINES FOR NON-LASER OUTPUT -START ***
	    CASE HPLAS, LSFIL
	      CALL LSDevPen(spen%)
'lllll *** OMIT THESE LINES FOR NON-LASER OUTPUT -END ***
'ppppp *** OMIT THESE LINES FOR NON-HP PLOT FILE OUTPUT -START ***
	    CASE HPFIL
	      CALL HPFDevPen(spen%)
'ppppp *** OMIT THESE LINES FOR NON-HP PLOT FILE OUTPUT -END ***
'kkkkk *** OMIT THESE LINES FOR NON-JK PLOT FILE OUTPUT -START ***
	    CASE JKFIL
	      CALL JKDevPen(spen%)
'kkkkk *** OMIT THESE LINES FOR NON-JK PLOT FILE OUTPUT -END ***
	    CASE ELSE
'shouldn't get this error - HA, HA
	  END SELECT
END SUB

SUB OpenWs (devno%, tkerr%)
	  CALL InitPsys
	  SELECT CASE devno%
'sssss *** OMIT THESE LINES FOR NON-SCREEN OUTPUT -START ***
	    CASE PCCGA TO PCHERC
	      tkerr% = PCWsOpen%(devno%)
'sssss *** OMIT THESE LINES FOR NON-SCREEN OUTPUT -END ***
'hhhhh *** OMIT THESE LINES FOR NON-HP PLOTTER OUTPUT -START ***
	    CASE HPPEN
	      tkerr% = HPWsOpen%(devno%)
'hhhhh *** OMIT THESE LINES FOR NON-HP PLOTTER OUTPUT -END ***
'eeeee *** OMIT THESE LINES FOR NON-EPSON OUTPUT -START ***
	    CASE EPSHR, EPSHW, EPSLR, EPSLW
	      tkerr% = EPWsOpen%(devno%)
'eeeee *** OMIT THESE LINES FOR NON-EPSON OUTPUT -END ***
'lllll *** OMIT THESE LINES FOR NON-LASER OUTPUT -START ***
	    CASE HPLAS, LSFIL
	      tkerr% = LSWsOpen%(devno%)
'lllll *** OMIT THESE LINES FOR NON-LASER OUTPUT -END ***
'ppppp *** OMIT THESE LINES FOR NON-HP PLOT FILE OUTPUT -START ***
	    CASE HPFIL
		tkerr% = HPFWsOpen%(devno%)
'ppppp *** OMIT THESE LINES FOR NON-HP PLOT FILE OUTPUT -END ***
'kkkkk *** OMIT THESE LINES FOR NON-JK PLOT FILE OUTPUT -START ***
	    CASE JKFIL
	      tkerr% = JKWsOpen%(devno%)
'kkkkk *** OMIT THESE LINES FOR NON-JK PLOT FILE OUTPUT -END ***
	    CASE ELSE
	      tkerr% = BADDEVNO
	  END SELECT
END SUB

SUB SetFnam (devno%, nam$)
	SELECT CASE devno%
'ppppp *** OMIT THESE LINES FOR NON-HP PLOT FILE OUTPUT -START ***
	  CASE HPFIL
	    CALL SetHPFnam(nam$)
'ppppp *** OMIT THESE LINES FOR NON-HP PLOT FILE OUTPUT -END ***
'kkkkk *** OMIT THESE LINES FOR NON-JK PLOT FILE OUTPUT -START ***
	  CASE JKFIL
	    CALL SetJKfnam(nam$)
'kkkkk *** OMIT THESE LINES FOR NON-JK PLOT FILE OUTPUT -END ***
'lllll *** OMIT THESE LINES FOR NON-LASER OUTPUT -START ***
	    CASE LSFIL
	      CALL SetLSfnam(nam$)
'lllll *** OMIT THESE LINES FOR NON-LASER OUTPUT -END ***
	  CASE ELSE
	END SELECT
END SUB

FUNCTION VideoHardware%
'automatic hardware detection.  Function returns one of the following
'constants, depending on the video hardware detected:
'
'plot system device identifier constants
'                   0     non graphics or unknown configuration
'        PCCGA%   = 1     color graphics adapter
'        PCEGA%   = 2     enhanced graphics adapter with color monitor
'        PCVGA%   = 3     video graphics array with color monitor
'        PCMCGA%  = 4     multicolor graphics array with color monitor
'        PCPRF%   = 5     ?prof adapter w color - not implemented
'        PCEGAM%  = 6     enhanced graphics adapter with monochrome monitor
'        PCVGAM%  = 7     video graphics array with monochrome monitor
'        PCMCGAM% = 8     multicolor graphics array with monochrome monitor
'        PCPRFM%  = 9     /prof adapter w mono - not implemented
'        PCHERC%  = 10    Hercules with monochrome monitor

'Set up RegType variables for passing information to and from CALL
'INTERRUPT.  Define constants for the two interrupts.
	DIM InRegs AS RegType, OutRegs AS RegType
	CONST VgaEgaBIOS = &H10, CgaBIOS = &H11
'Load AH with &H1A, AL with 0, and call VGA/EGA BIOS interrupt
	InRegs.ax = &H1A00
	CALL INTERRUPT(VgaEgaBIOS, InRegs, OutRegs)
'The following two lines set AH and BH to 0 while leaving AL and BL
'unchanged.  This ensures that you can test the values in AL and
'BL (where the interrupt returns its results) by looking at AX and BX.
	OutRegs.ax = OutRegs.ax AND &HFF
	OutRegs.bx = OutRegs.bx AND &HFF
'If AL contains &H1A, a VGA/MCGA BIOS was found.  The value in BL tells
'the kind of hardware installed.
	IF OutRegs.ax = &H1A THEN
	  SELECT CASE OutRegs.bx
	    CASE 1
		  hdw% = 0
	    CASE 2
		  hdw% = PCCGA
	    CASE 4
		  hdw% = PCEGA
	    CASE 5
		  hdw% = PCEGAM
	    CASE 7
		  hdw% = PCVGAM
	    CASE 8
		  hdw% = PCVGA
	    CASE &HB
		  hdw% = PCMCGAM
	    CASE &HA, &HC
		  hdw% = PCMCGA
	    CASE ELSE
		  hdw% = PCCGA
	  END SELECT
	ELSE
'Try for EGA if VGA/MCGA wasn't found
	  InRegs.ax = &H1200
	  InRegs.bx = &H10
	  CALL INTERRUPT(VgaEgaBIOS, InRegs, OutRegs)
'if BX has been changed, an EGA BIOS is present and the value in
'BH tells whether a color or monochrome monitor is attached.
	  IF OutRegs.bx <> &H10 THEN
	    OutRegs.bx = OutRegs.bx AND &HFF00
	    IF OutRegs.bx = 0 THEN
	      hdw% = PCEGA
	    ELSE
	      hdw% = PCEGAM
	    END IF
	  ELSE
'If execution reches here, there may be a CGA or MDPA installed.
'Call the CgaBIOS Interrupt, which returns the information in
'bits 4 and 5.
	    CALL INTERRUPT(CgaBIOS, InRegs, OutRegs)
OutRegs.ax = OutRegs.ax AND &H30
	    SELECT CASE OutRegs.ax
	      CASE &H10, &H20
		hdw% = PCCGA
	      CASE ELSE
		hdw% = 0
	    END SELECT
	  END IF
	END IF
'if still unknown, try for Hercules card
	hercerr% = 0
	IF hdw% = 0 THEN
	  ON ERROR GOTO Noherc
	  SCREEN 3
	  SCREEN 0
	END IF
	ON ERROR GOTO 0
	IF hercerr% THEN hdw% = PCHERC
	VideoHardware = hdw%
END FUNCTION

