'************************* DEVMAK.BAS *************************
'  U. S. Geological Survey Computer Program Module DEVMAK.BAS
' program to construct device specific versions of traffic controller
' $INCLUDE: 'disclaim.inc'
'*************************************************************************
'                       Description of program
'In order to prevent loading of unnecessary modules from the plot system
'libraries when linking graphics programs, subroutine and function calls
'that are used only with certain devices can be removed from the code.
'This program can automatically eliminate the unwanted portions of code
'from DEVALL.BAS.  The output files have specically coded names indicating
'which parts of the code have not been removed.
'
'The complete "traffic controller" for sending instructions to specific
'graphic devices is named DEVALL.BAS.  If some devices are not to be used
'much code can be eliminated.  There are six classes of devices considered:
'       1) PC screen  (s)
'       2) HP plotter (h)
'       3) Epson printer (e)
'       4) HP plotter output to a file (p)
'       5) JKPLOT file output (k)
'       6) HP laser printer
'The coded names of the versions output (there can be 63 of them) are
'constructed by appending the letters in parentheses above the the root
'name DV.  For example DVSHEPKL.BAS contains all the code; DVS.BAS contains
'only that code necessary for the PC screen; DVSHE.BAS contains code for
'the PC screen, HP plotter, and Epson printer.
'
'For choosing specific cases to be output the user is required to input
'a sequence of 0's and 1's, separated by commas, indicating whether the
'characteristics are to be omitted (0) or included (1).  For example, to
'construct the program DEVSHE.BAS described above, the user must
'insert 1,1,1,0,0,0<cr> when prompted on the screen.
'*************************************************************************

DECLARE SUB floop (nchk%, fchk%(), flhdr$())
DECLARE SUB comline (n%, a$(), mx%)
DIM xm%(6)
DIM flhdr$(6), chdr%(6), fchk%(6), args$(6)
DIM SHARED skptst%, skp%
        
        flhdr$(1) = "'sssss"
        flhdr$(2) = "'hhhhh"
        flhdr$(3) = "'eeeee"
        flhdr$(4) = "'ppppp"
        flhdr$(5) = "'kkkkk"
        flhdr$(6) = "'lllll"

        CLS
        FOR i% = 1 TO 6
          args$(i%) = ""
        NEXT i%
        CALL comline(nargs%, args$(), 6)
        IF nargs% = 0 THEN
          PRINT
          PRINT "device sequence is "
          PRINT "screen, HP plotter, Epson printer, HP plot file, JK plot file, HP laser"
          PRINT
          INPUT "insert device index sequence: "; xm%(1), xm%(2), xm%(3), xm%(4), xm%(5), xm%(6)
        ELSE
          FOR i% = 1 TO 6
            IF VAL(args$(i%)) = 0 THEN
              xm%(i%) = 0
            ELSE
              xm%(i%) = 1
            END IF
          NEXT i%
        END IF
        odev$ = "DEV"
        nchk% = 0
        FOR i% = 1 TO 6
          IF xm%(i%) = 0 THEN
            nchk% = nchk% + 1
            fchk%(nchk%) = i%
          ELSE
            odev$ = odev$ + UCASE$(MID$(flhdr$(i%), 2, 1))
          END IF
        NEXT i%
        IF nchk% <> 0 THEN
          odev$ = odev$ + ".BAS"
          PRINT "Program DEVMAK running"
          PRINT "Constructing device traffic-controller "; odev$
          OPEN "i", #1, "devall.bas"
          OPEN "o", #2, odev$
          FOR m% = 1 TO 2
            LINE INPUT #1, a$
          NEXT m%
          PRINT #2, "'" + odev$
          CALL floop(nchk%, fchk%(), flhdr$())
          CLOSE #2
          CLOSE #1
        ELSE
          PRINT
          PRINT
          PRINT "YOU HAVE SELECTED A CONTROLLER FOR ALL DEVICES"
          PRINT "YOU CAN JUST USE 'DEVALL.BAS' FOR THE CONTROLLER"
          PRINT
          PRINT "No new controller will be constructed"
        END IF
        SYSTEM
        END

SUB comline (NumArgs%, args$(), MaxArgs%)
'subroutine to get command line and split into arguments.
'parameters:  NumArgs%  : number of command line arguments found
'             Args$()   : array in which to return arguments
'             MaxArgs%  : maximum number of arguments the array
'                         can return
'
        NumArgs% = 0
        In% = 0
'get the command line using the COMMAND$ function.
        c1$ = COMMAND$
        l% = LEN(c1$)
'        IF l% = 0 THEN
'          NumArgs% = 0
'go through the command line a character at a time
'        ELSE
          FOR i% = 1 TO l%
            c$ = MID$(c1$, i%, 1)
'test for character being blank, tab, or comma
            IF (c$ <> " " AND c$ <> CHR$(9) AND c$ <> ",") THEN
'none of the seperators  
'test to see if your already inside an argument    
              IF NOT In% THEN
'you have found the beginning of a new argument
'test for too many arguments
                IF NumArgs% = MaxArgs% THEN EXIT FOR
                NumArgs% = NumArgs% + 1
                In% = -1
              END IF
'add the character to the current argument
              args$(NumArgs%) = args$(NumArgs%) + c$
            ELSE
'found a seperator 
'set "argument" flag to false    
              In% = 0
            END IF
          NEXT i%
END SUB

SUB floop (nchk%, fchk%(), flhdr$())
              skp% = 0
              WHILE NOT EOF(1)
                LINE INPUT #1, a$
                skptst% = 0
                IF nchk% <> 0 THEN
                  FOR m% = 1 TO nchk%
                    IF LEFT$(a$, 6) = flhdr$(fchk%(m%)) THEN
                      skptst% = -1
                    END IF
                  NEXT m%
                END IF
                IF skptst% THEN skp% = NOT skp%
                IF NOT skp% AND NOT skptst% THEN
                  PRINT #2, a$
                END IF
              WEND

END SUB

