'************************* JK2DPLT.BAS *************************
'  U. S. Geological Survey Computer Program Module JK2DPLT.BAS
'       device-independent routines for graphics system
' $INCLUDE: 'disclaim.inc'
'*************************************************************************
' $INCLUDE: 'jk2dplt.inc'
' $INCLUDE: 'jk2dint.inc'
' dim used to make array for error lines static
DIM SHARED errlin$(3), dfltwin AS RectT
DIM SHARED errocc%
t% = 1
DIM SHARED chtst$, ndv, tkcs%(t%), tkcl%(t%), tkx%(t%), tky%(t%), tkip%(t%)
DIM SHARED cchtst$, cndv, tkccs%(t%), tkccl%(t%), tkcx%(t%), tkcy%(t%), tkcip%(t%)

'dims for pipeline segments
DIM wc  AS PipeT
DIM ws AS PipeT
DIM wstran(4, 4), wsmap(4, 4)      'matrices for work station pipe
DIM ccmat(4, 4), ctm2(4, 4)        'store calcomp origin/scale & cur image tran
DIM wctran(4, 4), wcmap(4, 4)      'matrices for world coord pipe
DIM grfmat(4, 4), t3d2d(4, 4)      '3d matrices
DIM aggmat(4, 4)                   'aggregated map
DIM col4st  AS INTEGER, aggtset AS INTEGER
        DEF fnmin (a, b) = -b * (b < a) - a * (a < b) - a * (a = b)
        DEF fnmax (a, b) = -b * (b > a) - a * (a > b) - a * (a = b)
        DEF fncol4 (a, b, c, d) = a <> 0 OR b <> 0 OR c <> 0 OR d <> 1
fonterr:
        errocc% = -1
        RESUME NEXT

FUNCTION AcceptChk% (code1%, code2%)
'trivial acceptance check
        IF ((code1% OR code2%) = 0) THEN
          AcceptChk% = -1
        ELSE
          AcceptChk% = 0
        END IF
END FUNCTION

SUB AcmTrn2 (wch$, mat())
SHARED wstran(), ctm2()
d4% = 4
DIM tmpmat(d4%, d4%)
        SELECT CASE UCASE$(wch$)
          CASE "WS"
            CALL MatMul(mat(), 4, 4, wstran(), 4, 4, tmpmat())
          CASE "CTM", "WC"
            CALL MatMul(mat(), 4, 4, ctm2(), 4, 4, tmpmat())
          CASE ELSE
        END SELECT
        CALL SetTrn2(wch$, tmpmat())
ERASE tmpmat
END SUB

SUB Aggregate
SHARED wc  AS PipeT, ws AS PipeT
SHARED wctran(), wcmap(), ctm2(), ccmat(), wstran(), wsmap(), aggmat(), t3d2d()
SHARED col4st AS INTEGER, aggtset AS INTEGER
        d4% = 4
DIM mat(d4%, d4%), mat1(d4%, d4%)
'        CALL MatMul(t3d2d(), 4, 4, ccmat(), 4, 4, mat())
        CALL MatMul(ccmat(), 4, 4, t3d2d(), 4, 4, mat())
        CALL MatMul(mat(), 4, 4, ctm2(), 4, 4, wctran())
        CALL MatMul(wctran(), 4, 4, wcmap(), 4, 4, mat())
        CALL MatMul(mat(), 4, 4, wstran(), 4, 4, aggmat())
        wc.transet = NOT IsIdent%(4, wctran())
        col4st = fncol4(aggmat(1, 4), aggmat(2, 4), aggmat(3, 4), aggmat(4, 4))
        wc.tran4 = fncol4(wctran(1, 4), wctran(2, 4), wctran(3, 4), wctran(4, 4)) <> 1
        ws.tran4 = fncol4(wstran(1, 4), wstran(2, 4), wstran(3, 4), wstran(4, 4)) <> 1
        wc.map4 = fncol4(wcmap(1, 4), wcmap(2, 4), wcmap(3, 4), wcmap(4, 4)) <> 1
        ws.map4 = fncol4(wsmap(1, 4), wsmap(2, 4), wsmap(3, 4), wsmap(4, 4)) <> 1
        aggtset = NOT IsIdent%(4, aggmat())
ERASE mat
END SUB

SUB CalcMap (p AS PipeT, mat())
        fx = p.win.l
        fy = p.win.b
        tx = p.vp.l - p.win.l
        ty = p.vp.b - p.win.b
        sx = (p.vp.r - p.vp.l) / (p.win.r - p.win.l)
        sy = (p.vp.t - p.vp.b) / (p.win.t - p.win.b)
        CALL Eval2dTran(fx, fy, tx, ty, 0, sx, sy, mat())
END SUB

SUB CalcWsMap
SHARED ws AS PipeT
SHARED wsmap()
DIM scl AS PointT
          IF st.uscl AND st.inch THEN
            scl = st.sclmul
          ELSE
            scl.x = 1
            scl.y = 1
          END IF
          xspan = (ws.vp.r - ws.vp.l) / scl.x
          yspan = (ws.vp.t - ws.vp.b) / scl.y
'if inch-type plotter, recalculate viewport to plot in inches
'if plot is too large for device, scale down and set error
          inchwarn% = 0
          IF st.inch THEN
            tmp = ws.upi.x * (ws.win.r - ws.win.l)
            IF ws.vp.l + tmp * scl.x <= ws.vp.r THEN
              xspan = tmp
            ELSE
              inchwarn% = -1
            END IF
            tmp = ws.upi.y * (ws.win.t - ws.win.b)
            IF ws.vp.b + tmp * scl.y <= ws.vp.t THEN
              yspan = tmp
            ELSE
              inchwarn% = -1
            END IF
          END IF
'inch warning now set if necessary - calculate scales
'calculate scales and offsets without regard to aspect first
          ws.scl.x = xspan / (ws.win.r - ws.win.l)
          ws.scl.y = yspan / (ws.win.t - ws.win.b)
'case-preserve aspect
          IF NOT st.noeqasp THEN
'which window extent determines scale to fit in vp?
            IF (ws.scl.y / (ws.scl.x * ws.asp)) >= 1 THEN
'case x determines scale
              ws.scl.y = ws.scl.x * ws.asp
            ELSE
'case y determines scale
              ws.scl.x = ws.scl.y / ws.asp
            END IF
          END IF
'insert user scaling multipliers
          IF st.uscl THEN
            ws.scl.x = ws.scl.x * st.sclmul.x
            ws.scl.y = ws.scl.y * st.sclmul.y
          END IF
'calculate offsets and center image if necessary
'standard offset calcs
          ws.offset.x = ws.vp.l
          ws.offset.y = ws.vp.b
'case to center image in viewport
          IF st.clpcen THEN
            tmp = ws.scl.x * (ws.win.r - ws.win.l)
            IF tmp < ws.vp.r - ws.vp.l THEN
              ws.offset.x = ws.offset.x + .5 * (ws.vp.r - ws.vp.l - tmp)
            END IF
            tmp = ws.scl.y * (ws.win.t - ws.win.b)
            IF tmp < ws.vp.t - ws.vp.b THEN
              ws.offset.y = ws.offset.y + .5 * (ws.vp.t - ws.vp.b - tmp)
            END IF
          END IF
'calculate work station transformation matrix
        d4% = 4
        DIM lmat(d4%, d4%), rmat(d4%, d4%), tmat(d4%, d4%)
'rotation matrix
        CALL MatIden(4, lmat())
        IF st.picrot THEN
          lmat(1, 1) = 0
          lmat(1, 2) = -1
          lmat(2, 2) = 0
          lmat(2, 1) = 1
          lmat(4, 2) = dev.scr.t + dev.scr.b
        END IF
'y-coordinate inversion
        CALL MatIden(4, rmat())
        IF dev.yinv THEN
          rmat(2, 2) = -1
          rmat(4, 2) = dev.scr.t
        END IF
        CALL MatMul(lmat(), 4, 4, rmat(), 4, 4, tmat())
'offset and scaling for device
        CALL MatIden(4, lmat())
        lmat(1, 1) = ws.scl.x
        lmat(2, 2) = ws.scl.y
        lmat(4, 1) = ws.offset.x
        lmat(4, 2) = ws.offset.y
        CALL MatMul(lmat(), 4, 4, tmat(), 4, 4, rmat())
'translate window corner to origin
        CALL MatIden(4, lmat())
        lmat(4, 1) = -ws.win.l
        lmat(4, 2) = -ws.win.b
        CALL MatMul(lmat(), 4, 4, rmat(), 4, 4, tmat())
        CALL CopyMat(4, 4, tmat(), wsmap())
        ws.map4 = fncol4(wsmap(1, 4), wsmap(2, 4), wsmap(3, 4), wsmap(4, 4))
        ws.mapset = NOT IsIdent%(4, wsmap())
ERASE lmat, rmat, tmat
END SUB

FUNCTION Clip% (clp AS RectT, x1, y1, x2, y2)
'clipping to rectangle specified by clp
'x1,y1,x2,y2 end points of line segment
'returns clipped line segment in same variables
'clip codes for endpoints

'                |      |
'           1001 | 1000 | 1010
'                |      |
'          --------------------
'                |      |
'           0001 | 0000 | 0010
'                |      |
'          --------------------
'                |      |
'           0101 | 0100 | 0110
'                |      |

        bit1% = 1
        bit2% = 2
        bit3% = 4
        bit4% = 8
'loop control variables
        done% = 0
        swaps% = 0
        accpt% = 0

        WHILE (NOT done%)
'get position codes
          code1% = Clipcode%(clp, x1, y1)
          code2% = Clipcode%(clp, x2, y2)
          rejct% = RejectChk%(code1%, code2%)
          IF rejct% THEN
            done% = -1
          ELSE
            accpt% = AcceptChk%(code1%, code2%)
            IF accpt% THEN
              done% = -1
            ELSE
'subdivide because at most 1 pt is inside vp
              IF (NOT code1%) THEN
'make point 1 outside
                swaps% = swaps% + 1
                tmp = x1
                x1 = x2
                x2 = tmp
                tmp = y1
                y1 = y2
                y2 = tmp
                tmp% = code1%
                code1% = code2%
                code2% = tmp%
              END IF
'divide at top
              IF (code1% AND bit4%) THEN
                n# = CDBL((x2 - x1) * (clp.t - y1))
                d# = CDBL(y2 - y1)
                x1 = x1 + CSNG(n# / d#)
                y1 = clp.t
'divide at bottom
              ELSEIF (code1% AND bit3%) THEN
                n# = CDBL((x2 - x1) * (clp.b - y1))
                d# = CDBL(y2 - y1)
                x1 = x1 + CSNG(n# / d#)
                y1 = clp.b
'divide at right
              ELSEIF (code1% AND bit2%) THEN
                n# = CDBL((y2 - y1) * (clp.r - x1))
                d# = CDBL(x2 - x1)
                y1 = y1 + CSNG(n# / d#)
                x1 = clp.r
'divide at left
              ELSEIF (code1% AND bit1%) THEN
                n# = CDBL((y2 - y1) * (clp.l - x1))
                d# = CDBL(x2 - x1)
                y1 = y1 + CSNG(n# / d#)
                x1 = clp.l
              END IF
            END IF
          END IF
        WEND

        IF accpt% THEN
          IF (swaps% AND bit1%) THEN
            tmp = x1
            x1 = x2
            x2 = tmp
            tmp = y1
            y1 = y2
            y2 = tmp
          END IF
          Clip% = -1
        ELSE
          Clip% = 0
        END IF
END FUNCTION

FUNCTION Clipcode% (clp AS RectT, x, y)
'returns clip code for point (obviously)
        code% = 0
        IF (x < clp.l) THEN
          code% = code% + 1
        ELSEIF (x > clp.r) THEN
          code% = code% + 2
        END IF

        IF (y < clp.b) THEN
          code% = code% + 4
        ELSEIF (y > clp.t) THEN
          code% = code% + 8
        END IF

        Clipcode% = code%

END FUNCTION

SUB Comment (row%, col%, llen%, txt$)
'places comment on screen if graphics output is not screen
'input: row%, col%      left end location on 25x80 screen
'       llen%           length in characters to clear
'       txt$            comment
'-------------------------------------------------------------------------
          CALL DevCmt(row%, col%, llen%, txt$)
END SUB

SUB CopyMat (r%, c%, mat1(), mat2())
        FOR i% = 1 TO r%
          FOR j% = 1 TO c%
            mat2(i%, j%) = mat1(i%, j%)
          NEXT j%
        NEXT i%
END SUB

SUB Csymbol (x, y, ht, q%, angle, penup%)
'to draw centered symbol specified by q%
'input: x,y     location of center of symbol in inches
'       ht      symbol size in inches
'       q%      symbol code (0 - 13)
'       angle   rotation from positive x axis direction
'       penup%  -1 = move to location with pen up
'               0  = draw to location from present position
'-------------------------------------------------------------------------
SHARED wc AS PipeT
        z = wc.cp.z
        CALL Csymbol3D(x, y, z, ht, q%, angle, penup%)
END SUB

SUB Csymbol3D (x, y, z, ht, q%, angle, penup%)
'execute only of centered font file has been read
        IF st.cfont >= 0 THEN
'move or draw to initial point
          IF penup% = -1 THEN
            p% = 3
          ELSE
            p% = 2
          END IF
          CALL Plot3D(x, y, z, p%)
'choose symbol and rotation
          idx% = INSTR(chtst$, CHR$(q% + 33)) - 1
          IF idx% <> 0 THEN
            tht = ht / cndv         'scaling to inch square
            IF (angle = 0) THEN
              ss = 0
              cs = 1
            ELSE
              r = .0174533 * angle
              ss = SIN(r)
              cs = COS(r)
            END IF
            xp = x             'to preserve input values
            yp = y
            zp = z
            CALL DrawChr(xp, yp, zp, q%, tht, ss, cs, -1)
          END IF
        END IF
END SUB

SUB DrawChr (x, y, z, ch%, ht, ss, cs, typ%)
'to draw single character (centered or not)
'input  x,y     location in inches
'       ch%     symbol code if centered, ascii code for others
'       ht      symbol size in inches
'       ss,cs   sine and cosine of rotation angle
'x and y at end are returned
'-------------------------------------------------------------------------
        IF typ% = 0 THEN
          idx% = INSTR(chtst$, CHR$(ch%)) - 1
          IF idx% < 0 THEN idx% = 0
'draw the segments making up the symbol
          FOR i% = tkcs%(idx%) TO tkcs%(idx%) + tkcl%(idx%) - 1
            x = x + ht * (tkx%(i%) * cs - tky%(i%) * ss)
            y = y + ht * (tkx%(i%) * ss + tky%(i%) * cs)
            CALL Plot3D(x, y, z, tkip%(i%))
           NEXT i%
        ELSE
          idx% = INSTR(cchtst$, CHR$(ch% + 33)) - 1
          IF idx% < 0 THEN idx% = 0
'draw the segments making up the symbol
          FOR i% = tkccs%(idx%) TO tkccs%(idx%) + tkccl%(idx%) - 1
            x = x + ht * (tkcx%(i%) * cs - tkcy%(i%) * ss)
            y = y + ht * (tkcx%(i%) * ss + tkcy%(i%) * cs)
            CALL Plot3D(x, y, z, tkcip%(i%))
           NEXT i%
        END IF
END SUB

SUB Eval2dTran (fx, fy, tx, ty, rotdeg, sx, sy, mat())
'evaluate transformation matrix for 2d transformation
'point specs are in world coordinates
        d4% = 4
        DIM mat1(d4%, d4%) AS SINGLE
        DIM mat2(d4%, d4%) AS SINGLE
        DIM mat3(d4%, d4%) AS SINGLE
        rotrad = .0174533 * rotdeg
        ss = SIN(rotrad)
        cs = COS(rotrad)
'first translate fixed point to origin
        CALL MatIden(4, mat1())
        mat1(4, 1) = -fx
        mat1(4, 2) = -fy
'then scale
        CALL MatIden(4, mat2())
        mat2(1, 1) = sx
        mat2(2, 2) = sy
        CALL MatMul(mat1(), 4, 4, mat2(), 4, 4, mat3())
'next rotate
        CALL MatIden(4, mat1())
        mat1(1, 1) = cs
        mat1(1, 2) = ss
        mat1(2, 1) = -ss
        mat1(2, 2) = cs
        CALL MatMul(mat3(), 4, 4, mat1(), 4, 4, mat2())
'next translate back to with new translation
        CALL MatIden(4, mat1())
        mat1(4, 1) = fx + tx
        mat1(4, 2) = fy + ty
        CALL MatMul(mat2(), 4, 4, mat1(), 4, 4, mat())
ERASE mat1, mat2, mat3
END SUB

SUB Factor (fact)
'sets multiplier for subsequent moves
SHARED ccmat()
        ccmat(1, 1) = fact
        ccmat(2, 2) = fact
        CALL Aggregate
END SUB

SUB GetDfWin (r AS RectT)
        r = dfltwin
END SUB

SUB getwcprm (p AS PipeT, map(), ctm(), cc(), gr(), t3())
SHARED wc  AS PipeT
SHARED ccmat(), ctm2()
SHARED wcmap(), grfmat(), t3d2d()
        p = wc
        CALL CopyMat(4, 4, wcmap(), map())
        CALL CopyMat(4, 4, ctm2(), ctm())
        CALL CopyMat(4, 4, ccmat(), cc())
        CALL CopyMat(4, 4, grfmat(), gr())
        CALL CopyMat(4, 4, t3d2d(), t3())
END SUB

SUB GetWsPipe (p AS PipeT)
SHARED ws AS PipeT
        p = ws
END SUB

SUB InitChrs
'load character generator table
          CALL newfont(0)
'load centered symbol character generator
          CALL newcfont(0)
END SUB

SUB InitPsys
        IF NOT st.psyson THEN
'not first run through driver
'permanent parms set only on first run through driver
'open com port and one-time device init

'load character generator table
          st.font = -1
          st.cfont = -1
          CALL InitChrs
          st.pws = 0
          st.mode = 0
          st.inch = 0
'set status to on
          st.psyson = -1
        END IF
  st.spen = 0
  st.fno = 0
  st.psyson = -1
  st.uscl = 0
  st.wsuclr = 0
  st.noeqasp = 0
  st.clpcen = 0
  st.picrot = 0
  st.grfon = 0
  st.nopicend = 0
  st.clconly = 0
END SUB

FUNCTION InitWc%
SHARED ws AS PipeT
SHARED wc AS PipeT, wctran(), wcmap(), ctm2(), ccmat(), t3d2d()
'initialize world coordinate plane
d4% = 4
DIM mat(d4%, d4%)
        wc.cp.x = 0
        wc.cp.y = 0
        wc.cp.z = 0
        wc.win = ws.win
        wc.vp = ws.win
        wc.clp = ws.clp
        wc.scl.x = 1
        wc.scl.y = 1
        wc.offset.x = 0
        wc.offset.y = 0
        wc.clpoff = -1
        wc.transet = 0
        wc.tranrot = 0
        wc.mapset = 0
        wc.tran4 = 0
        wc.map4 = 0
        CALL MatIden(4, mat())
        CALL CopyMat(4, 4, mat(), ctm2())       'current 2d trans
        CALL CopyMat(4, 4, mat(), ccmat())      'for calcomp compatibility
        CALL CopyMat(4, 4, mat(), wcmap())      'wc to inch map
        CALL CopyMat(4, 4, mat(), t3d2d())
        CALL Aggregate
ERASE mat
END FUNCTION

FUNCTION InRect% (lr AS RectT, br AS RectT)
InRect% = ((lr.l >= br.l) AND (lr.r <= br.r) AND (lr.b >= br.b) AND (lr.t <= br.t))
END FUNCTION

FUNCTION IsIdent% (d%, mat())
DIM tstmat(d%, d%)
        CALL MatIden(d%, tstmat())
        IsIdent% = MatEqual%(d%, d%, tstmat(), mat())
ERASE tstmat
END FUNCTION

FUNCTION IsRect% (r AS RectT)
        IsRect% = ((r.l < r.r) AND (r.b < r.t))
END FUNCTION

FUNCTION MatEqual% (r%, c%, mat1(), mat2())
        a% = -1
        FOR i% = 1 TO r%
          FOR j% = 1 TO c%
            IF mat1(i%, j%) <> mat2(i%, j%) THEN a% = 0
          NEXT j%
        NEXT i%
        MatEqual% = a%
END FUNCTION

SUB MatIden (d%, mat())
'subroutine to make an identity matrix + a little
        FOR i% = 1 TO d%
          FOR j% = 1 TO d%
              mat(i%, j%) = 0
          NEXT j%
          mat(i%, i%) = 1
        NEXT i%
END SUB

SUB MatMul (lmat(), lr%, lc%, rmat(), rr%, rc%, pmat())
'subroutine to multiply two matrices-must be dimensioned properly elsewhere
'for compatibility, the no of left cols must = no or right rows
        FOR r% = 1 TO lr%
          FOR c% = 1 TO rc%
            pmat(r%, c%) = 0
            FOR k% = 1 TO lc%
              pmat(r%, c%) = pmat(r%, c%) + lmat(r%, k%) * rmat(k%, c%)
            NEXT k%
          NEXT c%
        NEXT r%
END SUB

SUB Mtrn (p(), o(), t(), c4ni%)
        o(1) = p(1) * t(1, 1) + p(2) * t(2, 1) + p(3) * t(3, 1) + t(4, 1)
        o(2) = p(1) * t(1, 2) + p(2) * t(2, 2) + p(3) * t(3, 2) + t(4, 2)
        IF c4ni% THEN
          d = p(1) * t(1, 4) + p(2) * t(2, 4) + p(3) * t(3, 4) + t(4, 4)
          o(1) = o(1) / d
          o(2) = o(2) / d
        END IF
END SUB

SUB newcfont (f%)
        errocc% = 0
        IF f% <> st.cfont THEN
          ON ERROR GOTO fonterr
          tfil$ = "jkcfont." + LTRIM$(RTRIM$(STR$(f%)))
          a$ = ENVIRON$("JKPLT")
          IF a$ <> "" THEN tfil$ = a$ + tfil$
          tmp% = FREEFILE
          OPEN "i", #tmp%, tfil$
          ON ERROR GOTO 0
          IF NOT errocc% THEN
            errocc% = 0
            st.cfont = f%
'use variable dimensions to remove from dgroup
'initially dimension for maximum of fonts supplied 
            tsym% = 14
            tinc% = 92
            REDIM tkccs%(tsym%), tkccl%(tsym%)
            REDIM tkcx%(tinc%), tkcy%(tinc%), tkcip%(tinc%)
            LINE INPUT #tmp%, hdr$
            LINE INPUT #tmp%, cchtst$
            INPUT #tmp%, nsym%, ninc%, cndv
'here allow for case that user altered fonts need more space 
            IF nsym% > tsym% OR ninc% > tinc% THEN
              REDIM tkccs%(nsym%), tkccl%(nsym%)
              REDIM tkcx%(ninc%), tkcy%(ninc%), tkcip%(ninc%)
            END IF
            FOR tki% = 0 TO nsym% - 1
              INPUT #tmp%, n%, tkccs%(tki%), tkccl%(tki%)
              IF CHR$(n% + 33) <> MID$(cchtst$, tki% + 1, 1) THEN
                PRINT "FATAL FONT ERROR"
                STOP
              END IF
              FOR j% = tkccs%(tki%) TO tkccs%(tki%) + tkccl%(tki%) - 1
                INPUT #tmp%, tkcx%(j%), tkcy%(j%), tkcip%(j%)
              NEXT j%
            NEXT tki%
          END IF
          CLOSE #tmp%
        END IF
END SUB

SUB newfont (f%)
'use variable dimensions to remove from dgroup
        errocc% = 0
        IF f% <> st.font THEN
          ON ERROR GOTO fonterr
          tfil$ = "jkfont." + LTRIM$(RTRIM$(STR$(f%)))
          a$ = ENVIRON$("JKPLT")
          IF a$ <> "" THEN tfil$ = a$ + tfil$
          tmp% = FREEFILE
          OPEN "i", #tmp%, tfil$
          ON ERROR GOTO 0
          IF NOT errocc% THEN
            errocc% = 0
            st.font = f%
'use variable dimensions to remove from dgroup
'initially allow for max of supplied fonts
            tsym% = 96
            tinc% = 3360
            REDIM tkcs%(tsym%), tkcl%(tsym%)
            REDIM tkx%(tinc%), tky%(tinc%), tkip%(tinc%)
            LINE INPUT #tmp%, hdr$
            LINE INPUT #tmp%, chtst$
            INPUT #tmp%, nsym%, ninc%, ndv
'here allow for user altered fonts 
            IF nsym% > tsym% OR ninc% > tinc% THEN
              REDIM tkcs%(nsym%), tkcl%(nsym%)
              REDIM tkx%(ninc%), tky%(ninc%), tkip%(ninc%)
            END IF
            FOR tki% = 0 TO nsym% - 1
              INPUT #tmp%, n%, tkcs%(tki%), tkcl%(tki%)
              IF CHR$(n%) <> MID$(chtst$, tki% + 1, 1) THEN
                PRINT "FATAL FONT ERROR"
                STOP
              END IF
              FOR j% = tkcs%(tki%) TO tkcs%(tki%) + tkcl%(tki%) - 1
                INPUT #tmp%, tkx%(j%), tky%(j%), tkip%(j%)
              NEXT j%
            NEXT tki%
          END IF
          CLOSE #tmp%
        END IF
END SUB

SUB Newpen (spen%)
          CALL DevPen(spen%)
END SUB

SUB Number (x, y, ht, fpn, angle, ndec%)
'draws a number
'input  x,y     location of lower left corner in inches from current origin
'       ht      size in inches
'       fpn     number to plot
'       angle   rotation from positive x axis direction
'       ndec%   specifies number of digits to plot
'follows the strange Calcomp form for placing decimal point
'if ndec%  > 0 then it represents the no of decimals right of the dec pt
'if ndec%  = 0 then the integer portion of the number
'              followed by a dec pt is used
'if ndec% = -1 then the integer portion of the number is used
'if ndec% < -1 then -ndec%-1 digits are used after rounding
'-------------------------------------------------------------------------
          IF ht > 0 THEN
'handle negative sign
            IF fpn < 0 THEN
              fp = -fpn
              fpc$ = "-"
            ELSE
              fp = fpn
              fpc$ = ""
            END IF
'find no of digits in integer portion
            IF fp >= 1 THEN
              npdig% = INT(LOG(fp + .5) / LOG(10))
            ELSE
              npdig% = 0
            END IF
'fix decimal pt location
            IF ndec% >= 0 THEN
              cdec% = ndec%
            ELSE
              cdec% = ndec% + 1
            END IF
'do digit calcs
            fp# = fp * (10 ^ cdec%)
            fp& = fp#
            FOR i = npdig% + cdec% TO 0 STEP -1
              pwr = 10 ^ i
              a$ = LTRIM$(RTRIM$(STR$(INT(fp& / pwr))))
              fpc$ = fpc$ + a$
              IF i = cdec% AND ndec% <> -1 THEN fpc$ = fpc$ + "."
              fp& = fp& - VAL(a$) * pwr
            NEXT i
            IF fpc$ = "" OR fpc$ = "-" THEN fpc$ = "0"
'now ready for symbol routine
            CALL Symbol(x, y, ht, fpc$, angle)
          END IF
END SUB

SUB p3d2d (x3, y3, z3, x2, y2)
SHARED wc AS PipeT, wctran(), wcmap(), aggmat()
DIM sp(4), ss(4)
DIM ap AS PipeT
        sp(1) = x3
        sp(2) = y3
        sp(3) = z3
        sp(4) = 1
        ap = wc
        ap.clpoff = -1
        cpret% = PipeStep%(sp(), sp(), ss(), ss(), wc, wctran(), wcmap())
        x2 = ss(1)
        y2 = ss(2)
END SUB

SUB Pipe (sp(), ep(), p%)
'moves pen to new position (either up or down)
'input  x,y,z     new pen position in inches from current origin
'       p%      pen control and origin move control
'               >0      no origin move
'               <0      move origin to new position
'               abs=2   pen down
'               abs=3   pen up
'               =999    end of plot unless overruled by status variable
'-------------------------------------------------------------------------
SHARED ws AS PipeT, wstran(), wsmap()
SHARED wc AS PipeT, wctran(), wcmap(), aggmat()
SHARED col4st AS INTEGER, aggtset AS INTEGER
DIM ss(4), es(4), ps(4), pe(4)
DIM ap AS PipeT
        cpret% = 0
        IF wc.clpoff THEN
          'pipe usine agg
          ap = ws
          ap.transet = aggtset
          ap.tran4 = col4st
          cpret% = PipeStep%(sp(), ep(), ps(), pe(), ap, aggmat(), wsmap())
        ELSE
          'use two pipes w/clipping
          cpret% = PipeStep%(sp(), ep(), ss(), es(), wc, wctran(), wcmap())
          IF cpret% THEN
            cpret% = PipeStep%(ss(), es(), ps(), pe(), ws, wstran(), wsmap())
          END IF
        END IF

'check for end of plot
        IF cpret% OR p% = 999 THEN
          pserr% = DevMov%(ps(1), ps(2), pe(1), pe(2), p%)
        END IF
        IF ((p% = 999) AND NOT st.nopicend) THEN
          BEEP
          pserr% = pserr% OR DevEnd%
          CALL InitPsys
        END IF
END SUB

FUNCTION PipeStep% (sp(), ep(), ns(), ne(), p AS PipeT, t(), m())
DIM col4st  AS INTEGER
DIM ts(4), te(4)
        cpret% = -1
        IF p.transet THEN
          CALL Mtrn(sp(), ns(), t(), p.tran4)
          CALL Mtrn(ep(), ne(), t(), p.tran4)
        ELSE
          FOR i% = 1 TO 4
            ns(i%) = sp(i%)
            ne(i%) = ep(i%)
          NEXT i%
        END IF
        IF NOT p.clpoff THEN
          cpret% = Clip%(p.clp, ns(1), ns(2), ne(1), ne(2))
        END IF
        IF p.mapset AND cpret% THEN
          FOR i% = 1 TO 4
            ts(i%) = ns(i%)
            te(i%) = ne(i%)
          NEXT i%
          CALL Mtrn(ts(), ns(), m(), p.map4)
          CALL Mtrn(te(), ne(), m(), p.map4)
        END IF
        PipeStep% = cpret%
END FUNCTION

SUB Plot (x, y, p%)
SHARED wc AS PipeT
        z = wc.cp.z
        CALL Plot3D(x, y, z, p%)
END SUB

SUB Plot3D (x, y, z, p%)
SHARED wc AS PipeT, wctran(), wcmap(), ctm2(), ccmat()
'moves pen to new position (either up or down)
'input  x,y     new pen position in inches from current origin
'       p%      pen control and origin move control
'               >0      no origin move
'               <0      move origin to new position
'               abs=2   pen down
'               abs=3   pen up
'               =999    end of plot unless overruled by status variable
'               other values default to +3
'-------------------------------------------------------------------------
DIM sp(4), ep(4)
        IF ((ABS(p%) <> 2) AND (ABS(p%) <> 3) AND p% <> 999) THEN
          pp% = 3
        ELSE
          pp% = p%
        END IF
        sp(1) = wc.cp.x
        sp(2) = wc.cp.y
        sp(3) = wc.cp.z
        sp(4) = 1
        wc.cp.x = x
        wc.cp.y = y
        wc.cp.z = z
        ep(1) = wc.cp.x
        ep(2) = wc.cp.y
        ep(3) = wc.cp.z
        ep(4) = 1
        CALL Pipe(sp(), ep(), pp%)
'move origin if necessary
        IF pp% < 0 THEN
          ccmat(4, 1) = ccmat(4, 1) + wc.cp.x
          ccmat(4, 2) = ccmat(4, 2) + wc.cp.y
          ccmat(4, 3) = ccmat(4, 3) + wc.cp.z
          CALL Aggregate
          wc.cp.x = 0
          wc.cp.y = 0
          wc.cp.z = 0
        END IF
END SUB

SUB Plots (xpage, ypage, devno%, tkerr%)
'initialization subroutine
'input  xpage,ypage     plot page size in inches
'       devno%          JKPLOT coded output device numbers
'                       (see include files)
'returns
'       tkerr%          true if error
'-------------------------------------------------------------------------
SHARED ws AS PipeT, wstran(), wsmap()
SHARED wc AS PipeT, wctran(), wcmap(), ctm2(), ccmat()
SHARED grfmat(), t3d2d()
DIM rect AS RectT
'set up workstation plane
'get device parms
        tmperr% = DevOpen%(devno%)
'clear device
'done here so that HP driver can get paper size for calculations
'on second and subsequent complete plots
        IF NOT tmperr% THEN
          IF (NOT st.wsuclr) AND (NOT st.nopicend) THEN
            tmperr% = Devclr%(xpage, ypage)
            IF (NOT tmperr%) THEN st.mode = dev.gmode
          END IF
        END IF
'default workstation plane definition
        tmperr% = NOT SetRect%(0, xpage, 0, ypage, rect)
        dfltwin = rect
        ws.win = rect
        ws.vp = dev.scr
        ws.upi = dev.upi
        ws.asp = dev.asp
'check for rotation
        IF st.picrot THEN 'rotate plot
          CALL rotrect(ws.vp)
          SWAP ws.upi.x, ws.upi.y
          ws.asp = 1 / ws.asp
        END IF
'set up ws map matrix
        a% = SetWsMap%
'initialize ws tran matrix to identity
        CALL MatIden(4, wstran())
        ws.transet = 0
        ws.tranrot = 0
'set clipping options - ws.clp may be changed from this default
        ws.clp = ws.win
        ws.clpoff = 0
'initialize world coordinate plane
        a% = InitWc%
'initialize 3d grafiti mat and 3d2d mat to identity also
        CALL CopyMat(4, 4, wstran(), grfmat())
        CALL CopyMat(4, 4, wstran(), t3d2d())
        CALL Aggregate

'not calc-only
        IF NOT st.clconly THEN
'set pen to no 1 for new seg
          CALL InitChrs
          CALL Newpen(1)
'move pen to lower left window corner
          CALL Plot(ws.win.l, ws.win.b, 3)
        END IF
        pserr% = tmperr%
        tkerr% = tmperr%
END SUB

SUB PolyLine (x(), y(), npts%, inc%, lintyp%, tkiq%, ht)
'line drawing routine
'       x(),y()           sequence of point locations for line
'                                 first point has subscript 1
'       npts%                   no of points
'       inc%                    no of points to skip in defining line
'                                 segment endpoints
'       lintyp%                 specifies line, symbols, or both
'                                 0   = line only, no symbols
'                                 neg = symbols only, no line
'                                 pos = both symbols and line segments
'                                 value specifies no of points to skip
'                                   between symbols
'       tkiq%                   which symbol to use (0 -13)
'       ht                      height of symbols in inches
'---------------------------------------------------------------------------
SHARED wc AS PipeT
DIM z(npts%)
        FOR i% = 0 TO npts%
          z(i%) = wc.cp.z
        NEXT i%
        CALL PolyLine3D(x(), y(), z(), npts%, inc%, lintyp%, tkiq%, ht)
END SUB

SUB PolyLine3D (x(), y(), z(), npts%, inc%, lintyp%, tkiq%, ht)
          IF npts% > 0 THEN
            CALL Plot3D(x(1), y(1), z(1), 3)
            IF inc% <= 0 THEN inc% = 1
            IF lintyp% = 0 THEN
              FOR i% = 1 + inc% TO npts% STEP inc%
              CALL Plot3D(x(i%), y(i%), z(i%), 2)
              NEXT i%
            ELSE
              IF lintyp% > 0 THEN
                penup% = 0
                stp% = lintyp%
              ELSE
                penup% = -1
                stp% = -lintyp%
              END IF

              IF ((tkiq% < 0) OR (tkiq% > 13)) THEN tkiq% = 0
              CALL Csymbol3D(x(1), y(1), z(1), ht, tkiq%, 0, -1)
              tst% = 1
              FOR i% = 1 + inc% TO npts% STEP inc%
                tst% = tst% + 1
                cnt% = (tst% - 1) MOD stp%
                IF cnt% <> 0 THEN
                  IF lintyp% > 0 THEN
                    CALL Plot3D(x(i%), y(i%), z(i%), 2)
                  END IF
                ELSE
                  CALL Csymbol3D(x(i%), y(i%), z(i%), ht, tkiq%, 0, penup%)
                END IF
              NEXT i%
            END IF
            IF lintyp% >= 0 AND i% <> npts% + 1 THEN
              CALL Plot3D(x(npts%), y(npts%), z(npts%), 2)
            END IF
          END IF
END SUB

FUNCTION RejectChk% (code1%, code2%)
'trivial rejection check
        IF (code1% AND code2%) THEN
          RejectChk% = -1
        ELSE
          RejectChk% = 0
        END IF
END FUNCTION

FUNCTION ResetClip% (wch$)
SHARED wc AS PipeT
SHARED ws AS PipeT
        ResetClip% = 0
        SELECT CASE UCASE$(wch$)
          CASE "WS"
            ws.clpoff = -1
          CASE "CTM", "WC"
            wc.clpoff = -1
          CASE ELSE
        END SELECT
END FUNCTION

SUB rotrect (r AS RectT)
        SWAP r.l, r.b
        SWAP r.r, r.t
END SUB

FUNCTION SectRect% (r1 AS RectT, r2 AS RectT, sr AS RectT)
'calculate the intersection of two rectangles
'returns true if rectangles intersect in more than a single point
        sr.l = fnmax(r1.l, r2.l)
        sr.r = fnmin(r1.r, r2.r)
        sr.b = fnmax(r1.b, r2.b)
        sr.t = fnmin(r1.t, r2.t)
        SectRect% = IsRect%(sr)
END FUNCTION

FUNCTION SetClip% (wch$, l, r, b, t)
SHARED wc AS PipeT
SHARED ws AS PipeT
DIM r1 AS RectT
        SetClip% = 0
        a% = SetRect%(l, r, b, t, r1)
        SELECT CASE UCASE$(wch$)
          CASE "WS"
            ws.clp = r1
            ws.clpoff = 0
            SetClip% = -1
          CASE "CTM", "WC"
            wc.clp = r1
            wc.clpoff = 0
            SetClip% = -1
          CASE ELSE
        END SELECT
END FUNCTION

FUNCTION SetRect% (l, r, b, t, rct AS RectT)
        rct.l = l
        rct.r = r
        rct.b = b
        rct.t = t
        SetRect% = IsRect%(rct)
END FUNCTION

SUB SetTrn2 (wch$, mat())
SHARED wstran(), ctm2(), ccmat(), wctran()
SHARED wc AS PipeT
SHARED ws AS PipeT
d4% = 4
DIM tstmat(d4%, d4%)
        CALL MatIden(4, tstmat())
        SELECT CASE UCASE$(wch$)
          CASE "WS"
            CALL CopyMat(4, 4, mat(), wstran())
            ws.transet = NOT IsIdent%(4, wstran())
          CASE "CTM", "WC"
            CALL CopyMat(4, 4, mat(), ctm2())
          CASE ELSE
        END SELECT
        CALL Aggregate
ERASE tstmat
END SUB

SUB setwcprm (p AS PipeT, map(), ctm(), cc(), grf(), t3d())
SHARED wc  AS PipeT
SHARED ccmat(), ctm2()
SHARED wcmap()
SHARED grfmat(), t3d2d()
        wc = p
        CALL CopyMat(4, 4, map(), wcmap())
        CALL CopyMat(4, 4, ctm(), ctm2())
        CALL CopyMat(4, 4, cc(), ccmat())
        CALL CopyMat(4, 4, grf(), grfmat())
        CALL CopyMat(4, 4, t3d(), t3d2d())
        CALL Aggregate
END SUB

FUNCTION SetWcVp% (l!, r!, b!, t!)
SHARED wc AS PipeT, wcmap(), grfmat()
        d4% = 4
DIM mat(d4%, d4%)
DIM rect AS RectT
        a% = SetRect%(l, r, b, t, rect)
        IF a% THEN
          wc.vp = rect
          CALL CalcMap(wc, mat())
          CALL MatMul(mat(), 4, 4, grfmat(), 4, 4, wcmap())
          wc.mapset = NOT IsIdent%(4, mat())
          CALL Aggregate
        END IF
        SetWcVp% = a%
END FUNCTION

FUNCTION SetWcWin% (l!, r!, b!, t!)
SHARED wc AS PipeT, wcmap(), grfmat()
d4% = 4
DIM mat(d4%, d4%)
DIM rect AS RectT
        a% = SetRect%(l, r, b, t, rect)
        IF a% THEN
          wc.win = rect
'for different clip, must set after setting window
          wc.clp = rect
          CALL CalcMap(wc, mat())
          CALL MatMul(mat(), 4, 4, grfmat(), 4, 4, wcmap())
          CALL Aggregate
          wc.mapset = NOT IsIdent%(4, wcmap())
        END IF
        a% = SetClip%("CTM", l, r, b, t)
        SetWcWin% = a%
END FUNCTION

FUNCTION SetWsMap%
SHARED ws AS PipeT
'define mapping between normalized inch coordinates and output surface
'-------------------------------------------------------------------------
DIM Rect1 AS RectT
DIM Rect2 AS RectT

'error checks of work station viewport - skip if initializing new plot
        Rect1 = dev.scr
        IF st.picrot THEN CALL rotrect(Rect1)
        vpok% = SectRect%(ws.vp, Rect1, Rect2)
        IF vpok% THEN
          ws.vp = Rect2
        ELSE
          ws.vp = Rect1
        END IF
       
'error checks of work station window
'default if not specified is 8" by 10"
        okwn% = IsRect%(ws.win)
        IF NOT okwn% THEN a% = SetRect(0, 8, 0, 10, ws.win)
'calculate ws map matrix (inch to dev coord)
        CALL CalcWsMap
        SetWsMap% = NOT vpok% OR NOT okwn%
END FUNCTION

SUB SetWsPipe (p AS PipeT)
SHARED ws AS PipeT
        ws = p
END SUB

FUNCTION SetWsVp% (l, r, b, t)
SHARED ws AS PipeT
DIM rect AS RectT
        a% = SetRect%(l, r, b, t, rect)
        IF a% THEN
          ws.vp = rect
          a% = SetWsMap%
        END IF
        SetWsVp% = a%
END FUNCTION

FUNCTION SetWsWin% (l, r, b, t)
SHARED ws AS PipeT, wsmap()
DIM rect AS RectT
        a% = SetRect%(l, r, b, t, rect)
        IF a% THEN
          ws.win = rect
'for different clip, must set after setting window
          ws.clp = rect
          a% = SetWsMap%
        END IF
        a% = SetClip%("WS", l, r, b, t)
        SetWsWin% = a%
END FUNCTION

SUB Symbol (x, y, ht, txt$, angle)
'to draw text
'input: x,y     location of center of symbol in inches
'       ht      symbol size in inches
'       txt$    text to plot
'       angle   rotation from positive x axis direction
'-------------------------------------------------------------------------
SHARED wc AS PipeT
        z = wc.cp.z
        CALL Symbol3D(x, y, z, ht, txt$, angle)
END SUB

SUB Symbol3D (x, y, z, ht, txt$, angle)
'execute only if font file has been read
        IF st.font >= 0 THEN
'move to starting point
          xp = x
          yp = y
          zp = z
          CALL Plot3D(xp, yp, zp, 3)
'fix character string and set rotation
          txt$ = RTRIM$(txt$)
          nln% = LEN(txt$)
          IF ((nln% > 0) AND (ht > 0)) THEN
            tht = ht / ndv
            IF (angle = 0) THEN
              ss = 0
              cs = 1
            ELSE
              r = .0174533 * angle
              ss = SIN(r)
              cs = COS(r)
            END IF
'draw the characters
            FOR i% = 1 TO nln%
              ch% = ASC(MID$(txt$, i%, 1))
              CALL DrawChr(xp, yp, zp, ch%, tht, ss, cs, 0)
            NEXT i%
          END IF
        END IF
END SUB

