'************************* JK3DPLT.BAS *************************
'  U. S. Geological Survey Computer Program Module JK3DPLT.BAS
'       device-independent routines for graphics system
' $INCLUDE: 'disclaim.inc'
'*************************************************************************
'  $INCLUDE: 'jk2dplt.inc'
'  $INCLUDE: 'jk2dint.inc'
'  $INCLUDE: 'jk3dplt.inc'
'  $INCLUDE: 'jk3dint.inc'
DECLARE SUB getwcprm (p AS PipeT, map!(), ctm!(), cc!(), gr!(), t3!())
DECLARE SUB setwcprm (p AS PipeT, map!(), ctm!(), cc!(), grf!(), t3d!())

DEF fnmin (a, b) = -b * (b < a) - a * (a < b) - a * (a = b)
DEF fnmax (a, b) = -b * (b > a) - a * (a > b) - a * (a = b)
       
DIM wc AS PipeT, map(4, 4), ctm(4, 4), cc(4, 4)
DIM VuPrm AS VuPrmT
DIM trn3d2d(4, 4)
'temporary storage of 2d pipe parameters for grafiti calls
DIM wcgrf AS PipeT, mapgrf(4, 4), ctmgrf(4, 4), ccgrf(4, 4), t3dgrf(4, 4)

SUB autoframe (xpage, ypage, ttl1$, ttl2$)
SHARED wc AS PipeT, map(), ctm(), cc()
        d% = 4
DIM p AS PipeT
DIM ma(d%, d%), ct(d%, d%), c(d%, d%), grf(d%, d%), t3(d%, d%)
DIM tmpid(d%, d%)
        CALL getwcprm(p, ma(), ct(), c(), grf(), t3())
        CALL MatIden(4, tmpid())
        CALL setwcprm(wc, map(), ct(), c(), tmpid(), tmpid())
        CALL retvuang(hang, vang, zper)
        CALL plate3d(xpage, ypage, hang, vang, ttl1$, ttl2$)
        CALL setwcprm(p, ma(), ct(), c(), grf(), t3())
        x9 = xpage / 9
        y9 = SQR(xpage * ypage / 81)
        CALL setvp3d(x9, xpage - x9, 2 * y9, ypage - y9)
ERASE ma, ct, c, grf
ERASE tmpid
      
END SUB

SUB Bgn3d
SHARED trn3d2d()
SHARED wc AS PipeT, map(), ctm(), cc()
SHARED VuPrm AS VuPrmT
DIM p AS PipeT
DIM r AS RectT
        CALL GetDfWin(r)
        VuPrm.vp = r
        CALL setpt3(1, 1, 1, VuPrm.box)
        CALL setpt3(0, 0, 0, VuPrm.vrp)
        CALL setpt3(5, -10, 5, VuPrm.cop)
        CALL setpt3(-5, 10, -5, VuPrm.vpn)
        CALL setpt3(-5, 10, 5, VuPrm.vup)
        VuPrm.uvset = 0
        VuPrm.cpn.x = 0
        VuPrm.cpn.y = 0
'3d absolute scaling
        CALL scl3d2d
'save 2d wc pipe step and reset to identities
        d% = 4
DIM tmpid(d%, d%), g(d%, d%)
        CALL getwcprm(wc, map(), ctm(), cc(), g(), tmpid())
        p.win = r
        p.vp = r
        p.clp = r
        p.transet = -1
        p.tranrot = 0
        p.clpoff = -1
        p.mapset = 0
        p.cp.x = 0
        p.cp.y = 0
        p.cp.z = 0
        CALL MatIden(4, tmpid())
'old way preserves wc ctm & cc - trying new way that resets all wc
'but will leave ws trans in effect through 3d portion - which better ???
'        CALL setwcprm(p, tmpid(), ctm(), cc(), tmpid(), trn3d2d())
        CALL setwcprm(p, tmpid(), tmpid(), tmpid(), tmpid(), trn3d2d())
ERASE tmpid
END SUB

SUB drawbox (xl, xu, yl, yu, zl, zu)
        d% = 2
DIM b(d%, d%, d%) AS Pt3T
        CALL SetBox(xl, xu, yl, yu, zl, zu, b())
'move to workbox corner
        CALL pltbox(b())
ERASE b
END SUB

SUB drawuvwin
SHARED VuPrm AS VuPrmT
        CALL Plot(VuPrm.puv.l, VuPrm.puv.b, 3)
        CALL Plot(VuPrm.puv.r, VuPrm.puv.b, 2)
        CALL Plot(VuPrm.puv.r, VuPrm.puv.t, 2)
        CALL Plot(VuPrm.puv.l, VuPrm.puv.t, 2)
        CALL Plot(VuPrm.puv.l, VuPrm.puv.b, 2)
        CALL Plot(VuPrm.puv.r, VuPrm.puv.t, 2)
        CALL Plot(VuPrm.puv.l, VuPrm.puv.t, 3)
        CALL Plot(VuPrm.puv.r, VuPrm.puv.b, 2)
END SUB

SUB drawwkbox
SHARED VuPrm AS VuPrmT
        d% = 2
DIM b(d%, d%, d%) AS Pt3T
        CALL SetBox(0, VuPrm.box.x, 0, VuPrm.box.y, 0, VuPrm.box.z, b())
'move to workbox corner
        CALL pltbox(b())
ERASE b
END SUB

SUB end3d
SHARED wc AS PipeT, map(), ctm(), cc()
d4% = 4
DIM tmpid(d4%, d4%)
        CALL MatIden(4, tmpid())
        CALL setwcprm(wc, map(), ctm(), cc(), tmpid(), tmpid())
ERASE tmpid
END SUB

SUB endgrafiti
SHARED wcgrf AS PipeT, mapgrf(), ctmgrf(), ccgrf(), t3dgrf()
d4% = 4
DIM tmpid(d4%, d4%)
        CALL MatIden(4, tmpid())
        CALL setwcprm(wcgrf, mapgrf(), ctmgrf(), ccgrf(), tmpid(), t3dgrf())
'        MID$(tkst$, 11, 1) = "0"
ERASE tmpid
END SUB

SUB GetAbs2uv (vvmat())
        d% = 4
DIM vmat1(d%, d%), mmat1(d%, d%), mmat2(d%, d%), mmat3(d%, d%)
        CALL GetTper(vmat1())
        CALL GetRmat(mmat2())
        CALL MatMul(vmat1(), 4, 4, mmat2(), 4, 4, mmat3())
        CALL GetTrl(mmat1())
        CALL MatMul(mmat3(), 4, 4, mmat1(), 4, 4, vvmat())
ERASE vmat1, mmat1, mmat2, mmat3
END SUB

SUB GetMmat (a AS Pt3T, mat())
        CALL MatIden(4, mat())
        zmin = (a.z + a.x) / (a.z + a.y)
        IF zmin = 1 THEN zmin = 0
        mat(3, 3) = 1 / (1 - zmin)
        mat(3, 4) = 1
        mat(4, 3) = -zmin / (1 - zmin)
        mat(4, 4) = 0
END SUB

SUB GetRmat (rmat())
SHARED VuPrm AS VuPrmT
DIM rsubx AS Pt3T, rsuby AS Pt3T, rsubz AS Pt3T
DIM tmp3 AS Pt3T
        CALL MatIden(4, rmat())
'calculate rotation matrix using Foley & VanDam, pg.261
        CALL vecunit(VuPrm.vpn, tmp3)
        CALL vecneg(tmp3, rsubz)
        CALL vecuprd(tmp3, VuPrm.vup, rsubx)
        CALL vecprod(rsubz, rsubx, rsuby)
        rmat(1, 1) = rsubx.x
        rmat(2, 1) = rsubx.y
        rmat(3, 1) = rsubx.z
        rmat(1, 2) = rsuby.x
        rmat(2, 2) = rsuby.y
        rmat(3, 2) = rsuby.z
        rmat(1, 3) = rsubz.x
        rmat(2, 3) = rsubz.y
        rmat(3, 3) = rsubz.z
END SUB

SUB GetShmat (vrpp AS Pt3T, uvwin AS RectT, shmat())
        CALL MatIden(4, shmat())
        shmat(3, 1) = -(vrpp.x + .5 * (uvwin.l + uvwin.r)) / vrpp.z
        shmat(3, 2) = -(vrpp.y + .5 * (uvwin.b + uvwin.t)) / vrpp.z
END SUB

SUB GetSmat (sx, sy, sz, smat())
        CALL MatIden(4, smat())
        smat(1, 1) = sx
        smat(2, 2) = sy
        smat(3, 3) = sz
END SUB

SUB GetSper (vrpp AS Pt3T, uvwin AS RectT, cpn AS Pt3T, spmat())
SHARED VuPrm AS VuPrmT
        sx = 2 * vrpp.z / ((uvwin.r - uvwin.l) * (vrpp.z + cpn.y))
        sy = 2 * vrpp.z / ((uvwin.t - uvwin.b) * (vrpp.z + cpn.y))
IF NOT VuPrm.uvset THEN
        tmp = fnmin(sx, sy)
        sx = tmp
        sy = tmp
END IF
        sz = 1 / (vrpp.z + cpn.y)
        CALL GetSmat(sx, sy, sz, spmat())
END SUB

SUB GetTmat (dx, dy, dz, tmat())
        CALL MatIden(4, tmat())
        tmat(4, 1) = dx
        tmat(4, 2) = dy
        tmat(4, 3) = dz
END SUB

SUB GetTper (tmat())
SHARED VuPrm AS VuPrmT
DIM v1 AS Pt3T, v2 AS Pt3T
        CALL vecsum(VuPrm.vrp, VuPrm.cop, v1)
        CALL vecneg(v1, v2)
        CALL GetTmat(v2.x, v2.y, v2.z, tmat())
END SUB

SUB GetTrl (rlmat())
        CALL MatIden(4, rlmat())
        rlmat(3, 3) = -1
END SUB

SUB Getuvmat (uvmat())
SHARED VuPrm AS VuPrmT
d2% = 2
d3% = 3
d4% = 4
DIM mat1(d4%, d4%), mat2(d4%, d4%), mat3(d4%, d4%)
DIM boxcrn(d2%, d2%, d2%) AS Pt3T
DIM b%(d4%, d3%)
DIM uvwin AS RectT
DIM vrpp AS Pt3T, opt AS Pt3T
        CALL GetAbs2uv(uvmat())
        CALL ptrn3(VuPrm.vrp, uvmat(), vrpp)
        VuPrm.cpn.z = vrpp.z
        CALL SetBox(0, VuPrm.box.x, 0, VuPrm.box.y, 0, VuPrm.box.z, boxcrn())
        IF NOT VuPrm.uvset THEN
          CALL locbox(boxcrn(), uvmat(), vrpp.z, uvwin, b%())
        ELSE
          uvwin = VuPrm.win
        END IF
        CALL GetShmat(vrpp, uvwin, mat1())
DIM zzzmat(d4%, d4%)
CALL CopyMat(4, 4, mat1(), zzzmat())
        CALL GetSper(vrpp, uvwin, VuPrm.cpn, mat2())
CALL CopyMat(4, 4, mat2(), zzzmat())
        CALL MatMul(mat1(), 4, 4, mat2(), 4, 4, mat3())
        CALL GetMmat(VuPrm.cpn, mat1())
CALL CopyMat(4, 4, mat1(), zzzmat())
        CALL MatMul(mat3(), 4, 4, mat1(), 4, 4, mat2())
CALL CopyMat(4, 4, mat2(), zzzmat())
CALL CopyMat(4, 4, uvmat(), mat1())
        CALL MatMul(mat1(), 4, 4, mat2(), 4, 4, uvmat())
uvmat(1, 3) = 0
uvmat(2, 3) = 0
uvmat(3, 3) = 0
uvmat(4, 3) = 0
'find the unscaled/uncentered xy window
        uvwin.l = -1
        uvwin.r = 1
        uvwin.b = -1
        uvwin.t = 1
        IF NOT VuPrm.uvset THEN
          CALL ptrn3(boxcrn(b%(1, 1), b%(1, 2), b%(1, 3)), uvmat(), opt)
          VuPrm.win.l = opt.x
          CALL ptrn3(boxcrn(b%(2, 1), b%(2, 2), b%(2, 3)), uvmat(), opt)
          VuPrm.win.r = opt.x
          CALL ptrn3(boxcrn(b%(3, 1), b%(3, 2), b%(3, 3)), uvmat(), opt)
          VuPrm.win.b = opt.y
          CALL ptrn3(boxcrn(b%(4, 1), b%(4, 2), b%(4, 3)), uvmat(), opt)
          VuPrm.win.t = opt.y
        END IF
VuPrm.uv = uvwin
VuPrm.puv = uvwin
ERASE mat1, mat2, mat3
ERASE boxcrn
ERASE b%
END SUB

SUB hmatmul (d%, lmat(), tmat(), rmat())
        CALL MatMul(lmat(), 1, d%, tmat(), d%, d%, rmat())
        IF rmat(1, d%) <> 0 THEN
          FOR i% = 1 TO d% - 1
            rmat(1, i%) = rmat(1, i%) / rmat(1, d%)
          NEXT i%
        END IF
END SUB

SUB locbox (boxcrn() AS Pt3T, uvmat(), p, w AS RectT, ibox%())
SHARED VuPrm AS VuPrmT
DIM opt AS Pt3T
        w.l = 1E+20
        w.r = -1E+20
        w.b = 1E+20
        w.t = -1E+20
        FOR i% = 1 TO 2
          FOR j% = 1 TO 2
            FOR k% = 1 TO 2
              CALL ptrn3(boxcrn(i%, j%, k%), uvmat(), opt)
              VuPrm.cpn.y = fnmax(VuPrm.cpn.y, opt.z)
              VuPrm.cpn.x = fnmin(VuPrm.cpn.x, opt.z)
              tmp = p / opt.z
              IF opt.z <> 0 THEN
                opt.x = opt.x * tmp
                opt.y = opt.y * tmp
              END IF
              IF opt.x < w.l THEN
                w.l = opt.x
                ibox%(1, 1) = i%
                ibox%(1, 2) = j%
                ibox%(1, 3) = k%
              END IF
              IF opt.x > w.r THEN
                w.r = opt.x
                ibox%(2, 1) = i%
                ibox%(2, 2) = j%
                ibox%(2, 3) = k%
              END IF
              IF opt.y < w.b THEN
                w.b = opt.y
                ibox%(3, 1) = i%
                ibox%(3, 2) = j%
                ibox%(3, 3) = k%
              END IF
              IF opt.y > w.t THEN
                w.t = opt.y
                ibox%(4, 1) = i%
                ibox%(4, 2) = j%
                ibox%(4, 3) = k%
              END IF
            NEXT k%
          NEXT j%
        NEXT i%

END SUB

SUB matPt3 (mat(), p AS Pt3T)
        p.x = mat(1, 1)
        p.y = mat(1, 2)
        p.z = mat(1, 3)
END SUB

SUB plate3d (xpage, ypage, hang, vang, ttl1$, ttl2$)
        CALL Plot(0, 0, 3)
        CALL Plot(xpage, 0, 2)
        CALL Plot(xpage, ypage, 2)
        CALL Plot(0, ypage, 2)
        CALL Plot(0, 0, 2)
        x9 = xpage / 9
        y9 = SQR(xpage * ypage / 81)
        CALL Plot(0, y9, 3)
        CALL Plot(xpage, y9, 2)
        CALL Plot(3 * x9, y9, 3)
        CALL Plot(3 * x9, 0, 2)
        CALL Plot(6 * x9, 0, 3)
        CALL Plot(6 * x9, y9, 2)
        ht = y9 / 8
        CALL Symbol(2 * x9, 5 * ht, ht, "HORIZ", 0)
        CALL Number(2 * x9, 2 * ht, ht, hang, 0, -1)
        CALL Symbol(5 * x9, 5 * ht, ht, "VERT", 0)
        CALL Number(5 * x9, 2 * ht, ht, vang, 0, -1)
        CALL Symbol(6.5 * x9, 5 * ht, ht, ttl1$, 0)
        CALL Symbol(6.5 * x9, 2 * ht, ht, ttl2$, 0)
        CALL Plot(x9, .2 * y9, 3)
        CALL Plot(x9, .8 * y9, 2)
        CALL Plot(.7 * x9, .5 * y9, 3)
        CALL Plot(1.3 * x9, .5 * y9, 2)
        CALL Plot(4 * x9, .2 * y9, 3)
        CALL Plot(4 * x9, .8 * y9, 2)
        CALL Plot(3.7 * x9, .5 * y9, 3)
        CALL Plot(4.3 * x9, .5 * y9, 2)
      
        IF x9 < y9 THEN rds = .5 * x9 ELSE rds = .5 * y9
        ht = .25 * rds
        rang = hang * 3.14157 / 180
        x1 = x9 + rds * COS(rang)
        y1 = .5 * y9 + rds * SIN(rang)
        x2 = x9
        y2 = .5 * y9
        CALL vudir(x1, y1, x2, y2, ht)
        rang = vang * 3.14157 / 180
        x1 = 4 * x9 + rds * COS(rang)
        y1 = .5 * y9 + rds * SIN(rang)
        x2 = 4 * x9
        y2 = .5 * y9
        CALL vudir(x1, y1, x2, y2, ht)
END SUB

SUB plot3dpt (t AS Pt3T, p%)
        CALL plot3d(t.x, t.y, t.z, p%)
END SUB

SUB pltbox (b() AS Pt3T)
        CALL plot3dpt(b(1, 1, 1), 3)
        CALL plot3dpt(b(1, 1, 2), 2)
        CALL plot3dpt(b(2, 1, 2), 2)
        CALL plot3dpt(b(2, 1, 1), 2)
        CALL plot3dpt(b(1, 1, 1), 2)
        CALL plot3dpt(b(1, 2, 1), 2)
        CALL plot3dpt(b(1, 2, 2), 2)
        CALL plot3dpt(b(2, 2, 2), 2)
        CALL plot3dpt(b(2, 2, 1), 2)
        CALL plot3dpt(b(1, 2, 1), 2)
        CALL plot3dpt(b(1, 2, 2), 3)
        CALL plot3dpt(b(1, 1, 2), 2)
        CALL plot3dpt(b(2, 1, 2), 3)
        CALL plot3dpt(b(2, 2, 2), 2)
        CALL plot3dpt(b(2, 2, 1), 3)
        CALL plot3dpt(b(2, 1, 1), 2)
END SUB

SUB Pt3mat (p AS Pt3T, mat())
        mat(1, 1) = p.x
        mat(1, 2) = p.y
        mat(1, 3) = p.z
        mat(1, 4) = 1
END SUB

SUB ptrn3 (ipt AS Pt3T, tmat(), opt AS Pt3T)
'matrix multiplication for 3d homogeneous coordinate transformation
d1% = 1
d4% = 4
DIM lmat(d1%, d4%), pmat(d1%, d4%)
        CALL Pt3mat(ipt, lmat())
        CALL hmatmul(4, lmat(), tmat(), pmat())
        CALL matPt3(pmat(), opt)
ERASE lmat, pmat
END SUB

SUB resetuvwin
SHARED VuPrm AS VuPrmT
        VuPrm.uvset = 0
END SUB

SUB Ret3dtrn (mat())
SHARED trn3d2d()
        CALL CopyMat(4, 4, trn3d2d(), mat())
END SUB

SUB retvuang (hang, vang, zper)
SHARED VuPrm AS VuPrmT
        DEGRAD# = .0174532925#
        d% = 2
DIM p AS Pt3T, q AS Pt3T
        CALL vecneg(VuPrm.vrp, p)
        CALL vecsum(VuPrm.cop, p, q)
        IF q.x = 0 THEN
          IF q.y >= 0 THEN
            hang = 90
          ELSE
            hang = -90
          END IF
        END IF
        IF q.x <> 0 THEN
          hang = ATN(q.y / q.x) / DEGRAD#
          IF q.x < 0 THEN
            hang = hang + 180
            IF hang > 180 THEN
              hang = hang - 360
            END IF
          END IF
        END IF
        IF q.x <> 0 OR q.y <> 0 THEN
          vang = ATN(q.z / SQR(q.x * q.x + q.y * q.y)) / DEGRAD#
        ELSE
          vang = 0
        END IF
        zper = SQR(q.x * q.x + q.y * q.y + q.z * q.z)
END SUB

SUB scl3d2d
SHARED trn3d2d()
        d% = 4
DIM uvmat(d%, d%), p AS PipeT
'get matrix for unscaled/uncentered xy
        CALL Getuvmat(uvmat())
'scale and center for 2d
        CALL SclCnt(uvmat())
'save 2d wc pipe step and reset to identities
        d% = 4
DIM ma(d%, d%), ct(d%, d%), c(d%, d%), grf(d%, d%), t3(d%, d%)
        CALL getwcprm(p, ma(), ct(), c(), grf(), t3())
        CALL setwcprm(p, ma(), ct(), c(), grf(), trn3d2d())
ERASE ma, ct, c, grf
ERASE uvmat
END SUB

SUB SclCnt (mat())
SHARED VuPrm AS VuPrmT
SHARED trn3d2d()
        d% = 4
DIM mat1(d%, d%), mat2(d%, d%), mat3(d%, d%)
DIM vr AS RectT
DIM ipt AS Pt3T, opt AS Pt3T
'uv boundaries are in VuPrm.win
'xy boundaries are in VuPrm.vp
        vr = VuPrm.vp
        xtmp = (vr.r - vr.l) / (VuPrm.uv.r - VuPrm.uv.l)
        ytmp = (vr.t - vr.b) / (VuPrm.uv.t - VuPrm.uv.b)
        IF ytmp < xtmp THEN
          scl2 = ytmp
        ELSE
          scl2 = xtmp
        END IF
        x2org = .5 * ((vr.r + vr.l) - (VuPrm.uv.r - VuPrm.uv.l) * scl2)
        y2org = .5 * ((vr.t + vr.b) - (VuPrm.uv.t - VuPrm.uv.b) * scl2)
        zmin = VuPrm.cpn.z + VuPrm.cpn.x
        zmax = VuPrm.cpn.z + VuPrm.cpn.y
        CALL GetTmat(-VuPrm.uv.l, -VuPrm.uv.b, 0, mat1())
        CALL GetSmat(scl2, scl2, zmax - zmin, mat2())
        CALL MatMul(mat1(), 4, 4, mat2(), 4, 4, mat3())
        CALL GetTmat(x2org, y2org, 0, mat1())
        CALL MatMul(mat3(), 4, 4, mat1(), 4, 4, mat2())
        d = VuPrm.cpn.z / (VuPrm.cpn.z + VuPrm.cpn.y)
        CALL setpt3(VuPrm.puv.l, VuPrm.puv.b, d, ipt)
        CALL ptrn3(ipt, mat2(), opt)
        VuPrm.puv.l = opt.x
        VuPrm.puv.b = opt.y
        CALL setpt3(VuPrm.puv.r, VuPrm.puv.t, d, ipt)
        CALL ptrn3(ipt, mat2(), opt)
        VuPrm.puv.r = opt.x
        VuPrm.puv.t = opt.y
        CALL MatMul(mat(), 4, 4, mat2(), 4, 4, trn3d2d())
ERASE mat1, mat2, mat3
END SUB

SUB SetBox (xl, xu, yl, yu, zl, zu, boxcrn() AS Pt3T)
        FOR i% = 1 TO 2
          FOR j% = 1 TO 2
            boxcrn(1, i%, j%).x = xl: boxcrn(2, i%, j%).x = xu
            boxcrn(i%, 1, j%).y = yl: boxcrn(i%, 2, j%).y = yu
            boxcrn(i%, j%, 1).z = zl: boxcrn(i%, j%, 2).z = zu
          NEXT j%
        NEXT i%
END SUB

SUB setcop (x, y, z)
SHARED VuPrm AS VuPrmT
        CALL setpt3(x, y, z, VuPrm.cop)
END SUB

SUB setcpn (x, y)
SHARED VuPrm AS VuPrmT
        VuPrm.cpn.x = x
        VuPrm.cpn.y = y
END SUB

SUB setpt3 (x, y, z, v AS Pt3T)
        v.x = x
        v.y = y
        v.z = z
END SUB

SUB setuvwin (l, r, b, t, f, bk)
SHARED VuPrm AS VuPrmT
        a% = SetRect%(l, r, b, t, VuPrm.win)
        CALL setpt3(f, bk, 0, VuPrm.cpn)
        VuPrm.uvset = -1
END SUB

SUB setvp3d (l, r, b, t)
SHARED VuPrm AS VuPrmT
        a% = SetRect%(l, r, b, t, VuPrm.vp)
        CALL scl3d2d
END SUB

SUB setvpn (x, y, z)
SHARED VuPrm AS VuPrmT
        CALL setpt3(x, y, z, VuPrm.vpn)
END SUB

SUB setvrp (x, y, z)
SHARED VuPrm AS VuPrmT
        CALL setpt3(x, y, z, VuPrm.vrp)
END SUB

SUB setvup (x, y, z)
SHARED VuPrm AS VuPrmT
        CALL setpt3(x, y, z, VuPrm.vup)
END SUB

SUB setwkbox (x, y, z)
SHARED VuPrm AS VuPrmT
        CALL setpt3(x, y, z, VuPrm.box)
        CALL scl3d2d
END SUB

SUB strgrafiti (x1, y1, z1, x2, y2, z2, x3, y3, z3)
'subroutine stgrft for plotting 2d surface in 3 space
'input setup parms(x1,y1,z1,x2,y2,z2,x3,y3,z3)
'give abs3d crds of origin,arbitrary x, and arbitrary y
SHARED wcgrf AS PipeT, mapgrf(), ctmgrf(), ccgrf(), t3dgrf()
        d4% = 4
DIM grfclc(d4%, d4%)
DIM gmat1(d4%, d4%), gmat2(d4%, d4%)
DIM p AS PipeT
DIM r AS RectT
CALL getwcprm(wcgrf, mapgrf(), ctmgrf(), ccgrf(), grfclc(), t3dgrf())
        CALL MatIden(4, grfclc())
        grfclc(4, 1) = x1
        grfclc(4, 2) = y1
        grfclc(4, 3) = z1
'get horizontal increments
        dx1 = x2 - x1
        dy1 = y2 - y1
        dz1 = z2 - z1
        tmp = SQR(dx1 * dx1 + dy1 * dy1 + dz1 * dz1)
        dx1 = dx1 / tmp
        dy1 = dy1 / tmp
        dz1 = dz1 / tmp
'get vertical increments
        dx2 = x3 - x1
        dy2 = y3 - y1
        dz2 = z3 - z1
        dx3 = dy1 * (dx1 * dy2 - dx2 * dy1) - dz1 * (dz1 * dx2 - dz2 * dx1)
        dy3 = dz1 * (dy1 * dz2 - dz1 * dy2) - dx1 * (dx1 * dy2 - dx2 * dy1)
        dz3 = dx1 * (dz1 * dx2 - dz2 * dx1) - dy1 * (dy1 * dz2 - dz1 * dy2)
        tmp = dx3 * dx3 + dy3 * dy3 + dz3 * dz3
        grfclc(1, 1) = dx1
        grfclc(1, 2) = dy1
        grfclc(1, 3) = dz1
        tmp = -SQR(tmp)
        grfclc(2, 1) = dx3 / tmp
        grfclc(2, 2) = dy3 / tmp
        grfclc(2, 3) = dz3 / tmp
        'grfclc(3, 4) = 1
'        CALL MatMul(grfclc(), 4, 4, t3dgrf(), 4, 4, gmat1())
        CALL MatMul(grfclc(), 4, 4, t3dgrf(), 4, 4, gmat2())
'        CALL MatMul(gmat1(), 4, 4, ccgrf(), 4, 4, gmat2())
        CALL MatMul(gmat2(), 4, 4, ctmgrf(), 4, 4, gmat1())
        CALL MatMul(gmat1(), 4, 4, mapgrf(), 4, 4, grfclc())
      
        CALL MatIden(4, gmat1())
        a% = SetRect%(0, 1, 0, 1, r)
        p.win = r
        p.vp = r
        p.clp = r
        p.transet = 0
        p.tranrot = 0
        p.clpoff = -1
        p.mapset = -1

        CALL setwcprm(p, grfclc(), gmat1(), gmat1(), grfclc(), gmat1())
        CALL Plot(0, 0, 3)    'to init new current pen
'        MID$(tkst$, 11, 1) = "1"
'matrix now completed
ERASE grfclc, gmat1, gmat2
END SUB

SUB vecneg (a AS Pt3T, b AS Pt3T)
        b.x = -a.x
        b.y = -a.y
        b.z = -a.z
END SUB

SUB vecprod (a AS Pt3T, b AS Pt3T, c AS Pt3T)
        c.x = a.y * b.z - a.z * b.y
        c.y = a.z * b.x - a.x * b.z
        c.z = a.x * b.y - a.y * b.x
END SUB

SUB vecsum (a AS Pt3T, b AS Pt3T, c AS Pt3T)
        c.x = a.x + b.x
        c.y = a.y + b.y
        c.z = a.z + b.z
END SUB

SUB vector3 (x1, y1, z1, x2, y2, z2)
        CALL plot3d(x1, y1, z1, 3)
        CALL plot3d(x2, y2, z2, 2)
END SUB

SUB vecunit (a AS Pt3T, b AS Pt3T)
        d = SQR(a.x * a.x + a.y * a.y + a.z * a.z)
        IF d <> 0 THEN
          b.x = a.x / d
          b.y = a.y / d
          b.z = a.z / d
        END IF
END SUB

SUB vecuprd (a AS Pt3T, b AS Pt3T, c AS Pt3T)
DIM v AS Pt3T
        CALL vecprod(a, b, v)
        CALL vecunit(v, c)
END SUB

SUB vuabs (x0, y0, z0)
SHARED VuPrm AS VuPrmT
        CALL setpt3(0, 0, 0, VuPrm.vrp)
        CALL setpt3(x0, y0, z0, VuPrm.cop)
        CALL setpt3(-x0, -y0, -z0, VuPrm.vpn)
        CALL setpt3(0, 0, 1, VuPrm.vup)
        CALL scl3d2d
END SUB

SUB vuang (hang, vang, zper)
SHARED VuPrm AS VuPrmT
        DEGRAD# = .0174532925#
        tmp = zper * COS(vang * DEGRAD#)
        x0 = tmp * COS(hang * DEGRAD#) + .5 * VuPrm.box.x
        y0 = tmp * SIN(hang * DEGRAD#) + .5 * VuPrm.box.y
        z0 = zper * SIN(vang * DEGRAD#) + .5 * VuPrm.box.z
        CALL vuabs(x0, y0, z0)
END SUB

SUB vudir (x1, y1, x2, y2, hl)
        IF x1 = x2 THEN
          IF y2 > y1 THEN
            ang1 = 3.14157 / 2
          ELSE
            ang1 = 3 * 3.14157 / 2
          END IF
        ELSE
          ang1 = ATN((y2 - y1) / (x2 - x1))
          IF x2 < x1 THEN
            ang1 = ang1 + 3.14157
          END IF
        END IF
        rang2 = ang1 + 30 * 3.14157 / 180
        rang3 = ang1 - 30 * 3.14157 / 180
        CALL Plot(x1, y1, 3)
        CALL Plot(x2, y2, 2)
        CALL Plot(x2 - hl * COS(rang2), y2 - hl * SIN(rang2), 2)
        CALL Plot(x2, y2, 3)
        CALL Plot(x2 - hl * COS(rang3), y2 - hl * SIN(rang3), 2)
END SUB

