'************************* JKFSEP.BAS *************************
'  U. S. Geological Survey Computer Program Module JKFSEP.BAS
' declarations and graphics routines for making JKPLOT intermediate
'          plot files - efficient version for solo use
'          includes 2d axis routines
' $INCLUDE: 'disclaim.inc'
'*************************************************************************
' $INCLUDE: 'jk2dplt.inc'
' $INCLUDE: 'ax2d.inc'
' $INCLUDE: 'jk3dplt.inc'
' $INCLUDE: 'ax3d.inc'

DECLARE SUB pmat (r%, c%, mat())
DECLARE SUB MatIden (d%, mat!())
DECLARE SUB MatMul (lmat!(), lr%, lc%, rmat!(), rr%, rc%, mat!())

DIM SHARED jkfno%, jkfnam$

END

'error handlers
SetErr:
  BEEP
  errocc% = -1
  RESUME NEXT

SUB AcmTrn2 (wch$, mat())
        PRINT #jkfno%, "ACMTRN2,"; wch$
        CALL pmat(4, 4, mat())
END SUB

SUB arrow (x1, y1, x2, y2, hl)
        IF x1 = x2 THEN
          IF y2 > y1 THEN
            ang1 = 3.14157 / 2
          ELSE
            ang1 = 3 * 3.14157 / 2
          END IF
        ELSE
          ang1 = ATN((y2 - y1) / (x2 - x1))
          IF x2 < x1 THEN
            ang1 = ang1 + 3.14157
          END IF
        END IF
        rang2 = ang1 + 30 * 3.14157 / 180
        rang3 = ang1 - 30 * 3.14157 / 180
        CALL Plot(x1, y1, 3)
        CALL Plot(x2, y2, 2)
        CALL Plot(x2 - hl * COS(rang2), y2 - hl * SIN(rang2), 2)
        CALL Plot(x2, y2, 3)
        CALL Plot(x2 - hl * COS(rang3), y2 - hl * SIN(rang3), 2)
END SUB

SUB autoframe (xpage, ypage, ttl1$, ttl2$)
        PRINT #jkfno%, "AUTOFRAME,"; xpage; ","; ypage
        PRINT #jkfno%, ttl1$
        PRINT #jkfno%, ttl2$
END SUB

FUNCTION autoplt% (xpage, ypage, xmin, xmax, ymin, ymax, errmsg$)
        PRINT #jkfno%, "AUTOPLT,"; xpage; ","; ypage; ","; xmin; ",";
        PRINT #jkfno%, xmax; ","; ymin; ","; ymax
END FUNCTION

FUNCTION axis2% (xpage, ypage, xmin, xmax, ymin, ymax, calconly%, errmsg$)
        PRINT #jkfno%, "AXIS2,"; xpage; ","; ypage; ","; xmin; ","; xmax; ",";
        PRINT #jkfno%, ymin; ","; ymax; ","; calconly%
END FUNCTION

SUB Bgn3d
        PRINT #jkfno%, "BGN3D"
END SUB

SUB Comment (row%, col%, llen%, txt$)
        PRINT #jkfno%, "NCOMMENT,"; row%; ","; col%; ","; llen%; ","; txt$
END SUB

SUB Csymbol (x!, y!, ht!, q%, a, i%)
        PRINT #jkfno%, "CSYMBOL,"; x; ","; y; ","; ht; ","; q%; ","; a; ","; i%
END SUB

SUB Csymbol3D (x, y, z, ht, q%, a, i%)
        PRINT #jkfno%, "CSYMBOL3D,"; x; ","; y; ","; z; ","; ht; ","; q%; ","; a; ","; i%
END SUB

SUB drawbox (xl, xu, yl, yu, zl, zu)
        PRINT #jkfno%, "DRAWBOX,"; xl; ","; xu; ","; yl; ","; yu; ","; zl; ","; zu
END SUB

SUB drawuvwin
        PRINT #jkfno%, "DRAWUVWIN"
END SUB

SUB drawwkbox
        PRINT #jkfno%, "DRAWWKBOX"
END SUB

SUB end3d
        PRINT #jkfno%, "END3D"
END SUB

SUB endgrafiti
        PRINT #jkfno%, "ENDGRAFITI"
END SUB

SUB eqplt (ind$)
        PRINT #jkfno%, "EQPLT,"; ind$
END SUB

SUB Eval2dTran (fx, fy, tx, ty, rotdeg, sx, sy, mat())
'evaluate transformation matrix for 2d transformation
'point specs are in world coordinates
        d4% = 4
        DIM mat1(d4%, d4%) AS SINGLE
        DIM mat2(d4%, d4%) AS SINGLE
        DIM mat3(d4%, d4%) AS SINGLE
        rotrad = .0174533 * rotdeg
        ss = SIN(rotrad)
        cs = COS(rotrad)
'first translate fixed point to origin
        CALL MatIden(4, mat1())
        mat1(4, 1) = -fx
        mat1(4, 2) = -fy
'then scale
        CALL MatIden(4, mat2())
        mat2(1, 1) = sx
        mat2(2, 2) = sy
        CALL MatMul(mat1(), 4, 4, mat2(), 4, 4, mat3())
'next rotate
        CALL MatIden(4, mat1())
        mat1(1, 1) = cs
        mat1(1, 2) = ss
        mat1(2, 1) = -ss
        mat1(2, 2) = cs
        CALL MatMul(mat3(), 4, 4, mat1(), 4, 4, mat2())
'next translate back to with new translation
        CALL MatIden(4, mat1())
        mat1(4, 1) = fx + tx
        mat1(4, 2) = fy + ty
        CALL MatMul(mat2(), 4, 4, mat1(), 4, 4, mat())
ERASE mat1, mat2, mat3
END SUB

SUB Factor (rfact)
        PRINT #jkfno%, "FACTOR,"; rfact
END SUB

SUB frame
        PRINT #jkfno%, "FRAME"
END SUB

SUB grid (xgrd%, ygrd%)
        PRINT #jkfno%, "GRID,"; xgrd%; ","; ygrd%
END SUB

SUB MatIden (d%, mat())
'subroutine to make an identity matrix + a little
        FOR i% = 1 TO d%
          FOR j% = 1 TO d%
              mat(i%, j%) = 0
          NEXT j%
          mat(i%, i%) = 1
        NEXT i%
END SUB

SUB MatMul (lmat(), lr%, lc%, rmat(), rr%, rc%, mat())
'subroutine to multiply two matrices-must be dimensioned properly elsewhere
'for compatibility, the no of left cols must = no or right rows
        FOR r% = 1 TO lr%
          FOR c% = 1 TO rc%
            mat(r%, c%) = 0
            FOR k% = 1 TO lc%
              mat(r%, c%) = mat(r%, c%) + lmat(r%, k%) * rmat(k%, c%)
            NEXT k%
          NEXT c%
        NEXT r%
END SUB

SUB newcfont (f%)
        PRINT #jkfno%, "NEWCFONT,"; f%
END SUB

SUB newfont (f%)
        PRINT #jkfno%, "NEWFONT,"; f%
END SUB

SUB Newpen (spen%)
        PRINT #jkfno%, "NEWPEN,"; spen%
END SUB

SUB nodraw (x$, y$)
        PRINT #jkfno%, "NODRAW,"; x$; ","; y$
END SUB

SUB nodraw3d (x$, y$, z$)
        PRINT #jkfno%, "NODRAW3D,"; x$; ", "; y$; ","; z$
END SUB

SUB noend (x$, y$)
        PRINT #jkfno%, "NOEND,"; x$; ","; y$

END SUB

SUB nofrst (x$, y$)
        PRINT #jkfno%, "NOFRST,"; x$; ","; y$
END SUB

SUB nolab (x$, y$)
        PRINT #jkfno%, "NOLAB,"; x$; ","; y$
END SUB

SUB nolast (x$, y$)
        PRINT #jkfno%, "NOLAST,"; x$; ","; y$
END SUB

SUB nonum (x$, y$)
        PRINT #jkfno%, "NONUM,"; x$; ","; y$
END SUB

SUB Number (x, y, ht, fpn, a, d%)
        PRINT #jkfno%, "NUMBER,"; x; ","; y; ","; ht; ","; fpn; ","; a; ","; d%
END SUB

SUB plate3d (xpage, ypage, hang, vang, ttl1$, ttl2$)
        PRINT #jkfno%, "PLATE3D,"; xpage; ","; ypage; ","; hang; ","; vang
        PRINT #jkfno%, ttl1$
        PRINT #jkfno%, ttl2$
END SUB

SUB Plot (x!, y!, p%)
        PRINT #jkfno%, "PLOT,"; x; ","; y; ","; p%
        IF ABS(p%) = 999 THEN
          CLOSE #jkfno%
        END IF
END SUB

SUB Plot3D (x, y, z, p%)
        PRINT #jkfno%, "PLOT3D,"; x; ","; y; ","; z; ","; p%
        IF ABS(p%) = 999 THEN
          CLOSE #jkfno%
        END IF
END SUB

SUB Plots (x, y, devno%, tkerr%)
        errocc% = 0
        ON ERROR GOTO SetErr
        IF jkfno% <> 0 THEN
          CLOSE jkfno%
        END IF
        IF jkfnam$ <> "" THEN
'initializes a plot
          IF NOT st.clconly THEN
            jkfno% = FREEFILE
            OPEN "o", #jkfno%, jkfnam$
            PRINT #jkfno%, "PLOTS,"; x; ","; y
          END IF
        ELSE
          errocc% = -1
        END IF
        ON ERROR GOTO 0
        tkerr% = errocc%
END SUB

SUB pmat (r%, c%, mat())
        FOR i% = 1 TO r%
          FOR j% = 1 TO c%
            PRINT #jkfno%, mat(i%, j%)
          NEXT j%
        NEXT i%
END SUB

SUB PolyLine (xary(), yary(), n%, inc%, typ%, q%, ht)
        PRINT #jkfno%, "POLYLINE,"; n%; ","; inc%; ","; typ%; ","; q%; ","; ht
        FOR i% = 1 TO n%
          WRITE #jkfno%, xary(i%), yary(i%)
        NEXT i%
END SUB

SUB PolyLine3D (x3(), y3(), z3(), n%, inc%, typ%, q%, ht)
        PRINT #jkfno%, "POLYLINE3D,"; n%; ","; inc%; ","; typ%; ","; q%; ","; ht
        FOR i% = 1 TO n%
          WRITE #jkfno%, x3(i%), y3(i%), z3(i%)
        NEXT i%
END SUB

SUB ResetAxes
        PRINT #jkfno%, "RESETAXES"
END SUB

FUNCTION ResetClip% (wch$)
        PRINT #jkfno%, "RESETCLIP,"; wch$
END FUNCTION

SUB resetuvwin
        PRINT #jkfno%, "RESETUVSIN"
END SUB

SUB scl3d2d
        PRINT #jkfno%, "SCL3D2D"
END SUB

SUB scsymbol (x, y, ht, q%, a, i%)
        PRINT #jkfno%, "SCSYMBOL,"; x; ","; y; ","; ht; ","; q%; ","; a; ","; i%
END SUB

SUB SetAxes (xtyp, xorig, xstep, xend, ytyp, yorig, ystep, yend)
        PRINT #jkfno%, "SETAXES,"; xtyp; ","; xorig; ","; xstep; ","; xend; ",";
        PRINT #jkfno%, ytyp; ","; yorig; ","; ystep; ","; yend
END SUB

SUB setaxes3d (xt, xs, xp, xe, yt, ys, yp, ye, zt, zs, zp, ze, nodraw3%)
        PRINT #jkfno%, "SETAXES3D,"; xt; ","; xs; ","; xp; ","; xe; ",";
        PRINT #jkfno%, yt; ","; ys; ","; yp; ","; ye; ",";
        PRINT #jkfno%, zt; ","; zs; ","; zp; ","; ze; ","; nodraw3%
END SUB

SUB SetAxht2 (xht, yht)
        PRINT #jkfno%, "SETAXHT2,"; xht; ","; yht
END SUB

SUB SetAxht3 (xht, yht, zht)
        PRINT #jkfno%, "SETAXHT3,"; xht; ","; yht; ","; zht
END SUB

SUB SetAxis (wch$, atyp, aorig, astep, aend, alen, alab$, aside%, xpos, ypos)
        PRINT #jkfno%, "SETAXIS,"; wch$; ","; atyp; ","; aorig; ",";
        PRINT #jkfno%, astep; ","; aend; ","; alen; ","; aside%; ","; xpos; ","; ypos; ",";
        PRINT #jkfno%, alab$
END SUB

SUB SetAxpg (xpage, ypage, tit$, xlab$, ylab$, xlen, ylen)
        PRINT #jkfno%, "SETAXPG,"; xpage; ","; ypage; ","; xlen; ","; ylen
        PRINT #jkfno%, tit$
        PRINT #jkfno%, xlab$
        PRINT #jkfno%, ylab$
END SUB

SUB SetAxpg3d (x3l$, x3ax, y3l$, y3ax, z3l$, z3ax)
        PRINT #jkfno%, "SETAXPG3D,"; x3ax; ","; y3ax; ","; z3ax
        PRINT #jkfno%, x3l$
        PRINT #jkfno%, y3l$
        PRINT #jkfno%, z3l$
END SUB

FUNCTION SetClip% (wch$, l, r, b, t)
        PRINT #jkfno%, "SETCLIP,"; wch$; ","; l; ","; r; ","; b; ","; t
END FUNCTION

SUB setcop (x, y, z)
        PRINT #jkfno%, "SETCOP,"; x; ","; y; ","; z
END SUB

SUB setcpn (x, y)
        PRINT #jkfno%, "SETCPN,"; x; ","; y
END SUB

SUB SetFnam (wch%, nam$)
        jkfnam$ = nam$
END SUB

SUB SetTrn2 (wch$, mat())
        PRINT #jkfno%, "SETTRN2,"; wch$
        CALL pmat(4, 4, mat())
END SUB

SUB setuvwin (l, r, b, t, f, bk)
        PRINT #jkfno%, "SETUVWIN,"; l; ","; r; ","; b; ","; t; ","; f; ","; bk
END SUB

SUB setvp3d (l, r, b, t)
        PRINT #jkfno%, "SETVP3D,"; l; ","; r; ","; b; ","; t
END SUB

SUB setvpn (x, y, z)
        PRINT #jkfno%, "SETVPN,"; x; ","; y; ","; z
END SUB

SUB setvrp (x, y, z)
        PRINT #jkfno%, "SETVRP,"; x; ","; y; ","; z
END SUB

SUB setvup (x, y, z)
        PRINT #jkfno%, "SETVUP,"; x; ","; y; ","; z
END SUB

FUNCTION SetWcVp% (l!, r!, b!, t!)
        PRINT #jkfno%, "SETWCVP,"; l; ","; r; ","; b; ","; t
END FUNCTION

FUNCTION SetWcWin% (l!, r!, b!, t!)
        PRINT #jkfno%, "SETWCWIN,"; l; ","; r; ","; b; ","; t
END FUNCTION

SUB setwkbox (x, y, z)
        PRINT #jkfno%, "SETWKBOX,"; x; ","; y; ","; z
END SUB

FUNCTION SetWsVp% (l!, r!, b!, t!)
        PRINT #jkfno%, "SETWSVP,"; l; ","; r; ","; b; ","; t
END FUNCTION

FUNCTION SetWsWin% (l!, r!, b!, t!)
        PRINT #jkfno%, "SETWSWIN,"; l; ","; r; ","; b; ","; t
END FUNCTION

SUB sNumber (x, y, ht, fpn, a, d%)
        PRINT #jkfno%, "SNUMBER,"; x; ","; y; ","; ht; ","; fpn; ","; a; ","; d%
END SUB

SUB splot (x, y, p%)
        PRINT #jkfno%, "SPLOT,"; x; ","; y; ","; p%
END SUB

SUB splot3d (x, y, z, p%)
        PRINT #jkfno%, "SPLOT3D,"; x; ","; y; ","; z; ","; p%
END SUB

SUB spoly3d (xary(), yary(), zary(), n%, inc%, typ%, q%, ht)
        PRINT #jkfno%, "SPOLYLINE3D,"; n%; ","; inc%; ","; typ%; ","; q%; ","; ht
        FOR i% = 1 TO n%
          WRITE #jkfno%, xary(i%), yary(i%), zary(i%)
        NEXT i%
END SUB

SUB spolyline (xary(), yary(), n%, inc%, typ%, q%, ht)
        PRINT #jkfno%, "SPOLYLINE,"; n%; ","; inc%; ","; typ%; ","; q%; ","; ht
        FOR i% = 1 TO n%
          WRITE #jkfno%, xary(i%), yary(i%)
        NEXT i%
END SUB

SUB ssymbol (x, y, ht, txt$, angle)
        PRINT #jkfno%, "SSSYMBOL,"; x; ","; y; ","; ht; ","; angle; ","; txt$
END SUB

SUB strgrafiti (x1, y1, z1, x2, y2, z2, x3, y3, z3)
        PRINT #jkfno%, "STRGRAFITI"
        PRINT #jkfno%, x1; ","; y1; ","; z1
        PRINT #jkfno%, x2; ","; y2; ","; z2
        PRINT #jkfno%, x3; ","; y3; ","; z3
END SUB

SUB Symbol (x!, y!, ht!, txt$, angle!)
        PRINT #jkfno%, "SSYMBOL,"; x; ","; y; ","; ht; ","; angle; ","; txt$
END SUB

SUB Symbol3D (x, y, z, ht, txt$, angle)
        PRINT #jkfno%, "SSYMBOL3D,"; x; ","; y; ","; z; ","; ht; ","; angle; ","; txt$
END SUB

SUB vuabs (x0, y0, z0)
        PRINT #jkfno%, "VUABS,"; x0; ","; y0; ","; z0
END SUB

SUB vuang (hang, vang, zper)
        PRINT #jkfno%, "VUANG,"; hang; ","; vang; ","; zper
END SUB

SUB xticks (n%)
        PRINT #jkfno%, "XTICKS,"; n%
END SUB

SUB yticks (n%)
        PRINT #jkfno%, "YTICKS,"; n%
END SUB

