'define variable types for plot system
TYPE PointT
  x AS SINGLE
  y AS SINGLE
END TYPE
TYPE Pt3T
  x     AS SINGLE
  y     AS SINGLE
  z     AS SINGLE
END TYPE
TYPE RectT
  l AS SINGLE
  b AS SINGLE
  r AS SINGLE
  t AS SINGLE
END TYPE

'type for plot device characteristics
TYPE devT
  id     AS STRING * 10
  gmode   AS INTEGER
  scr    AS RectT
  upi    AS PointT
  asp    AS SINGLE
  yinv   AS INTEGER
  inch   AS INTEGER
  txscr  AS INTEGER
  npen   AS INTEGER
END TYPE
'type for pipeline step - 2d
TYPE PipeT
  cp            AS Pt3T         'current pen in object space
  win           AS RectT        'window in object space
  vp            AS RectT        'viewport in image space
  asp           AS SINGLE       'aspect
  upi           AS PointT       'units per inch
  clp           AS RectT        'clipping window - default is win
  scl           AS PointT       'scale factors
  offset        AS PointT       'mapping offset
  clpoff        AS INTEGER      'clipping control
  transet       AS INTEGER      'set if tran is not identity
  tranrot       AS INTEGER      'skew indicator
  mapset        AS INTEGER      'set if map is not identity
  tran4         AS INTEGER      'indicator for transformation set
  map4          AS INTEGER      'indicator for map set
END TYPE
'type for plot system state
TYPE stateT
  pws           AS INTEGER             'present open workstation
  mode          AS INTEGER
  inch          AS INTEGER
  spen          AS INTEGER
  font          AS INTEGER
  cfont         AS INTEGER
  fno           AS INTEGER
  psyson        AS INTEGER
  wsuclr        AS INTEGER
  noeqasp       AS INTEGER
  uscl          AS INTEGER
  sclmul        AS PointT
  clpcen        AS INTEGER
  picrot        AS INTEGER
  grfon         AS INTEGER
  nopicend      AS INTEGER
  clconly       AS INTEGER
END TYPE

