'************************* QBEP.BAS *************************
'  U. S. Geological Survey Computer Program Module QBEP.BAS
'    definitions and graphics routines for Epson Printer
' $INCLUDE: 'disclaim.inc'
'*************************************************************************
' $INCLUDE: 'jk2dplt.inc'
'functions to be called externally
DECLARE FUNCTION EPWsOpen% (devno%)
DECLARE FUNCTION EPWsClose% ()
DECLARE FUNCTION EPDevOpen% (devno%)
DECLARE FUNCTION EPDevclr% ()
DECLARE SUB EPDevCmt (row%, c%, llen%, TEXT$)
DECLARE FUNCTION EPDevEnd% ()
DECLARE FUNCTION EPDevMov% (xo, yo, xn, yn, p%)
DECLARE SUB EPDevPen (spen%)
DECLARE SUB EPFill (xo, yo, xn, yn, p%)
'internal functions
DECLARE FUNCTION clrmap% ()
DECLARE SUB GETIT (bnk%, TKBYTE%, RVAL%)
DECLARE SUB PUTIT (bnk%, TKBYTE%, SVAL%)
DECLARE SUB SetPix (xo%, yo%)
DECLARE SUB SendRow (ps%)
       
        DIM SHARED penmap%(16)                  'pen definitions
        DIM SHARED errocc%                      'for error handling
        DIM SHARED pfilnum%, tkdelay%            'comm port file no
'printer characteristics
        DIM SHARED pxprps%                      'pixels per pass
        DIM SHARED psprln%                      'passes per line
        DIM SHARED pxprln%                      'pixels per line
        DIM SHARED lnprin%                      'lines per inch
        DIM SHARED crlf$                        'carriage return+line feed
        DIM SHARED setlf$(3)                    'line feed controls
        DIM SHARED gmodset$
        DIM SHARED stgln$                       'graphics line start
        DIM SHARED ndgrf$                       'end graphics = ff + init
'bitmap block/disk-swapping variables and memory use function
        DIM SHARED bitfile%                     'pageing file no
        DIM SHARED nblk%                        'total no of banks
        DIM SHARED nresblk%                     'total no or resident banks
        DIM SHARED replt%
        DIM SHARED nresrows%
        DIM SHARED strtrow%
        DIM SHARED endrow%
        DIM SHARED strtcrd%
        DIM SHARED endcrd%
        DIM SHARED pltpass%
        DIM SHARED blkoffset%
        DIM SHARED psoffset%
'bitmap defining variables
        DIM SHARED maxmemg                      'max memory for bitmap
        DIM SHARED maxindex%
        DIM SHARED msk%(2, 8)                   'bitmap mask
        DIM SHARED wrdsprblk%                    'integers per bitmap block
        DIM SHARED wrdsprrow%                    'integers per row block
        DIM SHARED rowsprblk%                   'printer passes per block
        DIM SHARED bytesprwrd%                  'integer length = 2
        DIM SHARED bytesprrow%
        DIM SHARED totpass%                     'total no of printer passes
        tmp% = 1
        DIM SHARED bitmap(tmp%, tmp%) AS INTEGER'dynamic bitmap array
        DIM SHARED olin(tmp%) AS STRING * 1
'only subs are in this module
END

'error handler
Seterr:

BEEP
  errocc% = ERR
  RESUME NEXT

FUNCTION clrmap%
'arrays are dynamic because first defined in module common
       
        tmperr% = 0
        tmp% = 0
        REDIM bitmap(tmp%, tmp%) AS INTEGER

'calculate bitmap blocking constants - seperated for understanding and
  'for ease of understanding blocking and disk-save with short memory
  'number of printer rows in one block
  'one row contains a sequence of bytes - representing each of the
   'eight printer pin locations - the passes per line variable indicates
  'the type of interweaving of these pin locations
       
        bytesprwrd% = 2                 'integer word
        bytesprrow% = dev.scr.r + 1     'left screen position is 0
        wrdsprrow% = INT((bytesprrow% - 1) / bytesprwrd%) + 1
'calculate global printer control constants
        n2% = INT((bytesprrow%) / 256)
        n1% = bytesprrow% - n2% * 256
'start graphics - specifies how many bytes to be sent
        stgln$ = gmodset$ + CHR$(n1%) + CHR$(n2%)
  'set max memory to use - leave 2000 bytes minimum
  'if not enough free, set to less and cause maximum dimension for
  'bitmap to be less-lack of memory can still cause fatal error now
      
  'init maxmem is zero unless set by application program
        maxmem = maxmemg
        IF maxmem = 0 THEN maxmem = FRE(-1) - 2000
 
  'dimension to use in integer bitmap
  'set to max possible pos int index-1 unless preset to less
  'to allow for wrdsprblk% calc
        IF maxindex% < wrdsprrow% THEN maxindex% = 32766
  'fix index to allow block to fit in memory
        IF maxindex% > maxmem / bytesprwrd% THEN
          maxindex% = INT((maxmem - 1) / bytesprwrd%) - 1
        END IF
  'if still too small then fatal error will occur
        IF maxindex% < wrdsprrow% THEN
          tmperr% = -1
        END IF
        wrdsprblk% = maxindex% + 1      'indexing starts with 0
        rowsprblk% = INT(wrdsprblk% / wrdsprrow%)
        rowsprblk% = rowsprblk% - (rowsprblk% MOD psprln%)
        wrdsprblk% = wrdsprrow% * rowsprblk%
        totpass% = INT(dev.scr.t / pxprps%) + 1
  'calculate resident blocks and disk-replot counters
        nblk% = INT((totpass% - 1) / rowsprblk%) + 1
        nresblk% = INT((maxmem / bytesprwrd%) / wrdsprblk%)
        IF nresblk% >= nblk% OR nblk% <= 1 THEN
  'case all blocks resident
          nresblk% = nblk%
          replt% = 0
        ELSE
  'case to save plot instruction for replotting
          replt% = INT((nblk% - 1) / nresblk%)
  'open plot instruction save file for replot use if necessary
          IF ((replt% <> 0) AND (bitfile% = 0)) THEN
            bitfile% = FREEFILE
            OPEN "REPLOT.$$$" FOR OUTPUT AS #bitfile%
          END IF
        END IF
  'set beginning and ending blocks in resident bitmap
        strtrow% = 0
        endrow% = nresblk% * rowsprblk% - 1
        nresrows% = nresblk% * rowsprblk%
        strtcrd% = 0
        endcrd% = pxprps% * nresrows% - 1
  'initialize replot pass number and block/pass offset variables
        pltpass% = 0
        blkoffset% = 0
        psoffset% = 0
       
        REDIM bitmap(nresblk% - 1, maxindex%) AS INTEGER
        clrmap% = tmperr%
END FUNCTION

FUNCTION EPDevclr%
'initializes a plot
'init bitmap
        LOCATE 23, 1: PRINT SPACE$(78);
        LOCATE 24, 1: PRINT SPACE$(78);
        LOCATE 23, 1: PRINT "CLEARING MEMORY BIT MAP";
        EPDevclr% = clrmap%
        LOCATE 23, 1: PRINT SPACE$(78);
        LOCATE 24, 1: PRINT "MEMORY MAP CLEARED - DRAWING PICTURE INTO BITMAP";
END FUNCTION

SUB EPDevCmt (row%, col%, llen%, TEXT$)
        LOCATE row%, col%
        PRINT SPACE$(llen%);
        LOCATE row%, col%
        PRINT TEXT$;
END SUB

FUNCTION EPDevEnd%
'screen/plot termination routine
        errocc% = 0
        ON ERROR GOTO Seterr
'memmap dump to printer
        LOCATE 23, 1: PRINT SPACE$(78);
        LOCATE 24, 1: PRINT SPACE$(78);
        LOCATE 23, 1: PRINT "SENDING MEMORY BIT MAP TO PRINTER";
        LOCATE 24, 1: PRINT "PRESS Q TO ABORT PLOT";

        PRINT #pfilnum%, crlf$;   'locate vertically
       
'loop through as many replot passes as necessary
        DO
          IF replt% <> 0 THEN CLOSE #bitfile%

          lpstrt% = pltpass% * nresrows%
          IF totpass% <= lpstrt% + nresrows% - 1 THEN
            lpend% = totpass% - 1
          ELSE
            lpend% = lpstrt% + nresrows% - 1
          END IF
          LOCATE 21, 1: PRINT SPACE$(78);
          LOCATE 21, 1: PRINT "Sending pass "; pltpass% + 1; " of "; replt% + 1;
          FOR ps% = lpstrt% TO lpend%
            a$ = INKEY$                   'for abort return
            IF UCASE$(a$) <> "Q" THEN
              PRINT #pfilnum%, setlf$(ps% MOD psprln%);
              LOCATE 22, 1: PRINT SPACE$(78);
              LOCATE 22, 1: PRINT "Sending line "; ps% + 1; " of "; totpass%;
              CALL SendRow((ps%))      'send zero row
              PRINT #pfilnum%, crlf$;
            ELSE
              ps% = totpass% + 1
            END IF
          NEXT ps%
 
          IF ps% < totpass% THEN
            pltpass% = pltpass% + 1
            strtcrd% = endcrd% + 1
            LOCATE 21, 1: PRINT SPACE$(78);
            LOCATE 21, 1: PRINT "Redrawing pass "; pltpass% + 1; " of "; replt% + 1;
            endcrd% = strtcrd% + pxprps% * nresrows% - 1
            strtrow% = endrow% + 1
            endrow% = strtrow% + nresblk% * rowsprblk% - 1
            psoffset% = psoffset% + nresrows%
            blkoffset% = blkoffset% + 1
            REDIM bitmap(nresblk% - 1, maxindex%)  AS INTEGER
            OPEN "REPLOT.$$$" FOR INPUT AS #bitfile%
            WHILE (NOT EOF(bitfile%))
              INPUT #bitfile%, xo, yo, xn, yn
              a% = EPDevMov%(xo, yo, xn, yn, 2)
            WEND
            CLOSE #bitfile%
            LOCATE 22, 1: PRINT SPACE$(78);
            LOCATE 22, 1: PRINT "Replot for pass "; pltpass% + 1;
            PRINT "replot for pass "; pltpass%
          END IF
        LOOP UNTIL ((lpend% >= totpass% - 1) OR (ps% >= totpass% + 1))

        PRINT #pfilnum%, ndgrf$
        BEEP
        LOCATE 23, 1: PRINT SPACE$(78);
        LOCATE 24, 1: PRINT SPACE$(78);
        LOCATE 23, 1: PRINT "PLOT FINISHED";

        CLOSE #bitfile%
        bitfile% = 0
        REDIM bitmap(0, 0) AS INTEGER
        REDIM olin(1) AS STRING * 1
        IF replot% <> 0 THEN KILL "REPLOT.$$$"
        ON ERROR GOTO 0
        EPDevEnd% = errocc%
END FUNCTION

FUNCTION EPDevMov% (xo, yo, xn, yn, p%)
'routine to format instructions for device and send to device
        IF (ABS(p%) = 2) THEN
'line generator for mem map
'assign local variables for end points
          xo% = INT(xo)
          yo% = INT(yo)
          xn% = INT(xn)
          yn% = INT(yn)
'if replotting necessary for non-resident blocks, save these end points
          IF ((replt% <> 0) AND (pltpass% = 0)) THEN
            IF ((yo% >= endcrd%) OR (yn% >= endcrd%)) THEN
              PRINT #bitfile%, xo%; ","; yo%; ","; xn%; ","; yn%
            END IF
          END IF
          IF ((yo% >= strtcrd%) OR (yn% >= strtcrd%)) THEN

'8 octant line generation
              IF xn% < xo% THEN
'mirror quadrants 2,5 to 1,4
                SWAP xo%, xn%
                SWAP yo%, yn%
              END IF
              dx% = xn% - xo%
              dy% = yn% - yo%
'determine which segment
              IF dy% < 0 THEN
                IF -dy% > dx% THEN

'octant 7 line generation
                  cnt% = -dy%
                  er% = dy% / 2
                  DO
                    CALL SetPix(xo%, yo%)
                    cnt% = cnt% - 1
                    yo% = yo% - 1
                    er% = er% + dx%
                    IF er% >= 0 THEN
                      xo% = xo% + 1
                      er% = er% + dy%
                    END IF
                  LOOP WHILE (cnt% >= 0)
         
                ELSE
'octant 8 line generation
                  cnt% = dx%
                  er% = -dx% / 2
                  DO
                    CALL SetPix(xo%, yo%)
                    cnt% = cnt% - 1
                    xo% = xo% + 1
                    er% = er% - dy%
                    IF er% >= 0 THEN
                      yo% = yo% - 1
                      er% = er% - dx%
                    END IF
                  LOOP WHILE (cnt% >= 0)
                END IF
       
              ELSE
                IF dy% > dx% THEN
'octant 2 line generation
                  cnt% = dy%
                  er% = -dy% / 2
                  DO
                    CALL SetPix(xo%, yo%)
                    cnt% = cnt% - 1
                    yo% = yo% + 1
                    er% = er% + dx%
                    IF er% >= 0 THEN
                      xo% = xo% + 1
                      er% = er% - dy%
                    END IF
                  LOOP WHILE (cnt% >= 0)
         
                ELSE
'octant 1 line generation
                  cnt% = dx%
                  er% = -dx% / 2
                  DO
                    CALL SetPix(xo%, yo%)
                    cnt% = cnt% - 1
                    xo% = xo% + 1
                    er% = er% + dy%
                    IF er% >= 0 THEN
                      yo% = yo% + 1
                      er% = er% - dx%
                    END IF
                  LOOP WHILE (cnt% >= 0)
        
                END IF
              END IF
            END IF
       
        END IF
        EPDevMov% = 0
END FUNCTION

FUNCTION EPDevOpen% (devno%)
tkdelay% = 100        'set now for 80386 speed
'setting prms for EPSON GRAPHICS
'allow program to proceed normally only if either the specified
'device has been opened as a workstation or no device has yet been
'specified as a workstation
        IF st.pws <> devno% THEN pserr% = EPWsOpen%(devno%)
        EPDevOpen% = pserr% OR errocc%
END FUNCTION

SUB EPDevPen (spen%)
'subroutine for newpen
'only one pen for printer-no action
          st.spen = spen%
END SUB

SUB EPFill (xo, yo, xn, yn, p%)
'just a stub for now - need gray scale fill matrix, etc.
END SUB

FUNCTION EPWsClose%
        IF pfilnum% <> 0 THEN
          CLOSE #pfilnum%
          pfilnum% = 0
        END IF
        IF (bitfile% <> 0) THEN
          CLOSE #bitfile%
          bitfile% = 0
        END IF
        REDIM bitmap(0, 0) AS INTEGER
        st.pws = 0
        EPWsClose% = 0
END FUNCTION

FUNCTION EPWsOpen% (devno%)
'device numbers
'       5 = EPSHR = Epson high resolution 8 inch width (regular)
'       6 = EPSHW = Epson high resolution 13 inch width (wide)
'       7 = EPSLR = Epson low resolution 8 inch width (regular)
'       8 = EPSLW = Epson low resolution 13 inch width (wide)
'to specify an output device
'first get comm port parms from file "config.lpt" and open port
        errocc% = 0
        tmpnum% = FREEFILE
        ON ERROR GOTO Seterr
        tfil$ = "CONFIG.LPT"
        a$ = ENVIRON$("JKPLT")
        IF a$ <> "" THEN tfil$ = a$ + tfil$
        OPEN "i", #tmpnum%, tfil$
        IF NOT errocc% THEN INPUT #tmpnum%, config$ ELSE errno% = 1
        CLOSE #tmpnum%
'open comm port and initialize plotter
        IF NOT errocc% THEN
          pfilnum% = FREEFILE
          OPEN config$ FOR RANDOM AS #pfilnum%
          IF errocc% THEN
            CLOSE #pfilnum%
          ELSE
            WIDTH #pfilnum%, 255
            PRINT #pfilnum%, CHR$(0);
          END IF
        END IF
        ON ERROR GOTO 0
'set parameters that depend on high/low resolution and reg/wide paper
'no error check for bad device number
        dev.id = "EP"
'resolution cases
        SELECT CASE devno%
          CASE EPSHR, EPSHW
            dev.id = dev.id + "H"
            gmodset$ = CHR$(27) + CHR$(76)      'graphics mode set
            psprln% = 3                         'passes per line
            dev.upi.x = 120               'units per inch
            dev.upi.y = 216
            dev.asp = 9 / 5               'aspect ratio
'line feed step controls for each pass of printer head
            setlf$(0) = CHR$(27) + CHR$(51) + CHR$(1)     '1/216 inch
            setlf$(1) = CHR$(27) + CHR$(51) + CHR$(1)
            setlf$(2) = CHR$(27) + CHR$(51) + CHR$(22)    '22/216 inch
          CASE EPSLR, EPSLW
            dev.id = dev.id + "L"
            gmodset$ = CHR$(27) + CHR$(75)
            psprln% = 1
            dev.upi.x = 60               'units per inch
            dev.upi.y = 72
            dev.asp = 6 / 5               'aspect ratio
'line feed step controls for each pass of printer head
            setlf$(0) = CHR$(27) + CHR$(65) + CHR$(8)     '8/72 inch
        END SELECT
'width cases
        SELECT CASE devno%
          CASE EPSHR, EPSLR
            dev.id = dev.id + "R"
            rside% = 8
          CASE EPSHW, EPSLW
            dev.id = dev.id + "W"
            rside% = 13
        END SELECT
'initialize Epson control constants
        pxprps% = 8                             'pixels per pass
        pxprln% = pxprps% * psprln%             'pixels per line
        lnprin% = 9                             'lines per inch
        crlf$ = CHR$(13) + CHR$(10)             'carriage return+line feed
'end plot = form feed and reinitialize printer
        ndgrf$ = CHR$(12) + CHR$(27) + "@"
'now set device parameters
        dev.gmode = 1
        dev.scr.l = 0                 'small paper size
        dev.scr.b = 0
'set raster limits for 8x10 inch image on 8.5x11 inch paper
        dev.scr.r = rside% * dev.upi.x - 1
        dev.scr.t = 10 * dev.upi.y - 1
        dev.yinv = -1                 'inverted y coordinate
        dev.inch = -1                 'inch-type plotter
        dev.txscr = 0                 'for leaving graphics mode
        dev.npen = 1                  'no of pens
'pen color mapping variable
        penmap%(0) = 0
        FOR i% = 1 TO npen%
          penmap%(i%) = 1
        NEXT i%
'initialize bitmap mask
'left byte of integer
        msk%(0, 7) = &H100
        msk%(0, 6) = &H200
        msk%(0, 5) = &H400
        msk%(0, 4) = &H800
        msk%(0, 3) = &H1000
        msk%(0, 2) = &H2000
        msk%(0, 1) = &H4000
        msk%(0, 0) = &H8000
'right byte of integer
        msk%(1, 7) = &H1
        msk%(1, 6) = &H2
        msk%(1, 5) = &H4
        msk%(1, 4) = &H8
        msk%(1, 3) = &H10
        msk%(1, 2) = &H20
        msk%(1, 1) = &H40
        msk%(1, 0) = &H80
        IF NOT errocc% THEN
          st.pws = devno%
        END IF
        pserr% = errocc%
        EPWsOpen% = errocc%
END FUNCTION

SUB SendRow (ps%)
'sub to send a row - even or odd - used in double den

'initialize the print line to zeroes
        REDIM olin(bytesprrow%) AS STRING * 1
'set check for null line
          nchk% = 0
'calculate which bitmap block and word to start with
          ps% = ps% - psoffset%
          blk% = INT(ps% / rowsprblk%)                       'block
          rowoffset% = ps% - blk% * rowsprblk%                 'row in block
          wrdoffset% = rowoffset% * wrdsprrow%                 'word in block
'loop through bitmap for that row
        FOR wrdidx% = 0 TO wrdsprrow% - 1
'get the word
          wrd% = bitmap(blk%, wrdoffset% + wrdidx%)
          IF (wrd% <> 0) THEN nchk% = -1
'set the bytes in the print line
  'left byte
          chrpos% = 1 + INT(wrdidx% * bytesprwrd%)
          sbit% = wrd% AND &H8000                 'pull off sign bit
          wrd% = wrd% AND &H7FFF
          tmp% = INT(wrd% / 256)
          IF sbit% <> 0 THEN tmp% = tmp% OR &H80
          olin(chrpos%) = CHR$(tmp%)
  'right byte
          IF chrpos% + 1 <= bytesprrow% THEN
            olin(chrpos% + 1) = CHR$(wrd% AND 255)
          END IF
        NEXT wrdidx%
'send the line if not a null line
        IF nchk% THEN
          PRINT #pfilnum%, stgln$;
          FOR i% = 1 TO bytesprrow%
            PRINT #pfilnum%, olin(i%);
          NEXT i%
        END IF
END SUB

SUB SetPix (xo%, yo%)
'sub to place 1 in proper place in bitmap for plot
'calculate which printer pass must hold the bit

        ps% = psprln% * INT(yo% / pxprln%) + (yo% MOD psprln%)

'if this row is resident then set the bitmap
        IF ((strtrow% <= ps%) AND (ps% <= endrow%)) THEN
'correct pass for resident blocks
          ps% = ps% - psoffset%
'calculate which bitmap block , word, byte, and bit to set
'(50% of total computing time!!!)
          blk% = INT(ps% / rowsprblk%)                        'block
          rowoffset% = ps% - blk% * rowsprblk%                 'row in block
          wrdoffset% = rowoffset% * wrdsprrow% + INT(xo% / 2)  'word in block
          byteinwrd% = xo% MOD 2                               'byte in word
          bitinbyte% = INT((yo% MOD pxprln%) / psprln%)
'set the bit
            bitmap(blk%, wrdoffset%) = bitmap(blk%, wrdoffset%) OR msk%(byteinwrd%, bitinbyte%)
        END IF
END SUB

