'************************* QBHP.BAS *************************
'  U. S. Geological Survey Computer Program Module QBHP.BAS
'    definitions and graphics routines for HP GL plotters
' $INCLUDE: 'disclaim.inc'
'*************************************************************************
' $INCLUDE: 'jk2dplt.inc'

DIM SHARED penmap%(16)            'pen definitions
DIM SHARED tkp$                         'plot string
DIM SHARED xh, yh, ph$, tol             'pen loc and status
DIM SHARED errocc%                      'for error handling
DIM SHARED pfilnum%, tkdelay%           'comm port file no
'functions to be called externally
DECLARE FUNCTION HPWsOpen% (devno%)
DECLARE FUNCTION HPWsClose% ()
DECLARE FUNCTION HPDevOpen% (devno%)
DECLARE FUNCTION HPDevclr% ()
DECLARE SUB HPDevCmt (row%, col%, llen%, TEXT$)
DECLARE FUNCTION HPDevEnd% ()
DECLARE FUNCTION HPDevMov% (xo, yo, xn, yn, p%)
DECLARE SUB HPDevPen (spen%)

'internal functions
DECLARE SUB HPPenUp ()
DECLARE SUB HPPenDown ()
DECLARE FUNCTION HPSendString% (p%)
DECLARE SUB HPWaitBuf ()
DECLARE SUB HPDelay (tkdelay%)

'only subs are in this module
END
                 
'error handler
Seterr:
  errocc% = -1
  RESUME NEXT

SUB HPDelay (tkdelay%)
        IF tkdelay% <= 0 THEN tkdelay% = 1
        dinc = 1 / tkdelay%
        FOR tkdly = 0 TO 1 STEP dinc
          tmp = SIN(tkdly)
        NEXT tkdly
END SUB

FUNCTION HPDevclr%
        errocc% = 0
        ON ERROR GOTO Seterr
'initializes a plot
        PRINT #pfilnum%, "IN;"; CHR$(27); ".L"
        IF NOT errocc% THEN
          INPUT #pfilnum%, l
          CALL HPDelay(tkdelay%)
          PRINT #pfilnum%, CHR$(27); ".@1024:;"
'get paper size again just to check
          PRINT #pfilnum%, "OP;"
          INPUT #pfilnum%, il, ib, ir, it
          CALL HPDelay(tkdelay%)
          dev.scr.l = il                  'small paper size
          dev.scr.b = ib
          dev.scr.r = ir
          dev.scr.t = it
          CALL HPDelay(tkdelay%)
          CALL HPWaitBuf
'initialize plot instruction string to lift pen
          tkp$ = "PU"
          ph$ = ""
        END IF
        ON ERROR GOTO 0
        HPDevclr% = errocc%
END FUNCTION

DEFINT I
SUB HPDevCmt (row%, col%, llen%, TEXT$)
        LOCATE row%, col%
        PRINT SPACE$(llen%);
        LOCATE row%, col%
        PRINT TEXT$;
END SUB

DEFSNG I
FUNCTION HPDevEnd%
'plot termination routine
'endplot return - sends last plot string
       
        IF RIGHT$(tkp$, 1) <> ";" THEN tkp$ = tkp$ + ";"
        tkp$ = tkp$ + "SP0;OE;"
        st.spen = 0
        tmperr% = HPSendString%(999)
        INPUT #pfilnum%, l
        HPDevEnd% = tmperr%
        
END FUNCTION

FUNCTION HPDevMov% (xo, yo, xn, yn, p%)
'routine to format instructions for device and send to device
       
        IF ABS(p% = 2) OR ABS(p% = 999) THEN
'draw case
          IF ABS(p%) = 2 THEN
'move pen to start pos if necessary
            IF ABS(xo - xh) > tol OR ABS(yo - yh) > tol THEN
              IF ph$ <> "PU" THEN CALL HPPenUp ELSE tkp$ = tkp$ + ","
              tkp$ = tkp$ + STR$(xo) + "," + STR$(yo)
            END IF
'draw to new position
            IF ph$ <> "PD" THEN CALL HPPenDown ELSE tkp$ = tkp$ + ","
            tkp$ = tkp$ + STR$(xn) + "," + STR$(yn)
'end of plot case
          ELSE
            IF ph$ <> "PU" THEN CALL HPPenUp ELSE tkp$ = tkp$ + ","
            tkp$ = tkp$ + STR$(xn) + "," + STR$(yn)
          END IF
        xh = xn
        yh = yn
        END IF
'send string and hold last pen position in any case
        
        HPDevMov% = HPSendString%(p%)
END FUNCTION

FUNCTION HPDevOpen% (devno%)
        tmperr% = 0
'setting prms for HP 7550A plotter
'initialize plot string and pen status
        tkp$ = ""
        ph$ = ""
        xh = 0
        yh = 0
        st.spen = 0
        tmperr% = 0
        IF st.pws <> devno% THEN tmperr% = HPWsOpen(devno%)
        IF tmperr% THEN
          HPDevOpen% = -1
        ELSE
          HPDevOpen% = 0
        END IF
END FUNCTION

DEFINT I
SUB HPDevPen (spen%)
'subroutine for newpen
're-assigns pen if bad selection
'to avoid changing spen%
        IF spen% >= 0 THEN tpen% = spen% ELSE tpen% = 1
        tpen% = penmap%(((tpen% - 1) MOD dev.npen%) + 1)
        IF tpen% <> st.spen THEN
          tkp$ = tkp$ + ";PU;SP" + RIGHT$(STR$(tpen%), 1)
          st.spen = tpen%
          ph$ = ""
        END IF
END SUB

DEFSNG I
SUB HPPenDown
'subroutine to start PD sequence
        tkp$ = tkp$ + ";PD"
        ph$ = "PD"
END SUB

SUB HPPenUp
'subroutine to start PU sequence
        tkp$ = tkp$ + ";PU"
        ph$ = "PU"
END SUB

FUNCTION HPSendString% (p%)
'to send plot instruction string to plotter
        errocc% = 0

        NBYTE = LEN(tkp$)
        IF ((NBYTE >= 200) OR (p% = 999)) THEN
          ON ERROR GOTO Seterr
          IF (NOT errocc%) THEN
            DO
              PRINT #pfilnum%, CHR$(27); ".B"
              INPUT #pfilnum%, TKBUF%
              IF TKBUF% < NBYTE + 2 THEN CALL HPDelay(tkdelay%)
            LOOP WHILE (TKBUF% < NBYTE + 2)
            PRINT #pfilnum%, tkp$;
            tkp$ = ""
            NBYTE = 0
          END IF
        END IF

        ON ERROR GOTO 0
        HPSendString% = errocc%
END FUNCTION

SUB HPWaitBuf STATIC
        PRINT #pfilnum%, CHR$(27); ".L"
        INPUT #pfilnum%, l
END SUB

FUNCTION HPWsClose%
        IF pfilnum% <> 0 THEN CLOSE pfilnum%
        pfilnum% = 0
        st.pws = 0
        HPWsClose% = 0
END FUNCTION

FUNCTION HPWsOpen% (devno%)
'setting prms for HP GL GRAPHICS
        tkdelay% = 100        'set now for 80386 speed
'first get comm port parms from file "config.hp" and open port
        errocc% = 0
        tmpnum% = FREEFILE
        ON ERROR GOTO Seterr
        tfil$ = "CONFIG.HP"
        a$ = ENVIRON$("JKPLT")
        IF a$ <> "" THEN tfil$ = a$ + tfil$
        OPEN "i", #tmpnum%, tfil$
        IF NOT errocc% THEN INPUT #tmpnum%, config$ ELSE errno% = 1
        CLOSE #tmpnum%
'open comm port and initialize plotter
        IF NOT errocc% THEN
          pfilnum% = FREEFILE
          OPEN config$ FOR RANDOM AS #pfilnum%
          IF NOT errocc% THEN
            PRINT #pfilnum%, "IN;"; CHR$(27); ".L"
            IF NOT errocc% THEN
              INPUT #pfilnum%, l
              CALL HPDelay(tkdelay%)
'set hardware handshake
              PRINT #pfilnum%, CHR$(27); ".@1024:"
              CALL HPDelay(tkdelay%)
'get type of plotter
              PRINT #pfilnum%, "OI;"
              INPUT #pfilnum%, tmp$
              dev.id = "HP" + tmp$
              CALL HPDelay(tkdelay%)
'get paper size
              PRINT #pfilnum%, "OP;"
              INPUT #pfilnum%, il, ib, ir, it
              CALL HPDelay(tkdelay%)
              dev.scr.l = il                'small paper size
              dev.scr.b = ib
              dev.scr.r = ir
              dev.scr.t = it
            END IF
          END IF
        END IF
'now set device parameters
        dev.gmode = 1
        dev.upi.x = 1016              'units per inch
        dev.upi.y = 1016
        dev.asp = 1                   'aspect ratio
        dev.yinv = 0                  'not inverted y coordinate
        dev.inch = -1                 'inch-type plotter
        dev.txscr = 0                 'for leaving graphics mode
        dev.npen = 8                  'no of pens-wrong for Sprint,
                                        'but should be ok for most others
        tol = .0001                   'tolerance for same pen position
'pen color mapping variable
        FOR i% = 0 TO 8
          penmap%(i%) = i%
        NEXT i%

        ON ERROR GOTO 0
        st.pws = devno%
        HPWsOpen% = errocc%              'indicate error for return
END FUNCTION

