'************************* QBJKF.BAS *************************
'  U. S. Geological Survey Computer Program Module QBJKF.BAS
'  definitions and graphics routines for JKPLOT intermediate
'  plot files - inefficient version -all output goes through
'  DevMov calls
' $INCLUDE: 'disclaim.inc'
'*************************************************************************
' $INCLUDE: 'jk2dplt.inc'
DECLARE FUNCTION JKWsOpen% (devno%)
DECLARE FUNCTION JKWsClose% ()
DECLARE FUNCTION JKDevOpen% (devno%)
DECLARE FUNCTION JKDevclr% (x, y)
DECLARE SUB JKDevCmt (row%, col%, llen%, TEXT$)
DECLARE FUNCTION JKDevEnd% ()
DECLARE FUNCTION JKDevMov% (xo, yo, xn, yn, p%)
DECLARE SUB JKDevPen (spen%)
DECLARE SUB SetJKfnam (a$)
DECLARE FUNCTION JKpplots (x, y)

DIM SHARED penmap%(16)            'pen definitions

DECLARE FUNCTION movscl% (x, y, xo, yo, xn, yn)
DIM SHARED jkfno%, jkfnam$
DIM SHARED xh, yh, tol          'pen pos and placement tol
END
'error handlers
SetErr:
  BEEP
  errocc% = -1
  RESUME NEXT

FUNCTION JKDevclr% (x, y)
        errocc% = 0
        ON ERROR GOTO SetErr
        IF jkfno% <> 0 THEN
          CLOSE jkfno%
        END IF
        IF jkfnam$ <> "" THEN
'initializes a plot
          IF NOT st.clconly THEN
            jkfno% = FREEFILE
            OPEN "o", #jkfno%, jkfnam$
            PRINT #jkfno%, "PLOTS,"; x; ","; y
            dev.scr.r = x
            dev.scr.t = y
          END IF
        ELSE
          errocc% = -1
        END IF
        ON ERROR GOTO 0
        pserr% = errocc%
        JKDevclr% = errocc%
END FUNCTION

SUB JKDevCmt (row%, col%, llen%, txt$)
        IF jkfno% <> 0 THEN
          PRINT #jkfno%, "COMMENT,"; txt$
          LOCATE row%, col%
          PRINT txt$;
        END IF
END SUB

FUNCTION JKDevEnd%
          CLOSE #jkfno%
          jkfno% = 0
          jkfnam$ = ""
          JKDevEnd% = 0
END FUNCTION

FUNCTION JKDevMov% (xo, yo, xn, yn, p%)
        IF jkfno% <> 0 THEN
          IF ABS(p%) = 2 OR ABS(p%) = 999 THEN
            IF ABS(xh - xo) > tol OR ABS(yh - yo) > tol THEN
              PRINT #jkfno%, "PLOT,"; xo; ","; yo; ","; 3
            END IF
          END IF
          PRINT #jkfno%, "PLOT,"; xn; ","; yn; ","; ABS(p%)
        END IF
        xh = xn
        yh = yn
END FUNCTION

FUNCTION JKDevOpen% (devno%)
'setting prms for JKPLOT intermediate plot file
        tmperr% = 0
        IF st.pws <> devno% THEN tmperr% = JKWsOpen(devno%)
        IF tmperr% THEN
          JKDevOpen% = -1
        ELSE
          JKDevOpen% = 0
        END IF
END FUNCTION

SUB JKDevPen (spen%)
'subroutine for newpen
're-assigns pen if bad selection
'to avoid changing spen%
        IF spen% >= 0 THEN tpen% = spen% ELSE tpen% = 1
        tpen% = penmap%(((tpen% - 1) MOD dev.npen%) + 1)
        IF tpen% <> st.spen THEN
          IF jkfno% <> 0 THEN
            PRINT #jkfno%, "NEWPEN,"; spen%
          END IF
          st.spen = tpen%
        END IF
END SUB

SUB JKPlots (x, y, tkerr%)
        ON ERROR GOTO SetErr
        PRINT #jkfno%, "PLOTS,"; x; ","; y
        ON ERROR GOTO 0
        tkerr% = errocc%
END SUB

FUNCTION JKpplots (x, y)
        PRINT #jkfno%, "PLOTS,"; x; ","; y
END FUNCTION

FUNCTION JKWsClose%
        IF jkfno% <> 0 THEN CLOSE jkfno%
        jkfno% = 0
        st.pws = 0
        JKWsClose% = 0
END FUNCTION

FUNCTION JKWsOpen% (devno%)
'to specify output device is an JKPLOT intermediate plot file
'set permanent specs here only - file is opened with a call to devclr
        dev.id = "JKPLTFIL"
'now set device parameters
        dev.gmode = 0
        dev.scr.l = 0
        dev.scr.b = 0
        dev.scr.r = 8
        dev.scr.t = 10
        dev.upi.x = 1              'units per inch
        dev.upi.y = 1
        dev.asp = 1                   'aspect ratio
        dev.yinv = 0                  'not inverted y coordinate
        dev.inch = -1                 'inch-type plotter
        dev.txscr = 0                 'for leaving graphics mode
        dev.npen = 16                  'no of pens-use max=16
'pen color mapping variable
        FOR i% = 0 TO 16
          penmap%(i%) = i%
        NEXT i%
        xh = -1E+20
        yh = -1E+20
        tol = .0001
        st.pws = JKFIL
        JKWsOpen% = 0
END FUNCTION

SUB SetJKfnam (nam$)
        jkfnam$ = nam$
END SUB

