'************************* QBLASER.BAS *************************
'  U. S. Geological Survey Computer Program Module QBLASER.BAS
'    definitions and graphics routines for HP Laser Printers
' $INCLUDE: 'disclaim.inc'
'*************************************************************************
' $INCLUDE: 'jk2dplt.inc'

DIM SHARED penmap%(16)                  'pen definitions
DIM SHARED tkp$, pbyte%                 'plot string
DIM SHARED xh, yh, ph$, tol             'pen loc and status
DIM SHARED errocc%                      'for error handling
DIM SHARED pfilnum%                     'comm port file no
DIM SHARED lsfno%, lsfnam$             'for file output
'functions to be called externally
DECLARE FUNCTION LSWsOpen% (devno%)
DECLARE FUNCTION LSWsClose% ()
DECLARE FUNCTION LSDevOpen% (devno%)
DECLARE FUNCTION LSDevclr% ()
DECLARE SUB LSDevCmt (row%, col%, llen%, TEXT$)
DECLARE FUNCTION LSDevEnd% ()
DECLARE FUNCTION LSDevMov% (xo, yo, xn, yn, p%)
DECLARE SUB LSDevPen (spen%)
DECLARE SUB SetLSfnam (nam$)
'internal functions
DECLARE SUB LSPenUp ()
DECLARE SUB LSPenDown ()
DECLARE FUNCTION LSSendString% (p%)

'only subs are in this module
END
                 
'error handler
SetErr:
  errocc% = -1
  RESUME NEXT

FUNCTION LSDevclr%
        errocc% = 0
        a$ = CHR$(27)
        ON ERROR GOTO SetErr
'if file output, open file
        IF st.pws = LSFIL THEN
          IF lsfno% <> 0 THEN
            CLOSE lsfno%
          END IF
          IF lsfnam$ <> "" THEN
'open output file
            IF NOT st.clconly THEN
              pfilnum% = FREEFILE
              lsfno% = pfilnum%
              OPEN "o", #lsfno%, lsfnam$
            END IF
          ELSE
            errocc% = -1
          END IF
        END IF
'initializes a plot
        IF NOT errocc% THEN
          PRINT #pfilnum%, a$; "E"; a$; "%0BIN;";
          IF NOT errocc% THEN
'initialize plot instruction string to lift pen
            tkp$ = "LA2,6;SP1;PW.2;PU"
            st.spen = 1
            ph$ = ""
'set pen hold position to nonsense to insure first move
            xh = -1E+20
            yh = -1E+20
          END IF
        END IF
        ON ERROR GOTO 0
        LSDevclr% = errocc%
END FUNCTION

DEFINT I
SUB LSDevCmt (row%, col%, llen%, TEXT$)
        LOCATE row%, col%
        PRINT SPACE$(llen%);
        LOCATE row%, col%
        PRINT TEXT$;
END SUB

DEFSNG I
FUNCTION LSDevEnd%
'plot termination routine
'endplot return - sends last plot string
       
        IF RIGHT$(tkp$, 1) <> ";" THEN tkp$ = tkp$ + ";"
        tkp$ = tkp$ + CHR$(27) + "%0A" + CHR$(27) + "E"
        tmperr% = LSSendString%(999)
        IF st.pws = LSFIL THEN
          CLOSE #lsfno%
          lsfno% = 0
        END IF
        LSDevEnd% = tmperr%
END FUNCTION

FUNCTION LSDevMov% (xo, yo, xn, yn, p%)
'routine to format instructions for device and send to device
       
        IF ABS(p% = 2) OR ABS(p% = 999) THEN
'draw case
          IF ABS(p%) = 2 THEN
'move pen to start pos if necessary
            IF ABS(xo - xh) > tol OR ABS(yo - yh) > tol THEN
              IF ph$ <> "PU" THEN CALL LSPenUp ELSE tkp$ = tkp$ + ","
              tkp$ = tkp$ + STR$(CINT(xo)) + "," + STR$(CINT(yo))
            END IF
'draw to new position
            IF ph$ <> "PD" THEN CALL LSPenDown ELSE tkp$ = tkp$ + ","
            tkp$ = tkp$ + STR$(CINT(xn)) + "," + STR$(CINT(yn))
'end of plot case
          ELSE
            IF ph$ <> "PU" THEN CALL LSPenUp ELSE tkp$ = tkp$ + ","
            tkp$ = tkp$ + STR$(CINT(xn)) + "," + STR$(CINT(yn))
          END IF
        xh = xn
        yh = yn
        END IF
'send string and hold last pen position in any case
        
        LSDevMov% = LSSendString%(p%)
END FUNCTION

FUNCTION LSDevOpen% (devno%)
        tmperr% = 0
'setting prms for Laser printer
'initialize plot string and pen status
        tkp$ = ""
        ph$ = ""
        xh = 0
        yh = 0
        st.spen = 0
        tmperr% = 0
        IF st.pws <> devno% THEN tmperr% = LSWsOpen(devno%)
        IF tmperr% THEN
          LSDevOpen% = -1
        ELSE
          LSDevOpen% = 0
        END IF
END FUNCTION

SUB LSDevPen (spen%)
'subroutine for newpen
're-assigns pen if bad selection
'to avoid changing spen%
        IF spen% >= 0 THEN tpen% = spen% ELSE tpen% = 1
        tpen% = penmap%(((tpen% - 1) MOD dev.npen%) + 1)
        IF tpen% <> st.spen THEN
          IF tpen% = 1 THEN
            penw = .2
          ELSE
            penw = .05 * tpen%
          END IF
          tkp$ = tkp$ + ";PU;PW" + STR$(penw)
          st.spen = tpen%
          ph$ = ""
        END IF
END SUB

SUB LSPenDown
'subroutine to start PD sequence
        tkp$ = tkp$ + ";PD"
        ph$ = "PD"
END SUB

SUB LSPenUp
'subroutine to start PU sequence
        tkp$ = tkp$ + ";PU"
        ph$ = "PU"
END SUB

FUNCTION LSSendString% (p%)
'to send plot instruction string to plotter
        errocc% = 0
        ON ERROR GOTO SetErr
        nbyte = LEN(tkp$)
        IF ((nbyte >= pbyte%) OR (p% = 999)) THEN
          PRINT #pfilnum%, tkp$
          tkp$ = ""
          nbyte = 0
        END IF
        ON ERROR GOTO 0
        LSSendString% = errocc%
END FUNCTION

FUNCTION LSWsClose%
        IF pfilnum% <> 0 THEN CLOSE pfilnum%
        pfilnum% = 0
        lsfno% = 0
        st.pws = 0
        LSWsClose% = 0
END FUNCTION

FUNCTION LSWsOpen% (devno%)
'setting prms for HP GL GRAPHICS on laser printer
'first get comm port parms from file "config.las" and open port
        errocc% = 0
        tmpnum% = FREEFILE
        ON ERROR GOTO SetErr
       
        IF devno% = HPLAS THEN
          tfil$ = "CONFIG.LAS"
          a$ = ENVIRON$("JKPLT")
          IF a$ <> "" THEN tfil$ = a$ + tfil$
          OPEN "i", #tmpnum%, tfil$
          IF NOT errocc% THEN INPUT #tmpnum%, config$ ELSE errno% = 1
          CLOSE #tmpnum%
'open comm port and initialize plotter
          IF NOT errocc% THEN
            pfilnum% = FREEFILE
            OPEN config$ FOR RANDOM AS #pfilnum%
          END IF
        END IF
        IF NOT errocc% THEN
          dev.scr.l = 0
          dev.scr.b = 0
          dev.scr.r = 8128
          dev.scr.t = 10160
        END IF
'now set device parameters
        dev.gmode = 1
        dev.upi.x = 1016              'units per inch
        dev.upi.y = 1016
        dev.asp = 1                   'aspect ratio
        dev.yinv = 0                  'not inverted y coordinate
        dev.inch = -1                 'inch-type plotter
        dev.txscr = 0                 'for leaving graphics mode
        dev.npen = 16                  'no of pens - #1 = .2
                                      '#2-9 = .05*penno
        tol = 1                       'tolerance for same pen position
                                        'in plotter units (1016plu=1in)
'pen color mapping variable
        penmap%(0) = 0
        FOR i% = 1 TO 16
          penmap%(i%) = i%
        NEXT i%

        ON ERROR GOTO 0
        IF devno% = HPLAS THEN
          dev.id = "LASDIRECT"
          pbyte% = 200
        ELSE
          dev.id = "LASFILE"
          pbyte% = 0
        END IF
        st.pws = devno%
        pserr% = errocc%
        LSWsOpen% = errocc%              'indicate error for return
END FUNCTION

SUB SetLSfnam (nam$)
        lsfnam$ = nam$
END SUB

