'************************* QBSCR.BAS *************************
'  U. S. Geological Survey Computer Program Module QBSCR.BAS
'definitions and graphics routines for pc cga, ega and vga screens
' $INCLUDE: 'disclaim.inc'
'*************************************************************************
' $INCLUDE: 'jk2dplt.inc'

DIM SHARED errocc%
DIM SHARED upen%

DECLARE FUNCTION PCWsOpen% (devno%)
DECLARE FUNCTION PCWsClose% ()
DECLARE FUNCTION PCDevOpen% (devno%)
DECLARE FUNCTION PCDevclr% ()
DECLARE SUB PCDevCmt (row%, col%, llen%, txt$)
DECLARE FUNCTION PCDevEnd% ()
DECLARE FUNCTION PCDevMov% (xo, yo, xn, yn, p%)
DECLARE SUB PCDevPen (spen%)
DECLARE SUB PCFill (xo, yo, xn, yn, p%)
'external subroutine called
DECLARE SUB CloseWs (devno%)

'default color palettes and pen mappings
'sixteen colors in each palette
'penmap has 17 values - 0 and 1 are for standard mapping without color
'penmap 2-17 give 16 colors in spectrum order (last 2 white) - user
'  can make the 1 unit increment in the application program
'  17-th color included so that parameters can be set in application
'  program for HP 16 color (dark and light shade on 8 pens)
'vga color palette numbers
palset:

'black
DATA 0,0,0
'blue
DATA 0,0,60
'green
DATA 0,30,0
'lt blue
DATA 20,40,60
'red
DATA 48,2,2
'purple
DATA 25,10,25
'orange
DATA 60,30,10
'white
DATA 45,45,45
'yellow
DATA 50,50,0
'brown
DATA 20,8,10
'navy
DATA 0,0,35
'pink
DATA 60,25,40
'dkred
DATA 40,4,1
'ltgreen
DATA 8,50,8
'ltyellow
DATA 60,60,0
'ltred
DATA 60,5,15

'definitions and mappings for color definition on ega screen
        DATA -1,9,2,11,4,40,38,7,22,32,1,53,12,18,54,44
        DATA 0,7,9,5,10,1,3,2,13,8,14,6,12,4,15,11,7,7
'palette sets nice spectrum of colors, 0-7 are good for text mode also
'pnmap maps the nice spectrum into order
'necessary because of making 0-7 nice for text mode
'colors 0,1 reserved for black and white
'spectrum sequence starts with 2 and goes to 17 (16 colors)
END

Seterr:
        errocc% = -1
        RESUME NEXT
palerr:
        RESUME NEXT

FUNCTION PCDevclr%
'puts screen in graphics mode and clears
        errocc% = 0
        ON ERROR GOTO Seterr
        SCREEN dev.gmode
        ON ERROR GOTO palerr
          PALETTE USING vpal&(0)
        ON ERROR GOTO 0
        CLS
        IF (errocc% = 0) THEN
          PCDevclr% = 0
        ELSE
          PCDevclr% = -1
        END IF
END FUNCTION

SUB PCDevCmt (row%, col%, llen%, txt$)
'not applicable because we are drawing on the screen

END SUB

FUNCTION PCDevEnd%
'screen/plot termination routine
hld:    a$ = INKEY$: IF a$ <> CHR$(27) GOTO hld
        SCREEN dev.txscr
        ON ERROR GOTO palerr
        IF dev.gmode <> 2 THEN PALETTE USING pal%(0)
        ON ERROR GOTO 0
        PCDevEnd% = 0
END FUNCTION

FUNCTION PCDevMov% (xo, yo, xn, yn, p%)
'routine to format instructions for device and send to device
        IF ABS(p%) = 2 THEN
'draw
          x1 = CINT(xo)
          y1 = CINT(yo)
          x2 = CINT(xn)
          y2 = CINT(yn)
          IF x1 < dev.scr.l THEN x1 = dev.scr.l
          IF x1 > dev.scr.r THEN x1 = dev.scr.r
          IF y1 < dev.scr.b THEN y1 = dev.scr.b
          IF y1 > dev.scr.t THEN y1 = dev.scr.t
          IF x2 < dev.scr.l THEN x2 = dev.scr.l
          IF x2 > dev.scr.r THEN x2 = dev.scr.r
          IF y2 < dev.scr.b THEN y2 = dev.scr.b
          IF y2 > dev.scr.t THEN y2 = dev.scr.t
 
          LINE (x1, y1)-(x2, y2), upen%
         ELSE
'move
'trf point to move to itkxo,itkyo if necessary for driver
        END IF
        PCDevMov% = 0
        END FUNCTION

FUNCTION PCDevOpen% (devno%)

'plotter specification and initialization
        IF st.pws <> devno% THEN PCDevOpen% = PCWsOpen%(devno%)

END FUNCTION

SUB PCDevPen (spen%)
'subroutine for newpen
're-assigns pen if bad selection

        IF spen% >= 0 THEN                      'to avoid changing spen%
          tpen% = spen%
        ELSE
          tpen% = 1
        END IF

        upen% = pnmap%(((tpen% - 1) MOD dev.npen) + 1)
        st.spen = tpen%
END SUB

FUNCTION PCWsClose%
        st.pws = 0
        PCWsClose% = 0
END FUNCTION

FUNCTION PCWsOpen% (devno%)
'to specify an output device
'to insure that user doesn't change devices in middle of plot
'first read in palette and penmapping constants
        IF st.pws <> 0 THEN CALL CloseWs(st.pws)
        REDIM pnmap%(17)
        REDIM vpal&(15)
        REDIM pal%(15)
        DIM a(15, 2)
        RESTORE palset
        tmp% = 0
'vga color constants
        FOR i% = 0 TO 15
          FOR j% = 0 TO 2
            READ a(i%, j%)
          NEXT j%
        NEXT i%
'color ega
        FOR i% = 0 TO 15
          READ pal%(i%)
        NEXT i%
'penmap for spectrum
        FOR i% = 0 TO 17
          READ pnmap%(i%)
        NEXT i%
'if color vga or color mcga then replace ega palette with vga one
        IF (devno% = PCVGA OR devno% = PCMCGA) THEN
          FOR i% = 0 TO 15
            vpal&(i%) = a(i%, 0) + 256 * a(i%, 1) + 65536 * a(i%, 2)
          NEXT i%
        ELSE
          FOR i% = 0 TO 15
            vpal&(i%) = pal%(i%)
          NEXT i%
        END IF
'if cga or monochrome monitor then replace penmap with 1's
        IF ((devno% = PCCGA) OR (PCEGAM <= devno% AND devno% <= PCHERC)) THEN
          FOR i% = 2 TO 17
            pnmap%(i%) = 1
          NEXT i%
        END IF
'setting prms for PC GRAPHICS
'assign characteristics common to all PC screens
        dev.scr.l = 0                   'small paper size
        dev.scr.b = 0
        dev.scr.r = 639    'except for Herc or color MCGA            
        dev.upi.x = 1                       'units per inch
        dev.upi.y = 1
        dev.yinv = -1                       'inverted y coordinate
        dev.inch = 0                        'not inch-type plotter
        dev.txscr = 0                       'for leaving graphics mode
'assign characteristics that differ according to configuration
'cga,ega,vga available
         SELECT CASE devno%
           CASE PCCGA
             dev.id = "PCCGA" 'device id
             dev.gmode = 2
             dev.scr.t = 199
             dev.npen = 2                       'no of pens
           CASE PCEGA, PCEGAM
             dev.id = "PCEGA" 'device id
             dev.gmode = 9
             dev.scr.t = 349
             dev.npen = 16                       'no of pens
             IF devno% = PCEGAM THEN
               dev.gmode = 10
               dev.npen = 2
             END IF
           CASE PCVGA, PCVGAM
             dev.id = "PCVGA" 'device id
             dev.gmode = 12
             dev.scr.t = 479
             dev.npen = 16                       'no of pens
             IF devno% = PCVGAM THEN
               dev.gmode = 11
               dev.npen = 2
             END IF
           CASE PCMCGA, PCMCGAM
             dev.id = "PCMCGA" 'device id
             dev.asp = 1                         'aspect ratio
             IF devno% = PCMCGAM THEN
               dev.scr.t = 479
               dev.gmode = 11
               dev.npen = 2
             ELSE
               dev.gmode = 13
               dev.scr.r = 199
               dev.scr.t = 319
               dev.npen = 16                     'no of pens
             END IF
           CASE PCHERC
             dev.id = "PCHERC" 'device id
             dev.gmode = 3
             dev.scr.r = 719
             dev.scr.t = 347
             dev.npen = 2                       'no of pens
           CASE ELSE
             tmp% = -1
         END SELECT
         dev.asp = (4 * (dev.scr.t + 1)) / (3 * (dev.scr.r + 1))
         IF tmp% <> 0 THEN
           st.pws = tmp%
           PCWsOpen% = -1
         ELSE
           st.pws = devno%
           PCWsOpen% = 0
         END IF
END FUNCTION

