'************************* QF1.BAS *************************
'  U. S. Geological Survey Computer Program Module QF1.BAS
'       simple version of file-reading device driver
' $INCLUDE: 'disclaim.inc'
'*************************************************************************
'  $INCLUDE: 'jk2dplt.inc'
'  $INCLUDE: 'jk2dint.inc'
'  $INCLUDE: 'ax2d.inc'
'  $INCLUDE: 'jk3dplt.inc'
'  $INCLUDE: 'jk3dint.inc'
'  $INCLUDE: 'ax3d.inc'
TYPE fdrvT
  odevp         AS INTEGER
  inch          AS INTEGER
  centr         AS INTEGER
  rot           AS INTEGER
  rotd          AS INTEGER
  wins          AS INTEGER
  win           AS RectT
  fvp           AS RectT
  fupi          AS PointT
  fasp          AS SINGLE
  aspoff        AS INTEGER
  vps           AS INTEGER
  vp            AS RectT
  scl           AS INTEGER
  sclmul        AS PointT
  dfscl         AS PointT
  maxscl        AS PointT
  drw           AS INTEGER
END TYPE
TYPE irectT
  l AS INTEGER
  b AS INTEGER
  r AS INTEGER
  t AS INTEGER
END TYPE
TYPE ipointT
  x AS INTEGER
  y AS INTEGER
END TYPE

DECLARE SUB DevLst (ndev%, lst%(), lst$(), echr%())
DECLARE SUB dprmscrn (fdrv AS fdrvT, xpage!, ypage!)
DECLARE FUNCTION getf% (noff%, nfin%, nfil$(), flnm%(), nfil%)
DECLARE SUB getscl ()
DECLARE SUB getswin ()
DECLARE SUB getvp ()
DECLARE SUB header ()
DECLARE FUNCTION mainmn% (plin%)
DECLARE FUNCTION odevmn% (dv%, nfil$(), prmt$(), flnm%(), clrmap%())
DECLARE FUNCTION optinp% ()
DECLARE FUNCTION plotem% (nfil%, nfil$(), ppen%())
DECLARE FUNCTION precalc% (f AS fdrvT, clconly%)
DECLARE SUB ReadMat (f%, r%, c%, mat!())
DECLARE SUB setpal ()
DECLARE FUNCTION VideoHardware% ()
DECLARE FUNCTION waitkey$ ()


        DEF fnmin (a, b) = -b * (b < a) - a * (a < b) - a * (a = b)
        DEF fnmax (a, b) = -b * (b > a) - a * (a > b) - a * (a = b)

DIM SHARED inpdev AS devT, odev AS devT
DIM SHARED fdrv AS fdrvT, frst%
DIM SHARED xpage, ypage
DIM SHARED lpal&(15)
DIM SHARED clrmap%(15)
DIM SHARED nodev%, dvlst%(10), dvlst$(10), echr%(10)
DIM pp AS PipeT
DIM elin$(3)
DIM nfil$(12), ppen%(12), prmt$(12), flnm%(12)
DIM SHARED filerrn%, pierr%
CLEAR , , 2000
'color swap array to allow low screen pens to be brighter
'this manipulates the automatic spectrum sequence mapping in the plot system
clrdat:
        DATA 0,7,4,2,3,6,8,15,13,1,10,12,11,14,5,9
'main control driver for file-reading plot driver - version m1
'find screen capabilities available
        CALL DevLst(nodev%, dvlst%(), dvlst$(), echr%())
        psscrn% = VideoHardware% 'plot system equivalent-req cga at least
        fdrv.odevp = psscrn%     'initial output selection is to screen
        CALL OpenWs(fdrv.odevp, tkerr%)
        odev = dev
        CALL CloseWs(fdrv.odevp)
        FOR i% = 0 TO nodev% - 1
          IF dvlst%(i%) = fdrv.odevp THEN tmp% = i%
        NEXT i%
        odevchr$ = dvlst$(tmp%)
'reduce to ega if vga present so that main selection screen will work
        IF psscrn% = PCVGA THEN
          pselscrn% = PCEGA
        ELSE
          pselscrn% = psscrn%
        END IF
        CALL OpenWs(pselscrn%, tkerr%)
        inpdev = dev
        FOR i% = 0 TO 15
          lpal&(i%) = vpal&(i%)
        NEXT i%
        CALL CloseWs(pselscrn%)
        SCREEN inpdev.txscr
        CALL setpal
'read the color swap variable
RESTORE clrdat
        FOR i% = 0 TO 15
          IF fdrv.odevp <> 2 THEN
            READ clrmap%(i%)
          ELSE
            clrmap%(i%) = 7
          END IF
        NEXT i%

'write program identifier on screen
        CALL header
'see if font file has been read
        IF st.font < 0 OR st.cfont < 0 THEN
          COLOR WHITE, BLACK
          CLS
          elin$(1) = "FONT FILE CANNOT BE FOUND"
          elin$(2) = "plotting can continue ignoring SYMBOL calls"
          elin$(3) = "Press (Q) to quit, any other key to continue"
          CLS
          FOR i% = 1 TO 3
            LOCATE 3 + i%, .5 * (79 - LEN(elin$(i%)))
            PRINT elin$(i%)
          NEXT i%
          a$ = waitkey$
        END IF
        IF UCASE$(a$) = "Q" THEN STOP
'initialize the plot file list
        nfil% = 0
        FOR i% = 0 TO 9
          ppen%(i%) = 1
          nfil$(i%) = ""
        NEXT i%
'initialize the option parameters
        fdrv.centr = 0
        fdrv.rot = 0
        fdrv.rotd = 0
        fdrv.inch = odev.inch
        IF odev.inch THEN fdrv.scl = -1 ELSE fdrv.scl = 0
        fdrv.wins = 0
        a% = SetRect%(0, xpage, 0, ypage, fdrv.win)
        fdrv.vps = 0
        fdrv.vp = odev.scr
        fdrv.fvp = odev.scr
        fdrv.fupi = odev.upi
        fdrv.fasp = odev.asp
        fdrv.sclmul.x = 1
        fdrv.sclmul.y = 1
        fdrv.aspoff = 0
        nfil% = 0
        plin% = 1
        odvmn% = fdrv.odevp
'loop for main menu
'need to know action and device wanted
        xit% = 0
        WHILE (NOT xit%)
'main menu screen
          SCREEN inpdev.txscr
          CALL setpal
          COLOR WHITE, BLACK
          CLS
          COLOR BLACK, LTBLUE
          LOCATE 1, 1
          PRINT SPACE$(78);
          a$ = "JKPLOT FILE PLOTTING PROGRAM"
          LOCATE 1, 40 - INT(.5 * LEN(a$))
          PRINT a$;
          LOCATE 16, 5
          PRINT "        Output Device         ";
          COLOR BLACK, WHITE
          LOCATE 17, 5
          PRINT SPACE$(30);
          LOCATE 17, 19 - INT(.5 * LEN(odevchr$))
          PRINT odevchr$;
          COLOR WHITE, BLACK
 'main menu selection
          plin% = mainmn%(plin%)
          SELECT CASE plin%
            CASE 1              'file list
              ftl$ = "JKPLOT Overlay Plot Filename Entry"
              nfin% = 10: noff% = 0
              a% = getf%(noff%, nfin%, nfil$(), flnm%(), nfil%)
              fdrv.win.l = 0
              fdrv.win.r = xpage
              fdrv.win.b = 0
              fdrv.win.t = ypage
            CASE 2              'plotting options and plotting
              IF nfil% <= 0 THEN
                elin$(1) = "NO PLOT FILES SELECTED YET"
                elin$(2) = "at least 1 plot file must be selected"
                elin$(3) = "Press any key to return to menu"
                CLS
                FOR i% = 1 TO 3
                  LOCATE 3 + i%, .5 * (79 - LEN(elin$(i%)))
                  PRINT elin$(i%)
                NEXT i%
                a$ = waitkey$
                ret% = 1
              ELSEIF (fdrv.odevp = HPFIL AND nfil$(10) = "") OR (fdrv.odevp = JKFIL AND nfil$(11) = "") OR (fdrv.odevp = LSFIL AND nfil$(12) = "") THEN
                elin$(1) = "PLOT OUTPUT FILE NOT SELECTED YET"
                elin$(2) = ""
                elin$(3) = "Press any key to return to menu"
                CLS
                FOR i% = 1 TO 3
                  LOCATE 3 + i%, .5 * (79 - LEN(elin$(i%)))
                  PRINT elin$(i%)
                NEXT i%
                a$ = waitkey$
                ret% = 1
              ELSE
                tmptst% = 0
                IF fdrv.odevp = HPFIL OR fdrv.odevp = JKFIL THEN
                  FOR i% = 0 TO nfil% - 1
                    IF nfil$(i%) = nfil$(10) THEN tmptst% = -1
                    IF nfil$(i%) = nfil$(11) THEN tmptst% = -1
                    IF nfil$(i%) = nfil$(12) THEN tmptst% = -1
                  NEXT i%
                END IF
                IF tmptst% THEN
                  elin$(1) = "SAME NAME FOR INPUT AND OUTPUT FILE"
                  elin$(2) = "change one of the file names"
                  elin$(3) = "Press any key to return to menu"
                  CLS
                  FOR i% = 1 TO 3
                    LOCATE 3 + i%, .5 * (79 - LEN(elin$(i%)))
                    PRINT elin$(i%)
                  NEXT i%
                  a$ = waitkey$
                  ret% = 1
                ELSE
                  fdrv.drw = 1
                  SCREEN inpdev.txscr
                  CALL setpal
                  CALL dprmscrn(fdrv, xpage, ypage)   'draw whole menu
                  act% = optinp%
'if act%=1 plot the files, otherwise return to main menu
                  IF act% = 1 THEN
                    sret% = plotem(nfil%, nfil$(), ppen%())
                  END IF
                  IF sret% = -1 THEN
                    elin$(1) = "FATAL ERROR WHILE PLOTTING"
                    elin$(2) = ""
                    elin$(3) = "Press any key to exit to system"
                    CLS
                    FOR i% = 1 TO 3
                      LOCATE 3 + i%, .5 * (79 - LEN(elin$(i%)))
                      PRINT elin$(i%)
                    NEXT i%
                    a$ = waitkey$
                    xit% = -1
                  END IF
                END IF
              END IF
            CASE 3              'output device
              odvmn% = odevmn%(odvmn%, nfil$(), prmt$(), flnm%(), clrmap%())
              IF odvmn% <> fdrv.odevp THEN
                CALL OpenWs(odvmn%, tkerr%)
                IF tkerr% THEN
                  FOR i% = 0 TO nodev% - 1
                    IF dvlst%(i%) = odvmn% THEN tmp% = i%
                    NEXT i%
                    a$ = dvlst$(tmp%)
                  elin$(1) = "ERROR OPENING DEVICE - " + a$
                  elin$(2) = "device not changed"
                  elin$(3) = "Press any key to return to main menu"
                  CLS
                  FOR i% = 1 TO 3
                    LOCATE 3 + i%, .5 * (79 - LEN(elin$(i%)))
                    PRINT elin$(i%)
                  NEXT i%
                  a$ = waitkey$
                  CALL CloseWs(odvmn%)
                  CALL OpenWs(fdrv.odevp, tkerr%)
                  odvmn% = fdrv.odevp
                ELSE
                  odev = dev
                  fdrv.odevp = odvmn%
                  fdrv.rot = 0
                  fdrv.rotd = 0
                  fdrv.inch = odev.inch
                  IF odev.inch THEN fdrv.scl = -1 ELSE fdrv.scl = 0
                  fdrv.vps = 0
                  fdrv.fupi = odev.upi
                  fdrv.fasp = odev.asp
                  fdrv.sclmul.x = 1
                  fdrv.sclmul.y = 1
                  fdrv.vp = odev.scr
                  fdrv.fvp = odev.scr
                  fdrv.aspoff = 0
                  odvmn% = fdrv.odevp
                END IF
                FOR i% = 0 TO nodev% - 1
                  IF dvlst%(i%) = odvmn% THEN tmp% = i%
                NEXT i%
                odevchr$ = dvlst$(tmp%)
              END IF
              IF odvmn% = JKFIL OR odvmn% = HPFIL THEN
                odev = dev
              END IF
              CALL CloseWs(odvmn%)
            CASE 4              'DOS
              CLS
              a$ = "In DOS shell - enter EXIT to return to program"
              a% = 40 - .5 * LEN(a$)
              LOCATE 1, a%
              COLOR WHITE, RED
              PRINT a$;
              COLOR BLACK, WHITE
              LOCATE 3, 1
              SHELL
            CASE 5              'quit after exit check
              elin$(1) = "JKPLOT FILE READING DRIVER TERMINATION"
              elin$(2) = ""
              elin$(3) = "Do you want to exit to DOS? (Y/N)"
              CLS
              FOR i% = 1 TO 3
                LOCATE 3 + i%, .5 * (79 - LEN(elin$(i%)))
                PRINT elin$(i%)
              NEXT i%
              a$ = waitkey$
              IF UCASE$(a$) = "Y" THEN xit% = -1
            CASE ELSE
          END SELECT
        WEND
        CLS
END
filerr:
        filerrn% = -1
        RESUME NEXT
pierr:
        pierrn% = -1
        RESUME NEXT
palerr:
        RESUME NEXT

FUNCTION getf% (noff%, nfin%, nfil$(), flnm%(), nfil%)
        nfil% = 0
        ff% = FREEFILE
'get list of plot files
        ifil$ = "aaa"
        WHILE nfil% < 10 AND ifil$ <> ""
          PRINT "INSERT NAME OF INPUT FILE NO "; nfil% + 1
          PRINT "(BLANK NAME TO END ENTRY)"
          INPUT ifil$
          IF ifil$ <> "" THEN
            ON ERROR GOTO filerr
            filerrn% = 0
            OPEN "i", #ff%, ifil$
            ON ERROR GOTO 0
            IF filerrn% THEN
               PRINT
               PRINT "***** FILE " + ifil$ + " NOT FOUND *****"
            ELSE
              pierr% = 0
              x = 0
              y = 0
              ON ERROR GOTO pierr
              INPUT #ff%, a$, x, y
              ON ERROR GOTO 0
              IF (pierr% OR x = 0 OR y = 0) THEN
                PRINT
                PRINT "***** " + ifil$ + " IS NOT A PROPER PLOT FILE *****"
              ELSE
                IF nfil% = 0 THEN
                  nfil$(nfil%) = ifil$
                  nfil% = nfil% + 1
                  xpage = x
                  ypage = y
                  xph = x
                  yph = y
                ELSE
                  IF x <> xph OR y <> yph THEN
                    PRINT
                    PRINT "***** DIFFERENT PAGE SIZE *****"
                  ELSE
                    nfil$(nfil%) = ifil$
                    nfil% = nfil% + 1
                  END IF
                END IF
              END IF
            END IF
            CLOSE #ff%
          END IF
        WEND
END FUNCTION

SUB getscl
        DIM f AS fdrvT
        COLOR 7, 0
        f = fdrv
        b% = 0
        WHILE b% = 0
          CLS
          a$ = "SCALE MULTIPLIER INPUT"
          LOCATE 1, .5 * (79 - LEN(a$))
          PRINT a$
          PRINT
          PRINT "X scale limits: 0 to "; f.maxscl.x
          PRINT "Y scale limits: 0 to "; f.maxscl.y
          INPUT "insert x and y scale factors: "; x, y
          IF x > 0 AND y > 0 AND x <= f.maxscl.x AND y <= f.maxscl.y THEN
            b% = -1
            f.sclmul.x = x
            f.sclmul.y = y
          ELSE
           PRINT
           PRINT "Your entry was "; x, y
           PRINT "Press any key to try again"
           a$ = waitkey$
          END IF
        WEND
        fdrv = f
END SUB

SUB getswin
        DIM f AS fdrvT
        DIM r AS RectT, w AS RectT
        COLOR 7, 0
        f = fdrv
        w = f.win
        b% = 0
        WHILE b% = 0
          CLS
          a$ = "WINDOW INPUT"
          LOCATE 1, .5 * (79 - LEN(a$))
          PRINT a$
          PRINT
          PRINT "X window limits: "; w.l, w.r
          PRINT "Y window limits: "; w.b, w.t
          INPUT "insert left, right, base and top: "; r.l, r.r, r.b, r.t
          IF IsRect%(r) AND InRect%(r, w) THEN
            b% = -1
            f.win = r
            f.wins = -1
          ELSE
           PRINT
           PRINT "Your entry was "; r.l, r.r, r.b, r.t
           PRINT "Press any key to try again"
           a$ = waitkey$
          END IF
        WEND
        fdrv = f
END SUB

SUB getvp
        DIM f AS fdrvT
        DIM p AS PipeT
        DIM r AS RectT, v AS RectT
        DIM vv  AS RectT
        COLOR 7, 0
        f = fdrv
        r = odev.scr
        IF f.rot THEN CALL rotrect(r)
        CALL GetWsPipe(p)
        r.l = r.l / p.upi.x
        r.b = r.b / p.upi.y
        r.r = r.r / p.upi.x
        r.t = r.t / p.upi.y
        b% = 0
        WHILE b% = 0
          CLS
          a$ = "VIEWPORT INPUT"
          LOCATE 1, .5 * (79 - LEN(a$))
          PRINT a$
          PRINT
          PRINT "X viewport limits: "; r.l, r.r
          PRINT "Y viewport limits: "; r.b, r.t
          INPUT "insert left, right, base and top: "; vv.l, vv.r, vv.b, vv.t
          IF IsRect%(vv) AND InRect%(vv, r) THEN
            b% = -1
            f.vp.l = vv.l * p.upi.x
            f.vp.r = vv.r * p.upi.x
            f.vp.b = vv.b * p.upi.y
            f.vp.t = vv.t * p.upi.y
            f.vps = -1
          ELSE
           PRINT
           PRINT "Your entry was "; vv.l, vv.r, vv.b, vv.t
           PRINT "Press any key to try again"
           a$ = waitkey$
          END IF
        WEND
        fdrv = f
     
END SUB

SUB header
'subroutine to print program identifier for fildrv progs
        DIM tmp$(18)
        FOR i% = 0 TO 18
          tmp$(i%) = ""
        NEXT i%
        SCREEN inpdev.txscr
        CALL setpal
        CLS
        KEY OFF
        tmp$(1) = "JKPLOT"
        tmp$(2) = "BASIC PLOTTING SYSTEM"
        tmp$(4) = "--------------------------"
        tmp$(5) = "file-reading device driver-version 3.00"
        tmp$(6) = "--------------------------"
        tmp$(8) = "BY"
        tmp$(10) = "John O. Kork"
        tmp$(11) = "Branch of Resource Analysis"
        tmp$(12) = "U. S. Geologic Survey"
        tmp$(13) = "Mail Stop 937"
        tmp$(14) = "Denver Federal Center"
        tmp$(15) = "Denver, Colorado  80225"
        tmp$(16) = "---------------------------------------"
        tmp$(18) = "PRESS ANY KEY TO START PROGRAM"
        FOR i% = 1 TO 18
          LOCATE 2 + i%, .5 * (79 - LEN(tmp$(i%)))
          PRINT tmp$(i%)
        NEXT i%
        a$ = waitkey$
END SUB

FUNCTION mainmn% (plin%)
'main menu definition
        DIM lin$(5)
        lin$(1) = "File name input/change"
        lin$(2) = "Go to plot option menu"
        lin$(3) = "Change output device"
        lin$(4) = "Execute a DOS command"
        lin$(5) = "Exit to system"
        b% = 0
        WHILE b% = 0
          CLS
          a$ = "MAIN MENU CHOICES"
          LOCATE 1, .5 * (79 - LEN(a$))
          PRINT a$
          PRINT
          FOR i% = 1 TO 5
            PRINT i%; ")  "; lin$(i%)
          NEXT i%
          PRINT
          INPUT "Insert choice (1-5): "; a%
          IF a% >= 1 AND a% <= 5 THEN
            b% = a%
          ELSE
           PRINT
           PRINT "Your entry was "; a%
           PRINT "Press any key to try again"
           a$ = waitkey$
          END IF
        WEND
        mainmn% = b%
END FUNCTION

FUNCTION odevmn% (dv%, nfil$(), prmt$(), flnm%(), clrmap%())
'select output device
        DIM lin$(nodev% + 1)
        dvh% = dv%
        dvm% = 1
        FOR i% = 0 TO nodev% - 1
          lin$(i% + 1) = dvlst$(i%)
        NEXT i%
        dvm% = dv%
        lin$(nodev% + 1) = "Return to main menu"
        b% = 0
        WHILE b% = 0
          CLS
          a$ = "DEVICE SELECTION MENU"
          LOCATE 1, .5 * (79 - LEN(a$))
          PRINT a$
          PRINT
          FOR i% = 1 TO nodev% + 1
            a$ = LTRIM$(RTRIM$(STR$(i%)))
            IF i% < 10 THEN a$ = a$ + " "
            a$ = a$ + ")  " + lin$(i%)
            PRINT a$
          NEXT i%
          PRINT
          INPUT "Insert choice: "; a%
          IF a% > 0 AND a% <= nodev% + 1 THEN
            IF a% = nodev% + 1 THEN
              b% = dvh%
            ELSE
              b% = dvlst%(a% - 1)
            END IF
          ELSE
           PRINT
           PRINT "Your entry was "; a%
           PRINT "Press any key to try again"
           a$ = waitkey$
          END IF
        WEND
        IF a% <= 0 OR a% = nodev% + 1 THEN
          a% = dvh%
        END IF
'get plot file name 
        IF dvlst%(a% - 1) = HPFIL OR dvlst%(a% - 1) = JKFIL OR dvlst%(a% - 1) = LSFIL THEN
          filok% = 0
          WHILE NOT filok%
            PRINT
            ifil$ = ""
            WHILE ifil$ = ""
              INPUT "Insert plot output file name: "; ifil$
              IF ifil$ = "" THEN
                PRINT
                PRINT "***** YOU INSERTED A BLANK FILE NAME - TRY AGAIN."
              END IF
            WEND
            filok% = -1
            ON ERROR GOTO filerr
            filerrn% = 0
            ff% = FREEFILE
            OPEN "i", #ff%, ifil$
            ON ERROR GOTO 0
            CLOSE #ff
            IF NOT filerrn% THEN
              PRINT
              y$ = ""
              WHILE (UCASE$(y$) <> "Y" AND UCASE$(y$) <> "N")
                PRINT "***** FILE " + ifil$ + " EXISTS *****"
                INPUT "***** DO YOU WANT TO OVERWRITE IT? (Y/N): "; y$
                IF y$ <> "" THEN y$ = LEFT$(y$, 1)
                IF (UCASE$(y$) <> "Y" AND UCASE$(y$) <> "N") THEN
                  PRINT
                  PRINT "***** YOU INSERTED "; y$
                  PRINT "***** PLEASE INSERT Y OR N"
                END IF
              WEND
              IF UCASE$(y$) = "N" THEN filok% = 0
            END IF
          WEND
          noff% = 10 - (dvlst%(a% - 1) = JKFIL) - 2 * (dvlst%(a% - 1) = LSFIL)
          nfil$(noff%) = ifil$
          CALL SetFnam(dvlst%(a% - 1), nfil$(noff%))
        END IF
        odevmn% = b%
END FUNCTION

FUNCTION optinp%
'function to set plotting options
'returns        1 for plot
'               2 for return to main menu
'get keyboard char for task
        DIM elin$(3)
        DIM r AS RectT
        qt% = 0
        WHILE qt% = 0
          a$ = waitkey$
          c% = ((INSTR("LCURETFIBWSVPQlcuretfibwsvpq", a$) - 1) MOD 14) + 1
          fdrv.drw = 0  'set for no recalc or redraw
          SELECT CASE c%
            CASE 1                'center
              fdrv.centr = 0
              IF st.clpcen THEN fdrv.drw = 2
            CASE 2
              fdrv.centr = -1
              IF NOT st.clpcen THEN fdrv.drw = 2
            CASE 3                'rotate
              fdrv.rot = 0
              IF st.picrot THEN fdrv.drw = 3
            CASE 4
              fdrv.rot = -1
              IF NOT st.picrot THEN fdrv.drw = 3
            CASE 5                'aspect preserved on
              IF fdrv.aspoff THEN fdrv.drw = 4
              fdrv.aspoff = 0
            CASE 6                'fill viewport
              IF NOT fdrv.aspoff THEN fdrv.drw = 4
              fdrv.aspoff = -1
              fdrv.sclmul.x = 1
              fdrv.sclmul.y = 1
            CASE 7                'scale
              IF fdrv.scl THEN
                fdrv.scl = 0
                fdrv.drw = 5
                fdrv.sclmul.x = 1
                fdrv.sclmul.y = 1
              END IF
            CASE 8
              fdrv.scl = -1
              fdrv.drw = 1
              getscl
            CASE 9                'window
              IF fdrv.wins THEN
                fdrv.wins = 0
                fdrv.win.l = 0
                fdrv.win.r = xpage
                fdrv.win.b = 0
                fdrv.win.t = ypage
                fdrv.drw = 6
              END IF
            CASE 10
              fdrv.drw = 1
              getswin
            CASE 11               'viewport
              IF fdrv.vps THEN
                fdrv.vps = 0
                r = odev.scr
                IF fdrv.rot THEN CALL rotrect(r)
                fdrv.vp = r
                fdrv.drw = 7
              END IF
            CASE 12
              fdrv.drw = 1
              getvp
            CASE 13
              'plot
              qt% = 1
            CASE 14
            'quit
              qt% = 2
            CASE ELSE
              BEEP
          END SELECT
      
          IF fdrv.drw <> 0 THEN
            SCREEN inpdev.txscr
            CALL setpal
            CALL dprmscrn(fdrv, xpage, ypage)
          END IF
        WEND
        optinp% = qt%
END FUNCTION

FUNCTION plotem% (nfil%, nfil$(), ppen%())
'function to loop through plot files and do plotting
'returns 0 if no error
'       -1 if error
'       +1 if warning
'uses precalc plots call
        DIM f AS fdrvT
        DIM elin$(4), cmat(4, 4)
        DIM r3d(4, 4), g3d(3, 3), tmt(2, 3)
        DIM rct1 AS RectT, rct2 AS RectT, rct3 AS RectT
        ret% = 0
'loop through plot files
        COLOR WHITE, BLACK
        CLS
        ffile% = FREEFILE
        FOR in% = 1 TO nfil%
          OPEN "I", #ffile%, nfil$(in% - 1)
          ln = 1
          INPUT #ffile%, QTA$
          IF QTA$ = "PLOTS" THEN
            IF in% <> 1 THEN st.wsuclr = -1 ELSE st.wsuclr = 0
            INPUT #ffile%, xpage, ypage
            f = fdrv
            pserr% = precalc%(f, 0)
            fdrv = f
            CALL Newpen(ppen%(in% - 1))
            IF pserr% > 0 THEN
              CLS
              elin$(1) = "ERROR RETURN ON INITIATION"
              elin$(2) = "Error number " + STR$(tkerr%)
              elin$(3) = "Press any key to return to menu"
              FOR i% = 1 TO 3
                LOCATE 3 + i%, .5 * (79 - LEN(elin$(i%)))
                PRINT elin$(i%)
              NEXT i%
              a$ = waitkey$
              in% = nfil% + 1     'to exit loop
              ret% = -1
            ELSE
              IF LEFT$(odev.id, 2) <> "PC" THEN
                LOCATE 1, 1: PRINT SPACE$(78);
                LOCATE 1, 1: PRINT "PLOTTING FILE NO "; in%, nfil$(in% - 1);
              END IF
              a$ = ""
              IF st.inch AND inchwarn% AND in% = 1 THEN
                elin$(1) = "PLOT TOO BIG FOR FULL SCALE ON DEVICE"
                elin$(2) = "Press Q to return to menu"
                elin$(3) = "Press any other key to continue rescaled"
                CLS
                FOR i% = 1 TO 3
                  LOCATE 3 + i%, .5 * (79 - LEN(elin$(i%)))
                  PRINT elin$(i%)
                NEXT i%
                a$ = waitkey$
              END IF
              IF UCASE$(a$) <> "Q" THEN
                pserr% = 0
                qt% = 0
                DO
'check for terminating plot early
                  a$ = INKEY$
                  IF UCASE$(a$) <> "Q" THEN
                    ln = ln + 1
                    IF EOF(ffile%) THEN
                      elin$(1) = "ERROR - END OF PLOT FILE"
                      elin$(2) = ""
                      elin$(3) = "Press any key to return to menu"
                      CLS
                      FOR i% = 1 TO 3
                        LOCATE 3 + i%, .5 * (79 - LEN(elin$(i%)))
                        PRINT elin$(i%)
                      NEXT i%
                      a$ = waitkey$
                      qt% = -1
                      ret% = -1
                    ELSE
                      IF NOT pserr% THEN
                        INPUT #ffile%, QTA$
                        SELECT CASE QTA$
                          CASE "PLOT"
                            IF in% = nfil% THEN
                              st.nopicend = 0
                            ELSE
                              st.nopicend = -1
                            END IF
                            INPUT #ffile%, tkxp, tkyp, tkip%
                            IF tkip% = 999 AND LEFT$(odev.id, 2) <> "PC" THEN
                              LOCATE 1, 1: PRINT SPACE$(78);
                            END IF
                            CALL Plot(tkxp, tkyp, tkip%)
                            IF tkip% = 999 THEN qt% = -1
'for compatibility with version 1
                          CASE "SYMBOL"
                            INPUT #ffile%, tkch%
                            IF tkch% >= 0 THEN
                              INPUT #ffile%, x, y, ht, angle
                              LINE INPUT #ffile%, txt$
                              CALL Symbol(x, y, ht, txt$, angle)
                            ELSE
                              INPUT #ffile%, x, y, ht, q%, angle
                              IF tkch% = -1 THEN
                                penup% = -1
                              ELSE
                                penup% = 0
                              END IF
                              CALL Csymbol(x, y, ht, q%, angle, penup%)
                            END IF
                          CASE "COMMENT"
                            LINE INPUT #ffile%, txt$
                            CALL Comment(1, 1, LEN(txt$), txt$)
                          CASE "SSYMBOL"
                            INPUT #ffile%, x, y, ht, angle
                            LINE INPUT #ffile%, txt$
                            CALL Symbol(x!, y!, ht!, txt$, angle!)
                          CASE "CSYMBOL"
                            INPUT #ffile%, x, y, ht, q%, angle, penup%
                            CALL Csymbol(x!, y!, ht!, q%, angle!, penup%)
                          CASE "NUMBER"
                            INPUT #ffile%, x, y, ht, fpn, angle, ndec%
                            CALL Number(x, y, ht, fpn, angle, ndec%)
'for compatibility with version 1
                          CASE "LINE", "POLYLINE"
                            IF QTA$ = "LINE" THEN
                              INPUT #ffile%, npts%, lintp%, q%, ht
                              inc% = ABS(lintp%)
                            ELSE
                              INPUT #ffile%, npts%, inc%, lintp%, q%, ht
                            END IF
                            IF inc% = 0 THEN inc% = 1
                            qtlpts% = npts%
                            qtsti% = 1
                            tmp% = 200
                            DIM xary(tmp%), yary(tmp%)
                            WHILE qtlpts% >= 0
                              IF qtlpts% + qtsti% - 1 <= 200 THEN
                                npts% = qtlpts% + qtsti% - 1
                              ELSE
                                npts% = 200
                              END IF
                              qtlpts% = qtlpts% - 200 + qtsti% - 1
                              FOR qti% = qtsti% TO npts%
                                INPUT #ffile%, xary(qti%), yary(qti%)
                              NEXT qti%
                              CALL PolyLine(xary(), yary(), npts%, inc%, lintp%, q%, ht)
                              qtsti% = 2
                              xary(1) = xary(200)
                              yary(1) = yary(200)
                            WEND
                            ERASE xary
                            ERASE yary
                          CASE "FACTOR"
                            INPUT #ffile%, fact
                            CALL Factor(fact)
                          CASE "NEWPEN"
                            INPUT #ffile%, pn%
                            CALL Newpen(pn%)
                          CASE "NCOMMENT"
                            INPUT #ffile%, row%, col%, llen%
                            LINE INPUT #ffile%, txt$
                            CALL Comment(row%, col%, llen%, txt$)
                          CASE "NEWFONT"
                            INPUT #ffile%, ff%
                            CALL newfont(ff%)
                          CASE "NEWCFONT"
                            INPUT #ffile%, ff%
                            CALL newcfont(ff%)
                          CASE "SETWSWIN"
                            INPUT #ffile%, l, r, b, t
                            a% = SetWsWin%(l, r, b, t)
                          CASE "SETWSVP"
                            INPUT #ffile%, l, r, b, t
                            a% = SetWsVp%(l, r, b, t)
                          CASE "SETWCWIN"
                            INPUT #ffile%, l, r, b, t
                            a% = SetWcWin%(l, r, b, t)
                          CASE "SETWCVP"
                            INPUT #ffile%, l, r, b, t
                            a% = SetWcVp%(l, r, b, t)
                          CASE "SETTRN2"
                            INPUT #ffile%, wch$
                            CALL ReadMat(ffile%, 4, 4, cmat())
                            CALL SetTrn2(wch$, cmat())
                          CASE "ACMTRN2"
                            INPUT #ffile%, wch$
                            CALL ReadMat(ffile%, 4, 4, cmat())
                            CALL AcmTrn2(wch$, cmat())
                          CASE "RESETCLIP"
                            INPUT #ffile%, wch$
                            a% = ResetClip%(wch$)
                          CASE "SETCLIP"
                            INPUT #ffile%, wch$, l, r, b, t
                            a% = SetClip%(wch$, l, r, b, t)
                          CASE "AUTOPLT"
                            INPUT #ffile%, xpage, ypage, xmin, xmax
                            INPUT #ffile%, ymin, ymax
                            a% = autoplt%(xpage, ypage, xmin, xmax, ymin, ymax, errmsg$)
                          CASE "AXIS2"
                            INPUT #ffile%, xpage, ypage, xmin, xmax
                            INPUT #ffile%, ymin, ymax, calconly%
                            a% = axis2%(xpage, ypage, xmin, xmax, ymin, ymax, calconly%, errmsg$)
                          CASE "EQPLT"
                            INPUT #ffile%, ind$
                            CALL eqplt(ind$)
                          CASE "FRAME"
                            CALL frame
                          CASE "GRID"
                            INPUT #ffile%, xgrd%, ygrd%
                            CALL grid(xgrd%, ygrd%)
                          CASE "NODRAW"
                            INPUT #ffile%, x$, y$
                            CALL nodraw(x$, y$)
                          CASE "NOEND"
                            INPUT #ffile%, x$, y$
                            CALL noend(x$, y$)
                          CASE "NOFRST"
                            INPUT #ffile%, x$, y$
                            CALL nofrst(x$, y$)
                          CASE "NOLAB"
                            INPUT #ffile%, x$, y$
                            CALL nolab(x$, y$)
                          CASE "NOLAST"
                            INPUT #ffile%, x$, y$
                            CALL nolast(x$, y$)
                          CASE "NONUM"
                            INPUT #ffile%, x$, y$
                            CALL nonum(x$, y$)
                          CASE "RESETAXES"
                            CALL ResetAxes
                          CASE "SCSYMBOL"
                            INPUT #ffile%, x, y, ht, q%, angle, penup%
                            CALL scsymbol(x!, y!, ht!, q%, angle!, penup%)
                          CASE "SETAXES"
                            INPUT #ffile%, xtyp, xorig, xstep, xend
                            INPUT #ffile%, ytyp, yorig, ystep, yend
                            CALL SetAxes(xtyp, xorig, xstep, xend, ytyp, yorig, ystep, yend)
                          CASE "SETAXHT2"
                            INPUT #ffile%, xht, yht
                            CALL SetAxht2(xht, yht)
                          CASE "SETAXIS"
                            INPUT #ffile%, wch$, atyp, aorig, astep, aend
                            INPUT #ffile%, alen, aside%, xpos, ypos
                            LINE INPUT #ffile%, alab$
                            CALL SetAxis(wch$, atyp, aorig, astep, aend, alen, alab$, aside%, xpos, ypos)
                          CASE "SETAXPG"
                            INPUT #ffile%, xpage, ypage, xlen, ylen
                            LINE INPUT #ffile%, tit$
                            LINE INPUT #ffile%, xlab$
                            LINE INPUT #ffile%, ylab$
                            CALL SetAxpg(xpage, ypage, tit$, xlab$, ylab$, xlen, ylen)
                          CASE "SNUMBER"
                            INPUT #ffile%, x, y, ht, fpn, angle, ndec%
                            CALL sNumber(x, y, ht, fpn, angle, ndec%)
                          CASE "SPLOT"
                            INPUT #ffile%, x, y, p%
                            CALL splot(x, y, p%)
                          CASE "SPOLYLINE"
                            INPUT #ffile%, npts%, inc%, lintyp%, tkiq%, ht
                            DIM xary(npts%), yary(npts%)
                            FOR i% = 1 TO npts%
                              INPUT #ffile%, xary(i%), yary(i%)
                            NEXT i%
                            CALL spolyline(xary(), yary(), npts%, inc%, lintyp%, tkiq%, ht)
                            ERASE xary
                            ERASE yary
                          CASE "SSSYMBOL"
                            INPUT #ffile%, x, y, ht, angle
                            LINE INPUT #ffile%, txt$
                            CALL ssymbol(x!, y!, ht!, txt$, angle!)
                          CASE "XTICKS"
                            INPUT #ffile%, n%
                            CALL xticks(n%)
                          CASE "YTICKS"
                            INPUT #ffile%, n%
                            CALL yticks(n%)
                          CASE "AUTOFRAME"
                            INPUT #ffile%, xpage, ypage
                            LINE INPUT #ffile%, ttl1$
                            LINE INPUT #ffile%, ttl2$
                            CALL autoframe(xpage, ypage, ttl1$, ttl2$)
                          CASE "BGN3D"
                            CALL Bgn3d
                          CASE "END3D"
                            CALL end3d
                          CASE "PLATE3D"
                            INPUT #ffile%, xpage, ypage, gam, bet
                            LINE INPUT #ffile%, ttl1$
                            LINE INPUT #ffile%, ttl2$
                            CALL plate3d(xpage, ypage, gam, bet, ttl1$, ttl2$)
                          CASE "RESETUVWIN"
                            CALL Resetuvwin
                          CASE "SCL3D2D"
                            CALL Scl3d2d
                          CASE "SETVP3D"
                            INPUT #ffile%, l, r, b, t
                            CALL setvp3d(l, r, b, t)
                          CASE "SETWKBOX"
                            INPUT #ffile%, x, y, z
                            CALL setwkbox(x, y, z)
                          CASE "VUABS"
                            INPUT #ffile%, x, y, z
                            CALL vuabs(x, y, z)
                          CASE "VUANG"
                            INPUT #ffile%, hang, vang, zper
                            CALL vuang(hang, vang, zper)
                          CASE "SETCOP"
                            INPUT #ffile%, x, y, z
                            CALL setcop(x, y, z)
                          CASE "SETCPN"
                            INPUT #ffile%, x, y
                            CALL setcpn(x, y)
                          CASE "SETUVWIN"
                            INPUT #ffile%, l, r, b, t, ff, bk
                            CALL setuvwin(l, r, b, t, ff, bk)
                          CASE "SETVPN"
                            INPUT #ffile%, x, y, z
                            CALL setvpn(x, y, z)
                          CASE "SETVRP"
                            INPUT #ffile%, x, y, z
                            CALL setvrp(x, y, z)
                          CASE "SETVUP"
                            INPUT #ffile%, x, y, z
                            CALL setvup(x, y, z)
                          CASE "DRAWUVWIN"
                            CALL drawuvwin
                          CASE "DRAWWKBOX"
                            CALL drawwkbox
                          CASE "DRAWBOX"
                            INPUT #ffile%, xl, xu, yl, yu, zl, zu
                            CALL drawbox(xl, xu, yl, yu, zl, zu)
                          CASE "CSYMBOL3D"
                            INPUT #ffile%, x, y, z, ht, q%, angle, icode%
                            CALL Csymbol3D(x, y, z, ht, q%, angle, icode%)
                          CASE "SYMBOL3D"
                            INPUT #ffile%, x, y, z, ht, angle
                            LINE INPUT #ffile%, txt$
                            CALL Symbol3D(x, y, z, ht, txt$, angle)
                          CASE "POLYLINE3D"
                            INPUT #ffile%, npts%, inc%, lintyp%, tkiq%, ht
                            DIM xary(npts%), yary(npts%), zary(npts%)
                            FOR i% = 1 TO npts%
                              INPUT #ffile%, xary(i%), yary(i%), zary(i%)
                            NEXT i%
                            CALL PolyLine3D(xary(), yary(), zary(), npts%, inc%, lintyp%, tkiq%, ht)
                            ERASE xary
                            ERASE yary
                            ERASE zary
                          CASE "PLOT3D"
                            INPUT #ffile%, x, y, z, p%
                            CALL Plot3D(x, y, z, p%)
                          CASE "NODRAW3D"
                            INPUT #ffile%, x$, y$, z$
                            CALL nodraw3d(x$, y$, z$)
                          CASE "SETAXES3D"
                            INPUT #ffile%, xt, xs, xp, xe, yt, ys, yp, ye
                            INPUT #ffile%, zt, zs, zp, ze, nd%
                            CALL setaxes3d(xt, xs, xp, xe, yt, ys, yp, ye, zt, zs, zp, ze, nd%)
                          CASE "SETAXHT3"
                            INPUT #ffile%, xh, yh, zh
                            CALL SetAxht3(xy, yh, zh)
                          CASE "SETAXPG3D"
                            INPUT #ffile%, x3ax, y3ax, z3ax
                            LINE INPUT #ffile%, x3l$
                            LINE INPUT #ffile%, y3l$
                            LINE INPUT #ffile%, z3l$
                            CALL SetAxpg3d(x3l$, x3ax, y3l$, y3ax, z3l$, z3ax)
                          CASE "SPLOT3D"
                            INPUT #ffile%, x, y, z, p%
                            CALL splot3d(x, y, z, p%)
                          CASE "SPOLYLINE3D"
                            INPUT #ffile%, npts%, inc%, lintyp%, tkiq%, ht
                            DIM xary(npts%), yary(npts%), zary(npts%)
                            FOR i% = 1 TO npts%
                              INPUT #ffile%, xary(i%), yary(i%), zary(i%)
                            NEXT i%
                            CALL spoly3d(xary(), yary(), zary(), npts%, inc%, lintyp%, tkiq%, ht)
                            ERASE xary
                            ERASE yary
                            ERASE zary
                          CASE "STRGRAFITI"
                            INPUT #ffile%, x1, y1, z1
                            INPUT #ffile%, x2, y2, z2
                            INPUT #ffile%, x3, y3, z3
                            CALL strgrafiti(x1, y1, z1, x2, y2, z2, x3, y3, z3)
                          CASE "ENDGRAFITI"
                            CALL endgrafiti
                          CASE ELSE
                            elin$(1) = "ERROR IN PLOT FILE " + nfil$(in% - 1)
                            elin$(2) = "Line " + STR$(ln)
                            elin$(3) = "Instruction is " + QTA$
                            elin$(4) = "Press any key to return to menu"
                            FOR i% = 1 TO 4
                              PRINT elin$(i%)
                            NEXT i%
                            a$ = waitkey$
                            CALL CloseWs(fdrv.odevp)
                            in% = nfil% + 1
                            qt% = -1
                            ret% = -1
                        END SELECT
                      END IF
                    END IF
                  ELSE
                    CALL Plot(tkxp, tkyp, 999)
                    CALL CloseWs(fdrv.odevp)
                    in% = nfil% + 1
                    qt% = -1
                  END IF
                LOOP WHILE NOT qt%
              ELSE
                CALL CloseWs(fdrv.odevp)
                in% = nfil% + 1
              END IF
            END IF
          ELSE
            elin$(1) = "ERROR IN PLOT FILE " + nfil$(in% - 1)
            elin$(2) = "no PLOTS"
            elin$(3) = "Press any key to return to menu"
            CLS
            FOR i% = 1 TO 3
              LOCATE 3 + i%, .5 * (79 - LEN(elin$(i%)))
              PRINT elin$(i%)
            NEXT i%
            a$ = waitkey$
          END IF
          CLOSE #ffile%
        NEXT in%
        plotem% = ret%
END FUNCTION

FUNCTION precalc% (f AS fdrvT, clconly%)
'subroutine to call set up prms for pltsys setup call
'  returns tkerr%
DIM pp AS PipeT, tdev AS RectT
'reinitialize plot system (possible new device)
        tscl = f.scl
        tmp% = st.wsuclr
        tdev = odev.scr
        a% = DevOpen%(f.odevp)
        st.wsuclr = tmp%
'plot centering
        st.clpcen = f.centr
'plot rotation
        IF f.rot <> f.rotd THEN
          f.rotd = NOT f.rotd
          CALL rotrect(f.fvp)
          CALL rotrect(f.vp)
          SWAP f.fupi.x, f.fupi.y
          f.fasp = 1 / f.fasp
        END IF
'calculate max allowable scale factor
        IF odev.inch THEN
          f.maxscl.x = (f.vp.r - f.vp.l) / (f.fupi.x * (f.win.r - f.win.l))
          f.maxscl.y = (f.vp.t - f.vp.b) / (f.fupi.y * (f.win.t - f.win.b))
          IF NOT f.aspoff THEN
            IF f.maxscl.x <= f.maxscl.y THEN
              f.maxscl.y = f.maxscl.x
            ELSE
              f.maxscl.x = f.maxscl.y
            END IF
          END IF
        ELSE
          f.maxscl.x = 1
          f.maxscl.y = 1
        END IF
        f.dfscl.x = fnmin(1, f.maxscl.x)
        f.dfscl.y = fnmin(1, f.maxscl.y)
'is sclmul <= f.maxscl
        IF NOT tscl THEN f.sclmul = f.maxscl
        IF f.sclmul.x > f.maxscl.x THEN f.sclmul.x = f.maxscl.x 'never allowed > max
        IF f.sclmul.y > f.maxscl.y THEN f.sclmul.y = f.maxscl.y
        IF (f.sclmul.x <> 1 OR f.sclmul.y <> 1) OR f.scl THEN
          st.uscl = -1
          tscl = -1
        ELSE
          st.uscl = 0
        END IF
        st.sclmul = f.sclmul
        st.noeqasp = f.aspoff
'call pltsys and save info
        IF f.odevp = JKFIL OR f.odevp = HPFIL THEN
          IF IsRect%(tdev) THEN odev.scr = tdev
          f.vps = -1
          f.wins = -1
          tscl = -1
        END IF
        st.picrot = f.rot
        st.clconly = clconly%
        IF f.odevp = JKFIL THEN
          xo = f.fvp.r
          yo = f.fvp.t
          IF f.rotd THEN SWAP xo, yo
        ELSE
          xo = xpage
          yo = ypage
        END IF
        CALL Plots(xo, yo, f.odevp, tkerr%)
'check for clipping window
        IF tscl THEN
          st.inch = odev.inch
        ELSE
          st.inch = 0
        END IF
        IF f.wins THEN
          a% = SetWsWin%(f.win.l, f.win.r, f.win.b, f.win.t)
        END IF
        a% = SetWsVp%(f.vp.l, f.vp.r, f.vp.b, f.vp.t)
        precalc% = tkerr%
END FUNCTION

SUB ReadMat (f%, r%, c%, mat())
        FOR i% = 1 TO r%
          FOR j% = 1 TO c%
            INPUT #f%, mat(i%, j%)
          NEXT j%
        NEXT i%
END SUB

SUB reclc (ir AS RectT, oset AS ipointT, scl AS PointT, rw AS RectT, otr AS irectT)
        otr.l = INT(oset.x + scl.x * (ir.l - rw.l))
        otr.r = INT(oset.x + scl.x * (ir.r - rw.l))
        otr.b = INT(oset.y + scl.y * (ir.b - rw.b))
        otr.t = INT(oset.y + scl.y * (ir.t - rw.b))
END SUB

SUB setpal
        ON ERROR GOTO palerr
        PALETTE USING lpal&(0)
        ON ERROR GOTO 0
END SUB

FUNCTION waitkey$
hld:    a$ = INKEY$: IF a$ = "" GOTO hld
        waitkey$ = a$
END FUNCTION

