'program to generate figure 1, table of standard symbols for JKPLOT system
'file output is four plot files named fig1pgX.plt, where X takes on the
'values 1-4, specifying the page of the figure
' $INCLUDE: 'jk2dplt.inc'
DECLARE SUB cplt (xl!, xu!, y!, t$, ht!, ang!)
DATA "ASCII","MAP","SIMPLEX","DUPLEX","TRIPLEX","ITALIC","SCRIPT","GREEK","SPECIAL"
DIM lbl$(8), ftt$(8)
'use this devno% for screen output
        devno% = VideoHardware%
'use this devno% for plot file output
'        devno% = JKFIL
'read the character header labels
        FOR i% = 0 TO 8
          READ lbl$(i%)
        NEXT i%
'construct the numberic header labels
        FOR i% = 0 TO 8
          a$ = LTRIM$(RTRIM$(STR$(i% - 1)))
          ftt$(i%) = a$
        NEXT i%
        ftt$(0) = ""
'set the page size and output device (to JKPLOT intermediate plot file)
        xpage = 8
        ypage = 9
'set up the loop for the four pages
      FOR pg% = 1 TO 4
'set up the starting ascii value for the page
        stasc% = 32 + 24 * (pg% - 1)
'construct the output file name for the page
        a$ = LTRIM$(RTRIM$(STR$(pg%)))
        ofil$ = "fig1pg" + a$ + ".plt"
'send the output file name to the plot system
        CALL SetFnam(JKFIL, ofil$)
'initiate the plot for the pg%-th page
        CALL Plots(xpage, ypage, devno%, terr%)
'draw page outline
        CALL Plot(0, 0, 3)
        CALL Plot(xpage, 0, 2)
        CALL Plot(xpage, ypage, 2)
        CALL Plot(0, ypage, 2)
        CALL Plot(0, 0, 2)
'plot the character header
        xl = 0
        xinc = xpage / 9
        y = ypage - .4
        ht = .1
        FOR i% = 0 TO 8
          xu = xl + xinc
          CALL cplt(xl, xu, y, lbl$(i%), ht, 0)
          xl = xu
        NEXT i%
'plot the numeric header label and draw a line beneath it
        xl = 0
        xinc = xpage / 9
        y = ypage - .7
        ht = .1
        FOR i% = 0 TO 8
          xu = xl + xinc
          CALL cplt(xl, xu, y, ftt$(i%), ht, 0)
          xl = xu
        NEXT i%
        CALL Plot(0, ypage - .8, 3)
        CALL Plot(xpage, ypage - .8, 2)
'draw the column of ascii numbers
        ht = .1
        y = ypage - 1.1
        yinc = -.3
        xl = 0
        xinc = xpage / 9
        xu = xl + xinc
        FOR i% = stasc% TO stasc% + 23
          y = y + yinc
          a$ = LTRIM$(RTRIM$(STR$(i%)))
          IF LEN(a$) < 2 THEN a$ = " " + a$
          CALL cplt(xl, xu, y, a$, ht, 0)
        NEXT i%
'loop through the fonts for the next 8 columns
        ht = .15
        FOR ff% = 0 TO 7
          CALL newfont(ff%)
          xl = xu
          xu = xl + xinc
          y = ypage - 1.1
          yinc = -.3
          FOR i% = stasc% TO stasc% + 23
            y = y + yinc
            a$ = CHR$(i%)
            CALL cplt(xl, xu, y, a$, ht, 0)
          NEXT i%
        NEXT ff%
'terminate the plot for the page
        CALL Plot(0, 0, 999)
      NEXT pg%
      SYSTEM
        END

SUB cplt (xl, xu, y, t$, ht, ang)
'subroutine to plot a symbol in the center of a rectangle
        x = .5 * (xl + xu) - .5 * LEN(t$) * ht
        CALL Symbol(x, y, ht, t$, ang)
END SUB

