'program fig27.bas to produce figure 27
' $INCLUDE: 'jk2dplt.inc'
' $INCLUDE: 'jk3dplt.inc'
' $INCLUDE: 'ax2d.inc'
' $INCLUDE: 'Ax3d.inc'
DIM prmx AS AxprmT, prmy AS AxprmT, prmz AS AxprmT
DIM x(10), y(10), z(10), xx(10), z0(10)
'set extra stack space for big program    
        CLEAR , , 2000
'use this devno% for screen output 
        devno% = VideoHardware%
'use this devno% for plot file output
'        devno% = JKFIL
'        CALL SetFnam(JKFIL, "fig27.plt")
'define the 3d curve   
        npts% = 10
        FOR i% = 1 TO 10
          zs = 1.4 * CSNG(i%)
          z(i%) = zs
          ys = zs * zs / 65.33
          y(i%) = ys
          xs = 1.2 + .2 * ys * ys
          x(i%) = 10 ^ xs
          xx(i%) = xs
          z0(i%) = 0
        NEXT i%
'set page size and initialize the 2d plot system    
        xpage = 6.5
        ypage = 8
        CALL Plots(xpage, ypage, devno%, ier%)
'initialize the 3d plot system, specify viewing parameters, and frame    
        CALL Bgn3d
        CALL vuabs(30, -31, 23)
        CALL autoframe(xpage, ypage, "PHASE", "DIAGRAM")
'set the 3d axis page (and thus workbox dimensions) and labels    
        CALL SetAxpg3d("", 7, "PHASE", 3, "AMPLITUDE", 3)
'specify that only the Y and Z axis annotation is to be drawn    
        CALL nodraw3d("ON", "OFF", "OFF")
'change from default height to the labels can be read    
        CALL SetAxht3(.13, .13, .13)
'specify the axis types and limits and draw axes 
'note that because the X axis is not drawn the axes are disconnected
        CALL setaxes3d(3, 10, 3.5, 1000, 1, 0, 1, 3, 1, 0, 3, 15, 0)
'draw the main 3d curve    
        CALL spoly3d(x(), y(), z(), 10, 1, 1, 1, .1)
'draw lines parallel to the z and x axes to each of the line nodes   
'to help with 3d visualization
        FOR i% = 1 TO npts%
          CALL splot3d(x(i%), y(i%), 0, 3)
          CALL splot3d(x(i%), y(i%), z(i%), 2)
          CALL splot3d(10, y(i%), z(i%), 2)
        NEXT i%
'add supplementary annotation for the x axis using grafiti and 
'2d axis commands in the grafiti plane defined by the equation Z=0
'the grafiti XY plane is thus the XY 3d plane also    
        CALL strgrafiti(0, 0, 0, 1, 0, 0, 0, 1, 0)
        CALL ResetAxes
        CALL SetAxht2(.13, .13)
'specify that only the X axis is to be drawn    
        CALL nodraw("OFF", "ON")
        CALL SetAxis("X", 3, 10, 3.5, 1000, 7, "FREQUENCY", 1, 0, 0)
        CALL SetAxis("Y", 1, 0, 1, 3, 3, "", 1, 0, 0)
        CALL frame
'draw the 2d trace of the 3d curve in the plane Z=10    
        CALL spolyline(x(), y(), 10, 1, 1, 2, .15)
'add grid to the plane Z=0    
        CALL nodraw("OFF", "OFF")
        CALL grid(1, 2)
        CALL endgrafiti
'add supplementary annotation for the x axis using grafiti and 
'2d axis commands in the grafiti plane defined by the equation Y=0
'the grafiti XY plane is now the 3d YZ plane    
        CALL strgrafiti(0, 0, 0, 0, 1, 0, 0, 0, 1)
'draw only the grafiti X axis (the 3d Y axis)    
        CALL nodraw("OFF", "ON")
        CALL SetAxht2(.08, .08)
        CALL SetAxis("X", 1, 0, .5, 3, 3, "PHASE", -1, 0, 3)
        CALL SetAxis("Y", 1, 0, 3, 15, 3, "", 1, 0, 0)
        CALL frame
'specify that both axes are to be gridded  
        CALL nodraw("OFF", "OFF")
        CALL grid(1, 1)
'draw the trace of the 3d curve on the plane YZ (Log X = 1)
        CALL spolyline(y(), z(), 10, 1, 1, 3, .15)
'terminate the plot    
        CALL endgrafiti
        CALL end3d
        CALL Plot(0, 0, 999)
        SYSTEM
        END

