ECHO OFF
CLS
ECHO This program is FIG12MAK.BAT, to construct the plot file FIG12.PLT.
ECHO The plot file for figure 12 cannot be generated in the same way
ECHO that the plot files for the other 26 plots can be generated
ECHO because the program FIG12.BAS makes use of special properties
ECHO of the QBJKF.BAS device control module.  The FIG12MAK.BAT program
ECHO copies the necessary files from the directory \JKPLOT\SOURCE,
ECHO compiles them to produce the program FIG12.EXE, executes FIG12.EXE,
ECHO and produces the plot file FIG12.PLT.
ECHO *
ECHO Press Ctrl-Break to abort program, any other key to continue
ECHO *
PAUSE
call setqk
cd \jkplot\batch
if NOT EXIST batloc.xxx goto badfin
if NOT EXIST \jkplot\source\jk2dplt.inc goto badfin
if EXIST jk2dplt.inc goto nocop
copy \jkplot\source\*.inc
copy \jkplot\source\config.*
copy \jkplot\source\jkfont.0
copy \jkplot\source\jkcfont.*
:nocop
copy \jkplot\source\devall.bas
copy \jkplot\source\devmak.bas
copy \jkplot\source\jk2dplt.bas
copy \jkplot\source\qbjkf.bas
copy \jkplot\figprgs\fig12.bas
call qb /run devmak /cmd 0,0,0,0,1
bc fig12 /ah/x/o;
bc jk2dplt.bas /ah/x/o;
bc devk /ah/x/o;
bc qbjkf /ah/x/o;
link fig12+jk2dplt+devk+qbjkf,,,qb.lib;
ECHO *
ECHO Running program fig12.exe now.
ECHO *
call fig12
erase *.obj
erase devall.bas
erase devmak.bas
erase fig12.bas
erase jk2dplt.bas
erase qbjkf.bas
erase devk.bas
erase *.inc
erase jkfont.0
erase jkcfont.0
erase config.*
goto fin
:badfin
CLS
ECHO *
ECHO THE PROGRAM CANNOT FIND THE \JKPLOT\BATCH DIRECTORY.  OTHER
ECHO DIRECTORIES MAY ALSO BE MISSING.  IN ORDER TO RUN THIS BATCH
ECHO JOB YOU MUST HAVE THE DIRECTORY STRUCTURE EXACTLY AS SPECIFIED
ECHO IN APPENDIX I.  BATCH JOB WILL BE SKIPPED.
ECHO *
GOTO out
:fin
CLS
ECHO *
ECHO THE PLOT FILE FOR FIGURE 12 IS NOW IN THE FILE, FIG12.PLT,
ECHO IN THIS DIRECTORY.  TO SEND THE PLOT TO THE SCREEN OR OTHER
ECHO DEVICE YOU CAN COPY THE FILE FIG12.PLT INTO THE DIRECTORY
ECHO \JKPLOT\SOURCE AND EXECUTE THE PROGRAM QF2.EXE.
ECHO *
ECHO Press any key to exit
PAUSE
:out
